''This macro is a online translations macro program for strings
''in Passolo translation list.
''It has the following features:
''- Use the online translation engine automatically translate strings
''  in the Passolo translation list
''- Integrated some of the well-known online translation engines, and
''  you can customize other online translation engines
''- You can choose the string type, skiping some of string, and processing
''  the strings before and after translation
''- Integrated shortcuts, terminators, Accelerator check macro, and you can
''  check and correct errors in translations after the strings has be translated
''2010-2019 Modified by wanfu 2010.05.12 (Last modified on 2019.08.28)

'#Uses ".\Module\modTransCommon.bas"

Option Explicit


' 
Public Sub PSL_OnAutoTranslate(Translations As PslTranslations,ByVal MinMatch As Long,ByVal MaxCount As Long)
	Dim i As Long,j As Long,n As Long,Obj As Object,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String

	'ΪջȫΪոִ
	If Trim(Translations.SourceString) = "" Then Exit Sub

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "WScript.Shell"
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			PSL.Output Err.Description
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "Adodb.Stream"
		Exit Sub
	End If
	Set Obj = Nothing
	' Scripting.Dictionary Ƿ
	Set Obj = CreateObject("Scripting.Dictionary")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "Scripting.Dictionary"
		Exit Sub
	End If
	Set Obj = Nothing
	' MSScriptControl.ScriptControl Ƿ
	Set Obj = CreateObject("MSScriptControl.ScriptControl")
	If Obj Is Nothing Then
		PSL.Output Err.Description & " - " & "MSScriptControl.ScriptControl"
		Exit Sub
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		PSL.Output Err.Description & " - " & "VBScript.RegExp"
		Exit Sub
	End If
	On Error GoTo SysErrorMsg

	'ʼ
	ReDim Tools(3) As TOOLS_PROPERTIE,FileDataList(0) As String
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA
	ReDim tSelected(27) As String,UpdateSet(5) As String,LFList(0) As LOG_FONT
	ReDim DefaultEngineList(3) As String,EngineList(0) As ENGINE_SET,EngineList(0).LangPairList(0) 'As LANG_SET
	ReDim cSelected(26) As String,cUpdateSet(5) As String
	ReDim DefaultCheckList(1) As String,CheckList(0) As CHECK_SET,CheckList(0).LangPairList(0) 'As LANG_SET
	ReDim DefaultProjectList(4) As String,ProjectList(0) As CHECK_PROJECT_SET
	ReDim CheckCountList(6) As Integer,PslLangList(0) As LANG_SET,TrnCountList(3) As Integer

	'ת HEX ֵַΪ Long ʽģ壬תıת
	MsgList = ReSplit(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(MsgList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(MsgList)
		CheckHexStr(i).Range = Replace$(MsgList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
		CheckHexStr(i).AscRange = "[" & Convert(Replace$(MsgList(i),",","")) & "]"
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = ReSplit("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetEngineSet("Option","")

	'ȡִ
	If GetUI(MacroLoc & "\Data\",tSelected(0),OSLanguage,UIDataList,UIFileList,LangFile) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		PSL.Output MsgList(0) & ":" & MsgList(1)
		Exit Sub
	End If

	'Ĭֵ
	TempList = ReSplit(MsgList(4),";")
	DefaultEngineList(0) = TempList(0)
	DefaultEngineList(1) = TempList(1)
	DefaultEngineList(2) = TempList(2)
	DefaultEngineList(3) = TempList(3)
	TempList = ReSplit(MsgList(5),";")
	DefaultCheckList(0) = TempList(0)
	DefaultCheckList(1) = TempList(1)
	TempList = ReSplit(MsgList(6),";")
	DefaultProjectList(0) = TempList(0)
	DefaultProjectList(1) = TempList(1)
	DefaultProjectList(2) = TempList(2)
	DefaultProjectList(3) = TempList(3)
	DefaultProjectList(4) = TempList(4)

	'ȡ
	GetEngineSet("","")
	'ȡִ
	GetCheckSet("","")

	'ֹͣťʱʾԻϵϢ
	StopTitle = MsgList(40)
	StopMsg = MsgList(41)

	'ȡַб
	CodeList = getCodePageList(0,49)

	'鷭
	If UBound(EngineList) >= 0 Then
		If CheckEngineSet(EngineList) = False Then
			n = -1
		Else
			n = UBound(EngineList)
		End If
		For i = 0 To UBound(DefaultEngineList)
			Stemp = False
			For j = 0 To n
				If EngineList(j).Name = DefaultEngineList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve EngineList(n) As ENGINE_SET
				EngineList(n) = DefaultEngineSet(DefaultEngineList(i))
				EngineList(n).Name = DefaultEngineList(i)
				EngineList(n).LangPairList = LangCodeList(DefaultEngineList(i),0,-1)
			End If
		Next i
		If CheckEngineSet(EngineList) = False Then
			PSL.Output MsgList(39) & ":" & MsgList(42)
			Exit Sub
		End If
	End If

	'鷭
	If UBound(CheckList) >= 0 Then
		If CheckCheckSet(CheckList) = False Then
			n = -1
		Else
			n = UBound(CheckList)
		End If
		For i = 0 To UBound(DefaultCheckList)
			Stemp = False
			For j = 0 To n
				If CheckList(j).Name = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve CheckList(n) As CHECK_SET
				CheckList(n) = DefaultCheckSet(DefaultCheckList(i),False)
				CheckList(n).Name = DefaultCheckList(i)
				CheckList(n).LangPairList = LangCodeList(DefaultCheckList(i),1,-1)
			End If
		Next i
		If CheckCheckSet(CheckList) = False Then
			For i = 18 To 24
				If i <> 21 Then tSelected(i) = "0"
			Next i
		End If
	End If
	'鷭鷽
	If UBound(ProjectList) >= 0 Then
		If CheckArray(getSetNameList(ProjectList)) = False Then
			n = -1
		Else
			n = UBound(ProjectList)
		End If
		For i = 0 To UBound(DefaultProjectList)
			Stemp = False
			For j = 0 To n
				If ProjectList(j).Name = DefaultProjectList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve ProjectList(n) As CHECK_PROJECT_SET
				ProjectList(n) = DefaultCheckSet(DefaultProjectList(i),True)
				ProjectList(n).Name = DefaultProjectList(i)
			End If
		Next i
		If CheckArray(getSetNameList(ProjectList)) = False Then
			For i = 18 To 24
				If i <> 21 Then tSelected(i) = "0"
			Next i
		End If
	End If

	'ʼ
	TranStrings(Translations,MinMatch,MaxCount)
	Call ExitMacro(0)
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0,True)
End Sub


'ַ
Private Function TranStrings(Translations As PslTranslations,ByVal MinMatch As Long,ByVal MaxCount As Long) As Long
	Dim i As Long,j As Long
	Dim srcString As String,OldSrcString As String,trnString As String
	Dim MsgList() As String,LangPair As LANG_SET,LangPairBak As LANG_SET
	Dim Stemp As Boolean,xmlHttp As Object
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'תΪֵ
	ReDim SetList(UBound(tSelected)) As Integer
	For i = 3 To UBound(tSelected)
		Select Case i
		Case 3
			SetList(i) = 1
		Case 4 - 10
			SetList(i) = 0
		Case Else
			SetList(i) = StrToLong(tSelected(i))
		End Select
	Next i

	'ȫΪֺͷŵִ
	If SetList(14) = 1 Then
		If LCase(Translations.SourceString) = UCase(Translations.SourceString) Then
			If CheckStrRegExp(Translations.SourceString,CheckSkipStr(1),0,1) = True Then Exit Function
		End If
	End If
	'ȫΪдӢĵִ
	If SetList(15) = 1 Then
		If UCase(Translations.SourceString) = Translations.SourceString Then
			If Trim$(Translations.SourceString) <> "OK" Then
				If CheckStrRegExp(Translations.SourceString,CheckSkipStr(2),0,1) = True Then Exit Function
			End If
		End If
	End If
	'ȫΪСдӢĵִ
	If SetList(16) = 1 Then
		If LCase(Translations.SourceString) = Translations.SourceString Then
			If CheckStrRegExp(Translations.SourceString,CheckSkipStr(3),0,1) = True Then Exit Function
		End If
	End If

	'ȡPSLԴ
	With LangPair
		'ȡPSLԴԴ
		.PslCode = PSL.GetLangCode(Translations.SourceLangID,pslCode639_1)
		If .PslCode = "" Or .PslCode = "zh" Then
			.PslCode = PSL.GetLangCode(Translations.SourceLangID,pslCodeLangRgn)
			Select Case .PslCode
			Case "zh-CHS" ,"zh-SG"
				.PslCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.PslCode = "zh-TW"
			End Select
		Else
			.PslCode = .PslCode & LngJoinStr & PSL.GetLangCode(Translations.SourceLangID,pslCodeLangRgn)
		End If
		'ȡĿ
		.UseCode = PSL.GetLangCode(Translations.TargetLangID,pslCode639_1)
		If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
		If .UseCode = "" Or .UseCode = "zh" Then
			.UseCode = PSL.GetLangCode(Translations.TargetLangID,pslCodeLangRgn)
			Select Case .UseCode
			Case "zh-CHS" ,"zh-SG"
				.UseCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.UseCode = "zh-TW"
			End Select
		Else
			.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(Translations.TargetLangID,pslCodeLangRgn)
		End If
	End With
	LangPairBak = LangPair

	'ȡõķ
	SetList(2) = -1
	If SetList(17) = 1 Then
		SetList(2) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
	Else
		For i = 0 To UBound(CheckList)
			If CheckList(i).Name = tSelected(2) Then
				SetList(2) = i
				Exit For
			End If
		Next i
		If SetList(2) = -1 Then
			SetList(2) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
		End If
	End If
	If SetList(2) = -1 Then SetList(2) = 0

	'÷Ϊȫ
	cSelected(14) = "1"

	'תеתֵ
	If SetList(19) = 1 Or SetList(23) = 1 Then
		CheckList(SetList(2)) = ConvertAndSortCheckSet(CheckList(SetList(2)))
	End If

	'תת
	Stemp = False
	OldSrcString = Translations.SourceString
	srcString = Convert(OldSrcString)
	If srcString <> OldSrcString Then
		OldSrcString = srcString
		Stemp = True
	End If

	'ʼԤִ
	If SetList(20) = 1 Then srcString = ReplaceStr(SetList(2),srcString,0,0)
	If SetList(21) = 0 Then
		If SetList(19) = 1 Then srcString = CheckHanding(SetList(2),SetList(18),srcString,srcString)
		If InStr(srcString,"&") Then srcString = Replace(srcString,"&","")
	End If

	'ֱõķ淭ִк
	MaxCount = MaxCount + UBound(EngineList) + 1
	For j = 0 To UBound(EngineList)
		'
		On Error Resume Next
		With EngineList(j)
			If .HttpName <> "" Then
				ReDim TempList(0) As String
				TempList = ReSplit(.HttpName,IIf(InStr(.HttpName,";"),";",","))
				For i = 0 To UBound(TempList)
					If TempList(i) <> "" Then
						Set xmlHttp = CreateObject(TempList(i))
						If Not xmlHttp Is Nothing Then Exit For
					End If
				Next i
			End If
		End With
		On Error GoTo 0
		If xmlHttp Is Nothing Then GoTo Skip

		'ȡ TK űļ
		If EngineList(j).Name = DefaultEngineList(1) Then
			If TKJScript = "" Then
				If Dir(MacroLoc & "\Module\modGoogleJScript.js") <> "" Then
					TKJScript = ReadTextFile(MacroLoc & "\Module\modGoogleJScript.js","windows-1252")
				End If
			End If
			If TKJScript = "" Then
				Err.Raise(1,"NotExitFile",MacroLoc & "\Module\modGoogleJScript.js")
			End If
		End If

		'ҷжӦԴ
		LangPair = LangPairBak
		If getEngineLngPair(EngineList(j).LangPairList,LangPair) = False Then GoTo Skip

		'תеת
		EngineList(j) = ConvertResponseTypeSet(EngineList(j))

		'ʼִ
		If SetList(21) = 0 Then
			trnString = getTranslate(xmlHttp,j,srcString,LangPair,0)
		Else
			trnString = SplitTran(xmlHttp,j,srcString,LangPair,SetList,0)
		End If

		'ʼִ滻ԭз
		If Trim(trnString) <> "" Then
			If trnString <> OldSrcString Then
				If SetList(23) = 1 Then
					If ProjectList(SetList(22)).ApplyCheckResult = 1 Then
						trnString = CheckHanding(SetList(2),SetList(22),OldSrcString,trnString)
					Else
						Call CheckHanding(SetList(2),SetList(22),OldSrcString,trnString)
					End If
				End If
				If SetList(24) = 1 Then trnString = ReplaceStr(SetList(2),trnString,2,1)
				If Stemp = True Then trnString = ReConvert(trnString)
				Translations.Add(trnString,Translations.SourceString,100,Replace(MsgList(30),"%s",EngineList(j).Name))
			End If
		End If
		Skip:
		If Translations.Count = MaxCount Then Exit For
		TranStrings = TranStrings + 1
		'DoEvents 'תÿȨϵͳ¼
		If StopProcess(VK_ESCAPE) = True Then
			TranStrings = -1
			Exit Function
		End If
	Next j
	Set xmlHttp = Nothing
End Function
