''This macro is a online translations macro program for strings
''in Passolo translation list.
''It has the following features:
''- Use the online translation engine automatically translate strings
''  in the Passolo translation list
''- Integrated some of the well-known online translation engines, and
''  you can customize other online translation engines
''- You can choose the string type, skiping some of string, and processing
''  the strings before and after translation
''- Integrated shortcuts, terminators, Accelerator check macro, and you can
''  check and correct errors in translations after the strings has be translated
''2010-2019 Modified by wanfu 2010.05.12 (Last modified on 2019.08.28)

'#Uses ".\Module\modTransCommon.bas"

Option Explicit


' 
Sub Main
	Dim i As Long,j As Long,n As Long,Obj As Object,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String,trns As PslTransDisplay

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		MsgBox(Err.Description & " - " & "WScript.Shell",vbInformation)
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			MsgBox Err.Description,vbInformation
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Adodb.Stream",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' Scripting.Dictionary Ƿ
	Set Obj = CreateObject("Scripting.Dictionary")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Scripting.Dictionary",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' MSScriptControl.ScriptControl Ƿ
	Set Obj = CreateObject("MSScriptControl.ScriptControl")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "MSScriptControl.ScriptControl",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		MsgBox Err.Description & " - " & "VBScript.RegExp",vbInformation
		Exit Sub
	End If
	On Error GoTo SysErrorMsg

	'ʼ
	ReDim Tools(3) As TOOLS_PROPERTIE,FileDataList(0) As String
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA
	ReDim tSelected(27) As String,UpdateSet(5) As String,LFList(0) As LOG_FONT
	ReDim DefaultEngineList(3) As String,EngineList(0) As ENGINE_SET,EngineList(0).LangPairList(0) 'As LANG_SET
	ReDim cSelected(26) As String,cUpdateSet(5) As String
	ReDim DefaultCheckList(1) As String,CheckList(0) As CHECK_SET,CheckList(0).LangPairList(0) 'As LANG_SET
	ReDim DefaultProjectList(4) As String,ProjectList(0) As CHECK_PROJECT_SET
	ReDim CheckCountList(6) As Integer,PslLangList(0) As LANG_SET,TrnCountList(3) As Integer

	'ת HEX ֵַΪ Long ʽģ壬תıת
	MsgList = ReSplit(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(MsgList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(MsgList)
		CheckHexStr(i).Range = Replace$(MsgList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
		CheckHexStr(i).AscRange = "[" & Convert(Replace$(MsgList(i),",","")) & "]"
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = ReSplit("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetEngineSet("Option","")

	'ȡִ
	If GetUI(MacroLoc & "\Data\",tSelected(0),OSLanguage,UIDataList,UIFileList,LangFile) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		MsgBox MsgList(1),vbOkOnly+vbInformation,MsgList(0)
		Exit Sub
	End If

	'ⷭбǷ񱻼
	Set trns = PSL.ActiveTransDisplay
	If trns Is Nothing Then
		MsgBox MsgList(2),vbOkOnly+vbInformation,MsgList(0)
		Exit Sub
	ElseIf trns.StringCount > 0 Then
		Set trn = trns.String(1,pslDisplay).TransList
	Else
		Exit Sub
	End If

	'Ĭֵ
	TempList = ReSplit(MsgList(4),";")
	DefaultEngineList(0) = TempList(0)
	DefaultEngineList(1) = TempList(1)
	DefaultEngineList(2) = TempList(2)
	DefaultEngineList(3) = TempList(3)
	TempList = ReSplit(MsgList(5),";")
	DefaultCheckList(0) = TempList(0)
	DefaultCheckList(1) = TempList(1)
	TempList = ReSplit(MsgList(6),";")
	DefaultProjectList(0) = TempList(0)
	DefaultProjectList(1) = TempList(1)
	DefaultProjectList(2) = TempList(2)
	DefaultProjectList(3) = TempList(3)
	DefaultProjectList(4) = TempList(4)

	'ȡ
	GetEngineSet("","")
	'ȡִ
	GetCheckSet("","")

	'ֹͣťʱʾԻϵϢ
	StopTitle = MsgList(40)
	StopMsg = MsgList(41)

	'ȡַб
	CodeList = getCodePageList(0,49)

	'鷭
	If UBound(EngineList) >= 0 Then
		If CheckEngineSet(EngineList) = False Then
			n = -1
		Else
			n = UBound(EngineList)
		End If
		For i = 0 To UBound(DefaultEngineList)
			Stemp = False
			For j = 0 To n
				If EngineList(j).Name = DefaultEngineList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve EngineList(n) As ENGINE_SET
				EngineList(n) = DefaultEngineSet(DefaultEngineList(i))
				EngineList(n).Name = DefaultEngineList(i)
				EngineList(n).LangPairList = LangCodeList(DefaultEngineList(i),0,-1)
			End If
		Next i
		If CheckEngineSet(EngineList) = False Then
			MsgBox MsgList(42),vbOkOnly+vbInformation,MsgList(0)
			Exit Sub
		End If
	End If

	'鷭
	If UBound(CheckList) >= 0 Then
		If CheckCheckSet(CheckList) = False Then
			n = -1
		Else
			n = UBound(CheckList)
		End If
		For i = 0 To UBound(DefaultCheckList)
			Stemp = False
			For j = 0 To n
				If CheckList(j).Name = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve CheckList(n) As CHECK_SET
				CheckList(n) = DefaultCheckSet(DefaultCheckList(i),False)
				CheckList(n).Name = DefaultCheckList(i)
				CheckList(n).LangPairList = LangCodeList(DefaultCheckList(i),1,-1)
			End If
		Next i
		If CheckCheckSet(CheckList) = False Then
			If MsgBox(MsgList(8),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			For i = 18 To 24
				If i <> 21 Then tSelected(i) = "0"
			Next i
		End If
	End If
	'鷭鷽
	If UBound(ProjectList) >= 0 Then
		If CheckArray(getSetNameList(ProjectList)) = False Then
			n = -1
		Else
			n = UBound(ProjectList)
		End If
		For i = 0 To UBound(DefaultProjectList)
			Stemp = False
			For j = 0 To n
				If ProjectList(j).Name = DefaultProjectList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve ProjectList(n) As CHECK_PROJECT_SET
				ProjectList(n) = DefaultCheckSet(DefaultProjectList(i),True)
				ProjectList(n).Name = DefaultProjectList(i)
			End If
		Next i
		If CheckArray(getSetNameList(ProjectList)) = False Then
			If MsgBox(MsgList(9),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			For i = 18 To 24
				If i <> 21 Then tSelected(i) = "0"
			Next i
		End If
	End If

	'ʼ
	TranStrings(trns,0)
	Call ExitMacro(0)
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
	Call ExitMacro(0)
End Sub


'ַ
Private Function TranStrings(trns As PslTransDisplay,ByVal SrcLangID As Long) As Long
	Dim i As Long,trnID As Long,TransListOpen As Boolean
	Dim StringCount As Long,TransString As PslTransString,tran As PslTransList
	Dim MsgList() As String,StrTypes As String,LangPair As LANG_SET
	Dim StartTime As Date,Temp As String,xmlHttp As Object
	Dim CheckName As String,SrcPrjName As String,TrnPrjName As String
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'ʾ򿪹رյķбҪ޸ĺɾ
	If trns Is Nothing Then
		Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		Select Case MsgBox(Replace(MsgList(10),"%s",Temp),vbYesNo,MsgList(0))
		Case vbYes
			If trn.Open = False Then
				MsgBox Replace(MsgList(11),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			Else
				TransListOpen = True
			End If
		Case Else
			TranStrings = -1
			Exit Function
		End Select
	End If

	'תΪֵ
	ReDim SetList(UBound(tSelected)) As Integer
	For i = 3 To UBound(tSelected)
		Select Case i
		Case 3 - 9
			SetList(i) = 0
		Case 10
			SetList(i) = 1
		Case Else
			SetList(i) = StrToLong(tSelected(i))
		End Select
	Next i

	'ȡѡķ
	SetList(1) = -1
	For i = 0 To UBound(EngineList)
		If EngineList(i).Name = tSelected(1) Then
			SetList(1) = i
			Exit For
		End If
	Next i
	If SetList(1) = -1 Then SetList(1) = 0

	'ȡ TK űļ
	If EngineList(SetList(1)).Name = DefaultEngineList(1) Then
		If TKJScript = "" Then
			If Dir(MacroLoc & "\Module\modGoogleJScript.js") <> "" Then
				TKJScript = ReadTextFile(MacroLoc & "\Module\modGoogleJScript.js","windows-1252")
			End If
		End If
		If TKJScript = "" Then
			Err.Raise(1,"NotExitFile",MacroLoc & "\Module\modGoogleJScript.js")
		End If
	End If

	'
	On Error Resume Next
	With EngineList(SetList(1))
		If .HttpName = "" Then Exit Function
		ReDim TempList(0) As String
		TempList = ReSplit(.HttpName,IIf(InStr(.HttpName,";"),";",","))
		For i = 0 To UBound(TempList)
			If TempList(i) <> "" Then
				Set xmlHttp = CreateObject(TempList(i))
				If Not xmlHttp Is Nothing Then Exit For
			End If
		Next i
	End With
	On Error GoTo 0
	If xmlHttp Is Nothing Then Exit Function

	'ȡPSLԴ
	With LangPair
		'ȡPSLԴԴ
		If SrcLangID = 0 Then
			.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCode639_1)
		Else
			.PslCode = PSL.GetLangCode(trn.Project.TransLists(SrcLangID).Language.LangID,pslCode639_1)
		End If
		If .PslCode = "" Or .PslCode = "zh" Then
			If SrcLangID = 0 Then
				.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
			Else
				.PslCode = PSL.GetLangCode(trn.Project.TransLists(SrcLangID).Language.LangID,pslCodeLangRgn)
			End If
			Select Case .PslCode
			Case "zh-CHS" ,"zh-SG"
				.PslCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.PslCode = "zh-TW"
			End Select
		Else
			.PslCode = .PslCode & LngJoinStr & PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
		End If
		'ȡĿ
		.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
		If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
		If .UseCode = "" Or .UseCode = "zh" Then
			.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
			Select Case .UseCode
			Case "zh-CHS" ,"zh-SG"
				.UseCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.UseCode = "zh-TW"
			End Select
		Else
			.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
		End If
	End With

	'ȡõķ
	SetList(2) = -1
	If SetList(17) = 1 Then
		SetList(2) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
	Else
		For i = 0 To UBound(CheckList)
			If CheckList(i).Name = tSelected(2) Then
				SetList(2) = i
				Exit For
			End If
		Next i
		If SetList(2) = -1 Then
			SetList(2) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
		End If
	End If
	If SetList(2) = -1 Then SetList(2) = 0

	'ҷжӦԴ
	If getEngineLngPair(EngineList(SetList(1)).LangPairList,LangPair) = False Then
		MsgBox Replace$(MsgList(12),"%s",EngineList(SetList(1)).Name),vbOkOnly+vbInformation,MsgList(0)
		Exit Function
	End If

	'÷Ϊȫ
	cSelected(14) = "1"

	'תеת
	EngineList(SetList(1)) = ConvertResponseTypeSet(EngineList(SetList(1)))

	If getMsgList(UIDataList,MsgList,"MainDlgFunc",1) = False Then Exit Function
	'ȡԷ
	Temp = getTranslate(xmlHttp,SetList(1),"Testing at " & Time,LangPair,3)
	'Set xmlHttp = Nothing
	Select Case Temp
	Case "NotConnected"	' Internet 
		MsgBox(MsgList(7),vbOkOnly+vbInformation,MsgList(0))
		Exit Function
	Case "NullUrl"	'ַǷΪ
		MsgBox(MsgList(8),vbOkOnly+vbInformation,MsgList(0))
		Exit Function
	Case "Timeout"	'Ƿʱ
		Select Case MsgBox(MsgList(4),vbYesNoCancel+vbInformation,MsgList(3))
		Case vbYes
			Temp = InputBox(MsgList(5),MsgList(6),"5")
			If Temp <> "" Then
				WaitTimes = CLng(Temp)
			Else
				Exit Function
			End If
		Case vbCancel
			Exit Function
		End Select
	Case Else	'ǷΪ
		If Trim(Temp) = "" Then
			MsgBox(MsgList(9),vbOkOnly+vbInformation,MsgList(0))
			Exit Function
		End If
	End Select
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'תеתֵ
	If SetList(19) = 1 Or SetList(23) = 1 Then
		CheckList(SetList(2)) = ConvertAndSortCheckSet(CheckList(SetList(2)))
		CheckName = CheckList(SetList(2)).Name
	Else
		CheckName = MsgList(13)
	End If

	'ȡ鷽
	If SetList(19) = 1 Then
		SrcPrjName = ProjectList(SetList(18)).Name
	Else
		SrcPrjName = MsgList(14)
	End If
	If SetList(23) = 1 Then
		TrnPrjName = ProjectList(SetList(22)).Name
	Else
		TrnPrjName = MsgList(14)
	End If

	'ȡִ
	If SetList(4) = 1 Then StrTypes = "|Menu|"
	If SetList(5) = 1 Then StrTypes = StrTypes & "|Dialog|"
	If SetList(6) = 1 Then StrTypes = StrTypes & "|StringTable|"
	If SetList(7) = 1 Then StrTypes = StrTypes & "|AcceleratorTable|"
	If SetList(8) = 1 Then StrTypes = StrTypes & "|Version|"

	'Ƿѡ "ѡִ" Ҫִ
	If trns Is Nothing Then
		If TransListOpen = True Then
			If SetList(10) = 0 Then
				StringCount = trn.StringCount(pslDisplay)
			Else
				StringCount = trn.StringCount(pslSelection)
			End If
		Else
			StringCount = trn.StringCount
		End If
	Else
		If SetList(10) = 0 Then
			StringCount = trns.StringCount(pslDisplay)
		Else
			StringCount = trns.StringCount(pslSelection)
		End If
	End If

	'ʼÿִ
	PSL.OutputWnd.Clear
	PSL.Output Replace$(Replace$(Replace$(Replace$(MsgList(15),"%s",EngineList(SetList(1)).Name),"%d",CheckName),"%p",SrcPrjName),"%n",TrnPrjName)
	StartTime = Timer
	For i = 1 To StringCount
		'Ƿѡ "ѡִ" Ҫִ
		If trns Is Nothing Then
			If TransListOpen = True Then
				If SetList(10) = 0 Then
					Set TransString = trn.String(i,pslDisplay)
				Else
					Set TransString = trn.String(i,pslSelection)
				End If
			Else
				Set TransString = trn.String(i)
			End If
		Else
			If SetList(10) = 0 Then
				Set TransString = trns.String(i,pslDisplay)
			Else
				Set TransString = trns.String(i,pslSelection)
			End If
			Set trn = TransString.TransList
		End If
		'ȡб IDԱԷбĳЩֻһ
		If trn.ListID <> trnID Then
			trnID = trn.ListID
			'бǷѾ
			If SrcLangID > 0 Then
				On Error Resume Next
				Set tran = trn.Project.TransLists(trn.SourceList,SrcLangID)
				If tran.String(1).Text = "" Then
					PSL.Output MsgList(16)
					If tran.Update = False Then
						Temp = tran.Title & " - " & PSL.GetLangCode(tran.Language.LangID,pslCodeText)
						MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						GoTo Skip
					End If
				ElseIf tran.SourceList.LastChange > tran.LastUpdate Then
					PSL.Output MsgList(16)
					If tran.Update = False Then
						Temp = tran.Title & " - " & PSL.GetLangCode(tran.Language.LangID,pslCodeText)
						MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						GoTo Skip
					End If
				End If
				On Error GoTo 0
			'бĸʱԭʼбԶ
			ElseIf trn.SourceList.LastChange > trn.LastUpdate Then
				PSL.Output MsgList(16)
				If trn.Update = False Then
					Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
					MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					GoTo Skip
				End If
			End If
			'üרõû
			If trn.Property(19980) <> "CheckAccessKeys" Then trn.Property(19980) = "CheckAccessKeys"
		End If
		'ѡԴԻȡͬķԴ
		If SrcLangID = 0 Then
			Temp = TransString.SourceText
		ElseIf SetList(14) = 0 Then
			Temp = tran.String(i,pslDisplay).Text
		Else
			Temp = tran.String(TransString.Number,pslNumber).Text
		End If
		TranStrings = TranStrings + TranString(xmlHttp,TransString,Temp,LangPair,StrTypes,SetList,MsgList)
		Skip:
		'DoEvents 'תÿȨϵͳ¼
		If StopProcess(VK_ESCAPE) = True Then
			TranStrings = -1
			Exit Function
		End If
	Next i
	Set xmlHttp = Nothing
	'Ϣ
	i = CheckCountList(0) + CheckCountList(1) + CheckCountList(2) + CheckCountList(3) + _
		CheckCountList(4) + CheckCountList(5) + CheckCountList(6)
	PSL.Output TranMassage(TrnCountList,i)
	PSL.Output Format(DateAdd("s",Timer - StartTime,0),MsgList(18))
	If i = 0 And TransListOpen = True Then trn.Close
End Function
