''This macro is a online translations macro program for strings
''in Passolo translation list.
''It has the following features:
''- Use the online translation engine automatically translate strings
''  in the Passolo translation list
''- Integrated some of the well-known online translation engines, and
''  you can customize other online translation engines
''- You can choose the string type, skiping some of string, and processing
''  the strings before and after translation
''- Integrated shortcuts, terminators, Accelerator check macro, and you can
''  check and correct errors in translations after the strings has be translated
''2010-2020 Modified by wanfu 2010.05.12 (Last modified on 2020.02.16)

'#Uses ".\Module\modTransCommon.bas"

Option Explicit

'Public Const Version = "2020.02.16"
'Public Const Build = "200216"
Private Const updateMainFile = "PSLWebTrans.bas"
Private Const updateINIFile = "PSLMacrosUpdates.rar"
Private Const updateINIMainUrl = "http://jp.wanfutrade.com/download/PSLMacrosUpdates.rar"
Private Const updateINIMinorUrl = "http://www.wanfutrade.com/software/hanhua/PSLMacrosUpdates.rar"
Private Const updateMainUrl = "http://jp.wanfutrade.com/download/PSLWebTrans.rar"
Private Const updateMinorUrl = "http://www.wanfutrade.com/software/hanhua/PSLWebTrans.rar"


' 
Sub Main
	Dim i As Long,j As Long,n As Long,Obj As Object,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String,trns As PslTransDisplay

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "WScript.Shell",vbInformation
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			MsgBox Err.Description,vbInformation
			Exit Sub
		End If
	End If
	Set Obj = Nothing
	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Adodb.Stream",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' Scripting.Dictionary Ƿ
	Set Obj = CreateObject("Scripting.Dictionary")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "Scripting.Dictionary",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' MSScriptControl.ScriptControl Ƿ
	Set Obj = CreateObject("MSScriptControl.ScriptControl")
	If Obj Is Nothing Then
		MsgBox Err.Description & " - " & "MSScriptControl.ScriptControl",vbInformation
		Exit Sub
	End If
	Set Obj = Nothing
	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		MsgBox Err.Description & " - " & "VBScript.RegExp",vbInformation
		Exit Sub
	End If
	On Error GoTo SysErrorMsg
	
	'ʼ
	ReDim Tools(3) As TOOLS_PROPERTIE,FileDataList(0) As String
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA
	ReDim tSelected(27) As String,UpdateSet(5) As String,LFList(0) As LOG_FONT
	ReDim DefaultEngineList(3) As String,EngineList(0) As ENGINE_SET,EngineList(0).LangPairList(0) 'As LANG_SET
	ReDim cSelected(26) As String,cUpdateSet(5) As String
	ReDim DefaultCheckList(1) As String,CheckList(0) As CHECK_SET,CheckList(0).LangPairList(0) 'As LANG_SET
	ReDim DefaultProjectList(4) As String,ProjectList(0) As CHECK_PROJECT_SET
	ReDim CheckCountList(6) As Integer,PslLangList(0) As LANG_SET,TrnCountList(3) As Integer

	'ת HEX ֵַΪ Long ʽģ壬תıת
	MsgList = ReSplit(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(MsgList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(MsgList)
		CheckHexStr(i).Range = Replace$(MsgList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
		CheckHexStr(i).AscRange = "[" & Convert(Replace$(MsgList(i),",","")) & "]"
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = ReSplit("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetEngineSet("Option","")

	'ȡִ
	If GetUI(MacroLoc & "\Data\",tSelected(0),OSLanguage,UIDataList,UIFileList,LangFile) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		MsgBox MsgList(1),vbOkOnly+vbInformation,MsgList(0)
		Exit Sub
	End If

	'ⷭбǷ񱻼
	Set trns = PSL.ActiveTransDisplay
	If trns Is Nothing Then
		Set trn = PSL.ActiveTransList
		If trn Is Nothing Then
			MsgBox MsgList(2),vbOkOnly+vbInformation,MsgList(0)
			Exit Sub
		End If
	ElseIf trns.StringCount > 0 Then
		Set trn = trns.String(1,pslDisplay).TransList
	End If

	'Ĭֵ
	TempList = ReSplit(MsgList(4),";")
	DefaultEngineList(0) = TempList(0)
	DefaultEngineList(1) = TempList(1)
	DefaultEngineList(2) = TempList(2)
	DefaultEngineList(3) = TempList(3)
	TempList = ReSplit(MsgList(5),";")
	DefaultCheckList(0) = TempList(0)
	DefaultCheckList(1) = TempList(1)
	TempList = ReSplit(MsgList(6),";")
	DefaultProjectList(0) = TempList(0)
	DefaultProjectList(1) = TempList(1)
	DefaultProjectList(2) = TempList(2)
	DefaultProjectList(3) = TempList(3)
	DefaultProjectList(4) = TempList(4)

	'ȡ
	GetEngineSet("","")
	'ȡִ
	GetCheckSet("","")

	'ȡݲ°汾
	If CheckUpdate(UpdateSet,-2) = True Then Exit Sub

	'ʼ༭߲˵
	TempList = ReSplit(MsgList(3),";")
	Tools(0).sName = TempList(0)
	Tools(1).sName = TempList(1)
	Tools(2).sName = TempList(2)
	Tools(3).sName = TempList(3)
	Tools(1).FilePath = "notepad.exe"

	'ֹͣťʱʾԻϵϢ
	StopTitle = MsgList(40)
	StopMsg = MsgList(41)

	'ȡַб
	CodeList = getCodePageList(0,49)

	'鷭
	If UBound(EngineList) >= 0 Then
		If CheckEngineSet(EngineList) = False Then
			n = -1
		Else
			n = UBound(EngineList)
		End If
		For i = 0 To UBound(DefaultEngineList)
			Stemp = False
			For j = 0 To n
				If EngineList(j).Name = DefaultEngineList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve EngineList(n) As ENGINE_SET
				EngineList(n) = DefaultEngineSet(DefaultEngineList(i))
				EngineList(n).Name = DefaultEngineList(i)
				EngineList(n).LangPairList = LangCodeList(DefaultEngineList(i),0,-1)
			End If
		Next i
		If CheckEngineSet(EngineList) = False Then
			If MsgBox(MsgList(7),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			EngineListBak = EngineList
			CheckListBak = CheckList
			UpdateSetBak = UpdateSet
			Temp = tSelected(0)
			Call Settings(0,0,0)
			If Temp <> tSelected(0) Then getMsgList(UIDataList,MsgList,"Main",1)
		End If
	End If

	'鷭
	If UBound(CheckList) >= 0 Then
		If CheckCheckSet(CheckList) = False Then
			n = -1
		Else
			n = UBound(CheckList)
		End If
		For i = 0 To UBound(DefaultCheckList)
			Stemp = False
			For j = 0 To n
				If CheckList(j).Name = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve CheckList(n) As CHECK_SET
				CheckList(n) = DefaultCheckSet(DefaultCheckList(i),False)
				CheckList(n).Name = DefaultCheckList(i)
				CheckList(n).LangPairList = LangCodeList(DefaultCheckList(i),1,-1)
			End If
		Next i
		If CheckCheckSet(CheckList) = False Then
			If MsgBox(MsgList(8),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			EngineListBak = EngineList
			CheckListBak = CheckList
			UpdateSetBak = UpdateSet
			Temp = tSelected(0)
			Call Settings(0,0,1)
			If Temp <> tSelected(0) Then getMsgList(UIDataList,MsgList,"Main",1)
		End If
	End If
	'鷭鷽
	If UBound(ProjectList) >= 0 Then
		If CheckArray(getSetNameList(ProjectList)) = False Then
			n = -1
		Else
			n = UBound(ProjectList)
		End If
		For i = 0 To UBound(DefaultProjectList)
			Stemp = False
			For j = 0 To n
				If ProjectList(j).Name = DefaultProjectList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				n = n + 1
				ReDim Preserve ProjectList(n) As CHECK_PROJECT_SET
				ProjectList(n) = DefaultCheckSet(DefaultProjectList(i),True)
				ProjectList(n).Name = DefaultProjectList(i)
			End If
		Next i
		If CheckArray(getSetNameList(ProjectList)) = False Then
			If MsgBox(MsgList(9),vbYesNo+vbInformation,MsgList(0)) = vbNo Then Exit Sub
			ProjectListBak = ProjectList
			Call Projects(0)
		End If
	End If

	'
	EngineListBak = EngineList
	CheckListBak = CheckList
	ProjectListBak = ProjectList
	tSelectedBak = tSelected()
	UpdateSetBak = UpdateSet
	LFListBak = LFList

	'ȡб
	With PSL.ActiveProject
		ReDim TitleList(.TransLists.Count) As String
		n = 0
		For i = 1 To .TransLists.Count
			Set trn = .TransLists(i)
			If trn.IsOpen = True Then
				TitleList(n) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
				n = n + 1
			End If
		Next i
		If n > 0 Then
			Set trn = trns.String(1,pslDisplay).TransList
			ReDim Preserve TitleList(n - 1) As String
		Else
			Set trn = PSL.ActiveTransList
			ReDim TitleList(0) As String
			TitleList(0) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		End If
	End With

	'ȡԴб
	j = trn.Project.Languages.Count
	ReDim TempList(i) As String,LangIDList(i) As Long
	TempList(0) = PSL.GetLangCode(trn.SourceList.LangID,pslCodeText)
	n = 1
	For i = 1 To j
		If trn.Project.Languages(i).LangID <> trn.Language.LangID Then
			TempList(n) = PSL.GetLangCode(trn.Project.Languages(i).LangID,pslCodeText)
			LangIDList(n) = trn.Project.Languages(i).LangID
			n = n + 1
		End If
	Next i
	If n > 1 Then n = n - 1
	ReDim Preserve TempList(n) As String,LangIDList(n) As Long

	'Ի򲢷
	i = 0
	Do
		EngineListBak = EngineList
		CheckListBak = CheckList
		ProjectListBak = ProjectList
		If MainDlg(Join$(TitleList,";"),TempList,i) = False Then Exit Do
		If TranStrings(trns,LangIDList(i)) > -1 Then Exit Do
		EngineList = EngineListBak
		CheckList = CheckListBak
		ProjectList = ProjectListBak
		ReDim CheckCountList(6) As Integer,TrnCountList(3) As Integer
	Loop
	Call ExitMacro(0)
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
	Call ExitMacro(0)
End Sub


'ַ
Private Function TranStrings(trns As PslTransDisplay,ByVal SrcLangID As Long) As Long
	Dim i As Long,trnID As Long,TransListOpen As Boolean
	Dim StringCount As Long,TransString As PslTransString,tran As PslTransList
	Dim MsgList() As String,StrTypes As String,LangPair As LANG_SET
	Dim StartTime As Date,Temp As String,xmlHttp As Object,TempBak As String
	Dim CheckName As String,SrcPrjName As String,TrnPrjName As String
	If getMsgList(UIDataList,MsgList,"Main",1) = False Then Exit Function

	'ʾ򿪹رյķбҪ޸ĺɾ
	If trns Is Nothing Then
		Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		Select Case MsgBox(Replace(MsgList(10),"%s",Temp),vbYesNo,MsgList(0))
		Case vbYes
			If trn.Open = False Then
				MsgBox Replace(MsgList(11),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			Else
				TransListOpen = True
			End If
		Case Else
			TranStrings = -1
			Exit Function
		End Select
	End If

	'תΪֵ
	ReDim SetList(UBound(tSelected)) As Integer
	For i = 3 To UBound(tSelected)
		SetList(i) = StrToLong(tSelected(i))
	Next i

	'ȡѡķ
	SetList(1) = -1
	For i = 0 To UBound(EngineList)
		If EngineList(i).Name = tSelected(1) Then
			SetList(1) = i
			Exit For
		End If
	Next i
	If SetList(1) = -1 Then SetList(1) = 0

	'ȡ TK űļ
	If EngineList(SetList(1)).Name = DefaultEngineList(1) Then
		If TKJScript = "" Then
			If Dir(MacroLoc & "\Module\modGoogleJScript.js") <> "" Then
				TKJScript = ReadTextFile(MacroLoc & "\Module\modGoogleJScript.js","windows-1252")
			End If
		End If
		If TKJScript = "" Then
			Err.Raise(1,"NotExitFile",MacroLoc & "\Module\modGoogleJScript.js")
		End If
	End If

	'
	On Error Resume Next
	With EngineList(SetList(1))
		If .HttpName = "" Then Exit Function
		ReDim TempList(0) As String
		TempList = ReSplit(.HttpName,IIf(InStr(.HttpName,";"),";",","))
		For i = 0 To UBound(TempList)
			If TempList(i) <> "" Then
				Set xmlHttp = CreateObject(TempList(i))
				If Not xmlHttp Is Nothing Then Exit For
			End If
		Next i
	End With
	On Error GoTo 0
	If xmlHttp Is Nothing Then Exit Function

	'ȡPSLԴ
	With LangPair
		'ȡPSLԴԴ
		If SrcLangID = 0 Then
			.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCode639_1)
		Else
			.PslCode = PSL.GetLangCode(trn.Project.TransLists(trn.SourceList,SrcLangID).Language.LangID,pslCode639_1)
		End If
		If .PslCode = "" Or .PslCode = "zh" Then
			If SrcLangID = 0 Then
				.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
			Else
				.PslCode = PSL.GetLangCode(trn.Project.TransLists(trn.SourceList,SrcLangID).Language.LangID,pslCodeLangRgn)
			End If
			Select Case .PslCode
			Case "zh-CHS" ,"zh-SG"
				.PslCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.PslCode = "zh-TW"
			End Select
		Else
			.PslCode = .PslCode & LngJoinStr & PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
		End If
		'ȡĿ
		.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
		If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
		If .UseCode = "" Or .UseCode = "zh" Then
			.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
			Select Case .UseCode
			Case "zh-CHS" ,"zh-SG"
				.UseCode = "zh-CN"
			Case "zh-CHT", "zh-HK", "zh-MO"
				.UseCode = "zh-TW"
			End Select
		Else
			.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
		End If
	End With
	'ҷжӦԴ
	If getEngineLngPair(EngineList(SetList(1)).LangPairList,LangPair) = False Then
		MsgBox Replace$(MsgList(12),"%s",EngineList(SetList(1)).Name),vbOkOnly+vbInformation,MsgList(0)
		Exit Function
	End If

	'ȡѡķ
	SetList(2) = -1
	For i = 0 To UBound(CheckList)
		If CheckList(i).Name = tSelected(2) Then
			SetList(2) = i
			Exit For
		End If
	Next i
	If SetList(2) = -1 Then SetList(2) = 0

	'ִΪȫ
	TempBak = cSelected(14)
	cSelected(14) = "1"

	'תеתֵ
	If SetList(19) = 1 Or SetList(23) = 1 Then
		CheckList(SetList(2)) = ConvertAndSortCheckSet(CheckList(SetList(2)))
		CheckName = CheckList(SetList(2)).Name
	Else
		CheckName = MsgList(13)
	End If

	'ȡ鷽
	If SetList(19) = 1 Then
		SrcPrjName = ProjectList(SetList(18)).Name
	Else
		SrcPrjName = MsgList(14)
	End If
	If SetList(23) = 1 Then
		TrnPrjName = ProjectList(SetList(22)).Name
	Else
		TrnPrjName = MsgList(14)
	End If

	'ȡִ
	If SetList(4) = 1 Then StrTypes = "|Menu|"
	If SetList(5) = 1 Then StrTypes = StrTypes & "|Dialog|"
	If SetList(6) = 1 Then StrTypes = StrTypes & "|StringTable|"
	If SetList(7) = 1 Then StrTypes = StrTypes & "|AcceleratorTable|"
	If SetList(8) = 1 Then StrTypes = StrTypes & "|Version|"

	'Ƿѡ "ѡִ" Ҫִ
	If trns Is Nothing Then
		If TransListOpen = True Then
			If SetList(10) = 0 Then
				StringCount = trn.StringCount(pslDisplay)
			Else
				StringCount = trn.StringCount(pslSelection)
			End If
		Else
			StringCount = trn.StringCount
		End If
	Else
		If SetList(10) = 0 Then
			StringCount = trns.StringCount(pslDisplay)
		Else
			StringCount = trns.StringCount(pslSelection)
		End If
	End If

	'ʼÿִ
	PSL.OutputWnd.Clear
	PSL.Output Replace$(Replace$(Replace$(Replace$(MsgList(15),"%s",EngineList(SetList(1)).Name),"%d",CheckName),"%p",SrcPrjName),"%n",TrnPrjName)
	StartTime = Timer
	For i = 1 To StringCount
		'Ƿѡ "ѡִ" Ҫִ
		If trns Is Nothing Then
			If TransListOpen = True Then
				If SetList(10) = 0 Then
					Set TransString = trn.String(i,pslDisplay)
				Else
					Set TransString = trn.String(i,pslSelection)
				End If
			Else
				Set TransString = trn.String(i)
			End If
		Else
			If SetList(10) = 0 Then
				Set TransString = trns.String(i,pslDisplay)
			Else
				Set TransString = trns.String(i,pslSelection)
			End If
			Set trn = TransString.TransList
		End If
		'ȡб IDԱԷбĳЩֻһ
		If trn.ListID <> trnID Then
			trnID = trn.ListID
			'бǷѾ
			If SrcLangID > 0 Then
				On Error Resume Next
				Set tran = trn.Project.TransLists(trn.SourceList,SrcLangID)
				If tran.String(1).Text = "" Then
					PSL.Output MsgList(16)
					If tran.Update = False Then
						Temp = tran.Title & " - " & PSL.GetLangCode(tran.Language.LangID,pslCodeText)
						MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						GoTo Skip
					End If
				ElseIf tran.SourceList.LastChange > tran.LastUpdate Then
					PSL.Output MsgList(16)
					If tran.Update = False Then
						Temp = tran.Title & " - " & PSL.GetLangCode(tran.Language.LangID,pslCodeText)
						MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						GoTo Skip
					End If
				End If
				On Error GoTo 0
			'бĸʱԭʼбԶ
			ElseIf trn.SourceList.LastChange > trn.LastUpdate Then
				PSL.Output MsgList(16)
				If trn.Update = False Then
					Temp = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
					MsgBox Replace(MsgList(17),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					GoTo Skip
				End If
			End If
			'üרõû
			If trn.Property(19980) <> "CheckAccessKeys" Then trn.Property(19980) = "CheckAccessKeys"
		End If
		'ѡԴԻȡͬķԴ
		If SrcLangID = 0 Then
			Temp = TransString.SourceText
		ElseIf SetList(14) = 0 Then
			Temp = tran.String(i,pslDisplay).Text
		Else
			Temp = tran.String(TransString.Number,pslNumber).Text
		End If
		TranStrings = TranStrings + TranString(xmlHttp,TransString,Temp,LangPair,StrTypes,SetList,MsgList)
		Skip:
		'DoEvents 'תÿȨϵͳ¼
		If StopProcess(VK_ESCAPE) = True Then
			TranStrings = -1
			Exit Function
		End If
	Next i
	Set xmlHttp = Nothing
	'ִûԭ
	cSelected(14) = TempBak
	'Ϣ
	i = CheckCountList(0) + CheckCountList(1) + CheckCountList(2) + CheckCountList(3) + _
		CheckCountList(4) + CheckCountList(5) + CheckCountList(6)
	PSL.Output TranMassage(TrnCountList,i)
	PSL.Output Format(DateAdd("s",Timer - StartTime,0),MsgList(18))
	'If i = 0 And TransListOpen = True Then trn.Close
End Function


'Ի
Private Function MainDlg(ByVal Title As String,srcLangList() As String,SrcLangID As Long) As Boolean
	Dim TempList() As String,MsgList() As String
	If getMsgList(UIDataList,MsgList,"MainDlg",0) = False Then Exit Function
	Begin Dialog UserDialog 660,518,MsgList(1),.MainDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		Text 20,7,620,14,Replace$(MsgList(0),"%s",Version),.Text1,2
		Text 20,28,620,32,MsgList(2),.Text2
		Text 20,63,620,14,MsgList(3) & Title,.Text3,2

		GroupBox 20,84,300,56,MsgList(4),.Configuration
		DropListBox 40,105,260,21,TempList,.EngineList

		GroupBox 340,84,300,56,MsgList(5),.SrcLang
		DropListBox 360,105,260,21,srcLangList(),.SrcLangList

		GroupBox 20,147,620,63,MsgList(6),.StrTypeSelection
		CheckBox 40,164,140,14,MsgList(7),.AllType
		CheckBox 190,164,140,14,MsgList(8),.Menu
		CheckBox 340,164,140,14,MsgList(9),.Dialog
		CheckBox 490,164,140,14,MsgList(10),.Strings
		CheckBox 40,185,140,14,MsgList(11),.AccTable
		CheckBox 190,185,140,14,MsgList(12),.Versions
		CheckBox 340,185,140,14,MsgList(13),.Other
		CheckBox 490,185,140,14,MsgList(14),.Seleted

		GroupBox 20,217,620,63,MsgList(15),.SkipSelection
		CheckBox 40,234,190,14,MsgList(16),.ForReview
		CheckBox 240,234,190,14,MsgList(17),.Validated
		CheckBox 440,234,190,14,MsgList(18),.NotTran
		CheckBox 40,255,190,14,MsgList(19),.NumAndSymbol
		CheckBox 240,255,190,14,MsgList(20),.AllUCase
		CheckBox 440,255,190,14,MsgList(21),.AllLCase

		GroupBox 20,287,620,168,MsgList(22),.PreProcessing
		Text 40,311,100,14,MsgList(23),.CheckConfigText
		Text 40,350,100,14,MsgList(24),.PreTrnText
		Text 40,406,100,14,MsgList(25),.AppTrnText
		Text 40,332,580,8,String$(200,MsgList(26)),.LineText1,2
		Text 40,388,580,8,String$(200,MsgList(26)),.LineText2,2
		DropListBox 150,308,270,21,TempList(),.CheckList
		CheckBox 480,311,150,14,MsgList(27),.AutoSelection
		DropListBox 150,347,270,21,TempList(),.SrcProjectList
		PushButton 420,347,30,21,MsgList(28),.SrcEditButton
		CheckBox 480,350,150,14,MsgList(29),.CheckSrc
		CheckBox 150,371,240,14,MsgList(30),.PreStrRep
		CheckBox 400,371,230,14,MsgList(31),.SplitTran
		DropListBox 150,403,270,21,TempList(),.TrnProjectList
		PushButton 420,403,30,21,MsgList(28),.TrnEditButton
		CheckBox 480,406,150,14,MsgList(32),.CheckTrn
		CheckBox 150,427,240,14,MsgList(33),.AppStrRep
		CheckBox 400,427,230,14,MsgList(34),.TranComment

		CheckBox 30,462,370,14,MsgList(35),.KeepSet
		CheckBox 400,462,240,14,MsgList(36),.ShowMsg
		PushButton 20,490,90,21,MsgList(37),.HelpButton
		PushButton 120,490,90,21,MsgList(38),.SetButton
		PushButton 220,490,110,21,MsgList(39),.SaveButton
		OKButton 450,490,90,21,.OKButton
		CancelButton 550,490,90,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.SrcLangList = SrcLangID
	If Dialog(dlg) = 0 Then Exit Function
	SrcLangID = dlg.SrcLangList
	MainDlg = True
End Function


'Ի
Private Function MainDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long,xmlHttp As Object
	Dim LangPair As LANG_SET,Temp As String,Stemp As Boolean
	Dim MsgList() As String,TempList() As String,tran As PslTransList
	Select Case Action%
	Case 1
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		TempList = getSetNameList(EngineList)
		DlgListBoxArray "EngineList",TempList()
		TempList = getSetNameList(CheckList)
		DlgListBoxArray "CheckList",TempList()
		TempList = getSetNameList(ProjectList)
		DlgListBoxArray "SrcProjectList",TempList()
		DlgListBoxArray "TrnProjectList",TempList()
		If CheckArray(tSelected) = True Then
			DlgText "EngineList",tSelected(1)
			DlgText "CheckList",tSelected(2)
			DlgValue "AllType",StrToLong(tSelected(3))
			DlgValue "Menu",StrToLong(tSelected(4))
			DlgValue "Dialog",StrToLong(tSelected(5))
			DlgValue "Strings",StrToLong(tSelected(6))
			DlgValue "AccTable",StrToLong(tSelected(7))
			DlgValue "Versions",StrToLong(tSelected(8))
			DlgValue "Other",StrToLong(tSelected(9))
			DlgValue "Seleted",StrToLong(tSelected(10))
			DlgValue "ForReview",StrToLong(tSelected(11))
			DlgValue "Validated",StrToLong(tSelected(12))
			DlgValue "NotTran",StrToLong(tSelected(13))
			DlgValue "NumAndSymbol",StrToLong(tSelected(14))
			DlgValue "AllUCase",StrToLong(tSelected(15))
			DlgValue "AllLCase",StrToLong(tSelected(16))
			DlgValue "AutoSelection",StrToLong(tSelected(17))
			DlgValue "SrcProjectList",StrToLong(tSelected(18))
			DlgValue "CheckSrc",StrToLong(tSelected(19))
			DlgValue "PreStrRep",StrToLong(tSelected(20))
			DlgValue "SplitTran",StrToLong(tSelected(21))
			DlgValue "TrnProjectList",StrToLong(tSelected(22))
			DlgValue "CheckTrn",StrToLong(tSelected(23))
			DlgValue "AppStrRep",StrToLong(tSelected(24))
			DlgValue "KeepSet",StrToLong(tSelected(25))
			DlgValue "ShowMsg",StrToLong(tSelected(26))
			DlgValue "TranComment",StrToLong(tSelected(27))
		End If
		If DlgValue("EngineList") < 0 Then DlgValue "EngineList",0
		If DlgValue("CheckList") < 0 Then DlgValue "CheckList",0
		If DlgValue("SrcProjectList") < 0 Then DlgValue "SrcProjectList",0
		If DlgValue("TrnProjectList") < 0 Then DlgValue "TrnProjectList",0
		If DlgValue("AutoSelection") = 1 Then
			'ȡĿ
			With LangPair
				.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
				If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
				If .UseCode = "" Or .UseCode = "zh" Then
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					Select Case .UseCode
					Case "zh-CHS" ,"zh-SG"
						.UseCode = "zh-CN"
					Case "zh-CHT", "zh-HK", "zh-MO"
						.UseCode = "zh-TW"
					End Select
				Else
					.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
				End If
				DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
				DlgEnable "CheckList",False
			End With
		End If
		If CheckEngineSet(EngineList,DlgValue("EngineList")) = False Then DlgEnable "OKButton",False
		If CheckCheckSet(CheckList,DlgValue("CheckList")) = False Then
			DlgValue "CheckSrc",0
			DlgValue "PreStrRep",0
			DlgValue "CheckTrn",0
			DlgValue "AppStrRep",0
			DlgEnable "CheckSrc",False
			DlgEnable "PreStrRep",False
			DlgEnable "CheckTrn",False
			DlgEnable "AppStrRep",False
		End If
		If DlgValue("AllType") + DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + _
			DlgValue("AccTable") + DlgValue("Versions") + DlgValue("Other") + DlgValue("Seleted") = 0 Then
			DlgValue "Seleted",1
		End If
		If trn.IsOpen = False Then
			DlgEnable "Seleted",False
			DlgValue "Seleted",0
		End If
		DlgEnable "SaveButton",False
		DlgEnable "LineText1",False
		DlgEnable "LineText2",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		MainDlgFunc = True ' ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			tSelected = tSelectedBak
			MainDlgFunc = False
			Exit Function
		Case "HelpButton"
			If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
			ReDim TempList(2) As String
			TempList(0) = MsgList(11)
			TempList(1) = MsgList(12)
			TempList(2) = MsgList(13)
			Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
			Case 0
				Call Help("MainHelp")
			Case 1
				i = Download(UpdateSet,UpdateSet(1),3,-2)
				If i = 0 Then Exit Function
				If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
					Stemp = True
				ElseIf i = 3 And ArrayComp(UpdateSet,UpdateSetBak) = False Then
					Stemp = True
				End If
				If Stemp = True Then
					UpdateSet(5) = Format(Date,"yyyy-MM-dd")
					If WriteEngineSet(tWriteLoc,"Update") = False Then Exit Function
					UpdateSetBak(5) = UpdateSet(5)
				End If
				If i = 3 Then Call ExitMacro(1)
			Case 2
				Call Help("About")
			End Select
			Exit Function
		Case "OKButton"
			If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
			'ִͺѡǷΪ
			If DlgValue("AllType") + DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + _
				DlgValue("AccTable") + DlgValue("Versions") + DlgValue("Other") + DlgValue("Seleted") = 0 Then
				MsgBox(MsgList(1),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			End If
			j = DlgValue("EngineList")
			If j < 0 Then Exit Function
			' TK űļǷ
			If EngineList(j).Name = DefaultEngineList(1) Then
				If Dir(MacroLoc & "\Module\modGoogleJScript.js") <> "" Then
					If TKJScript = "" Then
						TKJScript = ReadTextFile(MacroLoc & "\Module\modGoogleJScript.js","windows-1252")
					End If
				End If
				If TKJScript = "" Then
					Err.Source = "NotExitFile"
					Err.Description = MacroLoc & "\Module\modGoogleJScript.js"
					Call sysErrorMassage(Err,1)
				End If
			End If
			' Microsoft.XMLHTTP Ƿ
			On Error Resume Next
			TempList = ReSplit(EngineList(j).HttpName,IIf(InStr(EngineList(j).HttpName,";"),";",","))
			For i = 0 To UBound(TempList)
				TempList(i) = Trim(TempList(i))
				If TempList(i) <> "" Then
					Set xmlHttp = CreateObject(TempList(i))
					If Not xmlHttp Is Nothing Then Exit For
				End If
			Next i
			On Error GoTo 0
			If xmlHttp Is Nothing Then
				Err.Source = Join(TempList,"; ")
				Call sysErrorMassage(Err,1)
				Exit Function
			End If
			'ȡԶ
			With LangPair
				'ѡԴб
				Set tran = trn
				If DlgValue("SrcLangList") <> 0 Then
					Temp = DlgText("SrcLangList")
					For i = 1 To trn.Project.TransLists.Count
						Set tran = trn.Project.TransLists(i)
						If tran.SourceList.ListID = trn.SourceList.ListID Then
							If PSL.GetLangCode(tran.Language.LangID,pslCodeText) = Temp Then
								Exit For
							End If
						End If
					Next i
				End If
				'ȡPSLԴԴ
				If DlgValue("SrcLangList") = 0 Then
					.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCode639_1)
				Else
					.PslCode = PSL.GetLangCode(tran.Language.LangID,pslCode639_1)
				End If
				If .PslCode = "" Or .PslCode = "zh" Then
					If DlgValue("SrcLangList") = 0 Then
						.PslCode = PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
					Else
						.PslCode = PSL.GetLangCode(tran.Language.LangID,pslCodeLangRgn)
					End If
					Select Case .PslCode
					Case "zh-CHS" ,"zh-SG"
						.PslCode = "zh-CN"
					Case "zh-CHT", "zh-HK", "zh-MO"
						.PslCode = "zh-TW"
					End Select
				Else
					.PslCode = .PslCode & LngJoinStr & PSL.GetLangCode(trn.SourceList.LangID,pslCodeLangRgn)
				End If
				'ȡĿ
				.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
				If .UseCode = "" Or .UseCode = "zh" Then
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					Select Case .UseCode
					Case "zh-CHS" ,"zh-SG"
						.UseCode = "zh-CN"
					Case "zh-CHT", "zh-HK", "zh-MO"
						.UseCode = "zh-TW"
					End Select
				Else
					.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
				End If
			End With
			'ҷжӦԴ
			If getEngineLngPair(EngineList(j).LangPairList,LangPair) = False Then
				MsgBox Replace$(MsgList(10),"%s",EngineList(j).Name),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			'תеת
			EngineListBak = EngineList
			EngineList(j) = ConvertResponseTypeSet(EngineList(j))
			'ȡԷ
			Temp = getTranslate(xmlHttp,j,"Testing at " & Time,LangPair,3)
			Set xmlHttp = Nothing
			Select Case Temp
			Case "NotConnected"	' Internet 
				MsgBox(MsgList(7),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			Case "NullUrl"	'ַǷΪ
				MsgBox(MsgList(8),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			Case "Timeout"	'Ƿʱ
				Select Case MsgBox(MsgList(4),vbYesNoCancel+vbInformation,MsgList(3))
				Case vbYes
					Temp = InputBox(MsgList(5),MsgList(6),"5")
					If Temp <> "" Then
						WaitTimes = CLng(Temp)
					Else
						Exit Function
					End If
				Case vbCancel
					Exit Function
				End Select
			Case Else	'ǷΪ
				If Trim(Temp) = "" Then
					MsgBox(MsgList(9),vbOkOnly+vbInformation,MsgList(0))
					Exit Function
				End If
			End Select
			'ѡ
			If DlgValue("KeepSet") = 1 Then
				If ArrayComp(tSelected,tSelectedBak) = True Then
			 		If WriteEngineSet(tWriteLoc,"Main") = False Then
						MsgBox Replace$(MsgList(2),"%s",tWriteLoc),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Else
						tSelectedBak = tSelected
					End If
				End If
			End If
			EngineListBak = EngineList
			MainDlgFunc = False
			Exit Function
		Case "SaveButton"
			If ArrayComp(tSelected,tSelectedBak) = True Then
				If WriteEngineSet(tWriteLoc,"Main") = False Then
					If getMsgList(UIDataList,MsgList,"MainDlgFunc",0) = False Then Exit Function
					MsgBox Replace$(MsgList(2),"%s",tWriteLoc),vbOkOnly+vbInformation,MsgList(0)
				Else
					tSelectedBak = tSelected
					DlgEnable "SaveButton",False
				End If
			End If
			Exit Function
		Case "Menu", "Dialog", "Strings", "AccTable", "Versions", "Other"
			If DlgValue("Menu") + DlgValue("Dialog") + DlgValue("Strings") + DlgValue("AccTable") + _
				DlgValue("Versions") + DlgValue("Other") = 0 Then
				If DlgValue("Seleted") = 0 Then DlgValue "AllType",1
			Else
				DlgValue "AllType",0
				DlgValue "Seleted",0
			End If
		Case "AllType"
			If DlgValue("AllType") = 1 Then
				DlgValue "Menu",0
				DlgValue "Dialog",0
				DlgValue "Strings",0
				DlgValue "AccTable",0
				DlgValue "Versions",0
				DlgValue "Other",0
				DlgValue "Seleted",0
			End If
		Case "Seleted"
			If DlgValue("Seleted") = 1 Then
				DlgValue "AllType",0
				DlgValue "Menu",0
				DlgValue "Dialog",0
				DlgValue "Strings",0
				DlgValue "AccTable",0
				DlgValue "Versions",0
				DlgValue "Other",0
			Else
				DlgValue "AllType",1
			End If
		Case "AutoSelection"
			If DlgValue("AutoSelection") = 1 Then
				'ȡĿ
				With LangPair
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
					If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
					If .UseCode = "" Or .UseCode = "zh" Then
						.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
						Select Case .UseCode
						Case "zh-CHS" ,"zh-SG"
							.UseCode = "zh-CN"
						Case "zh-CHT", "zh-HK", "zh-MO"
							.UseCode = "zh-TW"
						End Select
					Else
						.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					End If
					DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
					DlgEnable "CheckList",False
				End With
			Else
				DlgValue "CheckList",StrToLong(tSelected(2))
				DlgEnable "CheckList",True
			End If
		Case "SrcEditButton", "TrnEditButton"
			If DlgItem$ = "SrcEditButton" Then
				Call Projects(DlgValue("SrcProjectList"))
			Else
				Call Projects(DlgValue("TrnProjectList"))
			End If
			TempList = getSetNameList(ProjectList)
			DlgListBoxArray "SrcProjectList",TempList()
			DlgListBoxArray "TrnProjectList",TempList()
			DlgValue "SrcProjectList",StrToLong(tSelected(18))
			DlgValue "TrnProjectList",StrToLong(tSelected(22))
			If DlgText("SrcProjectList") = "" Then DlgValue "SrcProjectList",0
			If DlgText("TrnProjectList") = "" Then DlgValue "TrnProjectList",0
		Case "SetButton"
			Temp = tSelected(0)
			ReDim tmpLFList(0) As LOG_FONT
			tmpLFList(0) = LFList(0)
			Call Settings(DlgValue("EngineList"),DlgValue("CheckList"),0)
			TempList = getSetNameList(EngineList)
			DlgListBoxArray "EngineList",TempList()
			DlgText "EngineList",tSelected(1)
			If DlgValue("EngineList") < 0 Then DlgValue "EngineList",0
			TempList = getSetNameList(CheckList)
			DlgListBoxArray "CheckList",TempList()
			If DlgValue("AutoSelection") = 1 Then
				'ȡĿ
				With LangPair
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
					If .UseCode = "zh" Or .UseCode = "ja" Or .UseCode = "ko" Then .Name = "Asia"
					If .UseCode = "" Or .UseCode = "zh" Then
						.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
						Select Case .UseCode
						Case "zh-CHS" ,"zh-SG"
							.UseCode = "zh-CN"
						Case "zh-CHT", "zh-HK", "zh-MO"
							.UseCode = "zh-TW"
						End Select
					Else
						.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					End If
					DlgValue "CheckList",getCheckID(CheckList,.UseCode,.Name)
				End With
			Else
				DlgText "CheckList",tSelected(2)
			End If
			If Temp <> tSelected(0) Then
				If getMsgList(UIDataList,MsgList,"MainDlg",1) = True Then
					n = 0
					With PSL.ActiveProject
						ReDim TempList(.TransLists.Count) As String
						For i = 1 To .TransLists.Count
							If .TransLists(i).IsOpen = True Then
							TempList(n) = .TransLists(i).Title & " - " & _
										  PSL.GetLangCode(.TransLists(i).Language.LangID,pslCodeText)
								n = n + 1
							End If
						Next i
						If n > 0 Then
							ReDim Preserve TempList(n - 1) As String
						Else
							ReDim TempList(0) As String
							TempList(0) = trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
						End If
					End With
					DlgText -1,MsgList(1)
					DlgText "Text1",Replace$(MsgList(0),"%s",Version)
					DlgText "Text2",MsgList(2)
					DlgText "Text3",MsgList(3) & Join(TempList,";")

					DlgText "Configuration",MsgList(4)
					TempList = getSetNameList(EngineList)
					DlgListBoxArray "EngineList",TempList()
					DlgText "EngineList",tSelected(1)
					DlgText "SrcLang",MsgList(5)

					DlgText "StrTypeSelection",MsgList(6)
					DlgText "AllType",MsgList(7)
					DlgText "Menu",MsgList(8)
					DlgText "Dialog",MsgList(9)
					DlgText "Strings",MsgList(10)
					DlgText "AccTable",MsgList(11)
					DlgText "Versions",MsgList(12)
					DlgText "Other",MsgList(13)
					DlgText "Seleted",MsgList(14)

					DlgText "SkipSelection",MsgList(15)
					DlgText "ForReview",MsgList(16)
					DlgText "Validated",MsgList(17)
					DlgText "NotTran",MsgList(18)
					DlgText "NumAndSymbol",MsgList(19)
					DlgText "AllUCase",MsgList(20)
					DlgText "AllLCase",MsgList(21)

					DlgText "PreProcessing",MsgList(22)
					DlgText "CheckConfigText",MsgList(23)
					DlgText "PreTrnText",MsgList(24)
					DlgText "AppTrnText",MsgList(25)
					DlgText "LineText1",String$(200,MsgList(26))
					DlgText "LineText2",String$(200,MsgList(26))
					TempList = getSetNameList(CheckList)
					DlgListBoxArray "CheckList",TempList()
					DlgText "CheckList",tSelected(2)
					DlgText "AutoSelection",MsgList(27)
					DlgText "SrcEditButton",MsgList(28)
					DlgText "TrnEditButton",MsgList(28)
					DlgText "CheckSrc",MsgList(29)
					DlgText "PreStrRep",MsgList(30)
					DlgText "SplitTran",MsgList(31)
					DlgText "CheckTrn",MsgList(32)
					DlgText "AppStrRep",MsgList(33)
					DlgText "TranComment",MsgList(34)
					TempList = getSetNameList(ProjectList)
					DlgListBoxArray "SrcProjectList",TempList()
					DlgListBoxArray "TrnProjectList",TempList()
					DlgValue "SrcProjectList",StrToLong(tSelected(18))
					DlgValue "TrnProjectList",StrToLong(tSelected(22))

					DlgText "KeepSet",MsgList(35)
					DlgText "ShowMsg",MsgList(36)
					DlgText "HelpButton",MsgList(37)
					DlgText "SetButton",MsgList(38)
					DlgText "SaveButton",MsgList(39)
				End If
			End If
			DlgEnable "OKButton",CheckEngineSet(EngineList,DlgValue("EngineList"))
			If CheckCheckSet(CheckList,DlgValue("CheckList")) = False Then
				DlgValue "CheckSrc",0
				DlgValue "PreStrRep",0
				DlgValue "CheckTrn",0
				DlgValue "AppStrRep",0
				DlgEnable "CheckSrc",False
				DlgEnable "PreStrRep",False
				DlgEnable "CheckTrn",False
				DlgEnable "AppStrRep",False
			Else
				DlgEnable "CheckSrc",True
				DlgEnable "PreStrRep",True
				DlgEnable "CheckTrn",True
				DlgEnable "AppStrRep",True
			End If
			'ж϶ԻǷѱı
			If FontComp(LFList(0),tmpLFList(0)) = True Then
				n = CLng(DlgText("SuppValueBox"))
				j = CreateFont(n,LFList(0))
				If j = 0 Then Exit Function
				For i = 0 To DlgCount() - 1
					SendMessageLNG(GetDlgItem(n,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
				Next i
				DrawWindow(n,j)
			End If
		End Select
		tSelected(1) = DlgText("EngineList")
		tSelected(2) = DlgText("CheckList")
		tSelected(3) = DlgValue("AllType")
		tSelected(4) = DlgValue("Menu")
		tSelected(5) = DlgValue("Dialog")
		tSelected(6) = DlgValue("Strings")
		tSelected(7) = DlgValue("AccTable")
		tSelected(8) = DlgValue("Versions")
		tSelected(9) = DlgValue("Other")
		tSelected(10) = DlgValue("Seleted")
		tSelected(11) = DlgValue("ForReview")
		tSelected(12) = DlgValue("Validated")
		tSelected(13) = DlgValue("NotTran")
		tSelected(14) = DlgValue("NumAndSymbol")
		tSelected(15) = DlgValue("AllUCase")
		tSelected(16) = DlgValue("AllLCase")
		tSelected(17) = DlgValue("AutoSelection")
		tSelected(18) = DlgValue("SrcProjectList")
		tSelected(19) = DlgValue("CheckSrc")
		tSelected(20) = DlgValue("PreStrRep")
		tSelected(21) = DlgValue("SplitTran")
		tSelected(22) = DlgValue("TrnProjectList")
		tSelected(23) = DlgValue("CheckTrn")
		tSelected(24) = DlgValue("AppStrRep")
		tSelected(25) = DlgValue("KeepSet")
		tSelected(26) = DlgValue("ShowMsg")
		tSelected(27) = DlgValue("TranComment")
		DlgEnable "SaveButton",ArrayComp(tSelected,tSelectedBak,"1-" & CStr$(UBound(tSelected)))
	End Select
End Function


'Զ
Private Function Projects(ByVal ProjectID As Long) As Long
	Dim MsgList() As String,TempList(2) As String,TempArry() As String
	Projects = ProjectID
	If getMsgList(UIDataList,MsgList,"Projects",1) = False Then Exit Function
	TempArry = getSetNameList(ProjectList)
	TempList(0) = MsgList(23)
	TempList(1) = MsgList(24)
	TempList(2) = MsgList(25)
	Begin Dialog UserDialog 660,518,MsgList(0),.ProjectsFunc ' %GRID:10,7,1,1
		Text 20,7,620,28,MsgList(1),.MainText

		GroupBox 20,42,360,77,MsgList(2),.GroupBox1
		DropListBox 40,63,290,21,TempArry(),.ProjectList
		PushButton 330,63,30,21,MsgList(3),.NextSetType
		PushButton 40,91,90,21,MsgList(4),.AddButton
		PushButton 155,91,90,21,MsgList(5),.ChangButton
		PushButton 270,91,90,21,MsgList(6),.DelButton

		GroupBox 390,42,250,77,MsgList(7),.GroupBox2
		OptionGroup .cWriteType
			OptionButton 410,66,100,14,MsgList(8),.cWriteToFile
			OptionButton 520,66,100,14,MsgList(9),.cWriteToRegistry
		PushButton 410,91,90,21,MsgList(10),.ImportButton
		PushButton 530,91,90,21,MsgList(11),.ExportButton

		GroupBox 20,133,620,161,MsgList(12),.GroupBox3
		Text 40,154,160,14,MsgList(13),.ItemText
		Text 210,154,130,14,MsgList(14),.inSourceText
		Text 350,154,130,14,MsgList(15),.inTargetText
		Text 490,154,130,14,MsgList(16),.inBothText
		Text 40,178,160,14,MsgList(17),.PreSpaceText
		Text 40,199,160,14,MsgList(18),.EndSpaceText
		Text 40,220,160,14,MsgList(19),.acckeyText
		Text 40,241,160,14,MsgList(20),.EndStringText
		Text 40,262,160,14,MsgList(21),.ShortcutText
		CheckBox 210,175,120,21,MsgList(22),.PreSpaceinSourceBox
		CheckBox 350,175,120,21,MsgList(25),.PreSpaceinTargetBox
		DropListBox 490,175,130,21,TempList(),.PreSpaceinBothBox
		CheckBox 210,196,120,21,MsgList(22),.EndSpaceinSourceBox
		CheckBox 350,196,120,21,MsgList(25),.EndSpaceinTargetBox
		DropListBox 490,196,130,21,TempList(),.EndSpaceinBothBox
		CheckBox 210,217,120,21,MsgList(22),.AcckeyinSourceBox
		CheckBox 350,217,120,21,MsgList(25),.AcckeyinTargetBox
		DropListBox 490,217,130,21,TempList(),.AcckeyinBothBox
		CheckBox 210,238,120,21,MsgList(22),.EndStringinSourceBox
		CheckBox 350,238,120,21,MsgList(25),.EndStringinTargetBox
		DropListBox 490,238,130,21,TempList(),.EndStringinBothBox
		CheckBox 210,259,120,21,MsgList(22),.ShortcutinSourceBox
		CheckBox 350,259,120,21,MsgList(25),.ShortcutinTargetBox
		DropListBox 490,259,130,21,TempList(),.ShortcutinBothBox

		GroupBox 20,301,620,175,MsgList(26),.GroupBox4
		CheckBox 40,322,580,14,MsgList(27),.DelSpaceBox
		CheckBox 40,343,580,14,MsgList(28),.SpaceForEnAndAsiaBox
		CheckBox 40,364,580,14,MsgList(29),.EnableStringSplitBox
		CheckBox 40,385,580,14,MsgList(30),.TranEndStringBox
		CheckBox 40,406,580,14,MsgList(31),.AcckeyInShortcutBox
		CheckBox 40,427,580,14,MsgList(33),.ApplyCheckResultBox
		CheckBox 40,448,580,14,MsgList(32),.ShowOriginalTranBox

		PushButton 20,490,90,21,MsgList(34),.HelpButton
		PushButton 120,490,100,21,MsgList(35),.ResetButton
		PushButton 330,490,90,21,MsgList(36),.TestButton
		PushButton 230,490,90,21,MsgList(37),.CleanButton
		OKButton 460,490,90,21,.OKButton
		CancelButton 560,490,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.ProjectList = ProjectID
	If Dialog(dlg) = 0 Then Exit Function
	Projects = dlg.ProjectList
End Function


Private Function ProjectsFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long
	Dim TempList() As String,MsgList() As String,Temp As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		DlgEnable "ShowOriginalTranBox",False
		Select Case cWriteLoc
		Case CheckFilePath
			DlgValue "cWriteType",0
		Case CheckRegKey
			DlgValue "cWriteType",1
		Case Else
			DlgValue "cWriteType",0
		End Select

		j = DlgValue("ProjectList")
		TempList = getSetNameList(ProjectList)
		If j < 0 Then
			DlgValue "ProjectList",0
			j = 0
		End If
		If CheckArray(TempList) = True Then
			With ProjectList(j)
				DlgValue "PreSpaceinSourceBox",.PreSpaceInSource
				DlgValue "PreSpaceinTargetBox",.PreSpaceInTarget
				DlgValue "PreSpaceinBothBox",.PreSpaceInBoth
				DlgValue "EndSpaceinSourceBox",.EndSpaceInSource
				DlgValue "EndSpaceinTargetBox",.EndSpaceInTarget
				DlgValue "EndSpaceinBothBox",.EndSpaceInBoth
				DlgValue "AcckeyinSourceBox",.AcckeyInSource
				DlgValue "AcckeyinTargetBox",.AcckeyInTarget
				DlgValue "AcckeyinBothBox",.AcckeyInBoth
				DlgValue "EndStringinSourceBox",.EndStrInSource
				DlgValue "EndStringinTargetBox",.EndStrInTarget
				DlgValue "EndStringinBothBox",.EndStrInBoth
				DlgValue "ShortcutinSourceBox",.ShortcutInSource
				DlgValue "ShortcutinTargetBox",.ShortcutInTarget
				DlgValue "ShortcutinBothBox",.ShortcutInBoth
				DlgValue "DelSpaceBox",.DelSpace
				DlgValue "EnableStringSplitBox",.EnableStrSplit
				DlgValue "TranEndStringBox",.TranEndStr
				DlgValue "AcckeyInShortcutBox",.UseAcckeyInShortcut
				DlgValue "ShowOriginalTranBox",.ShowOriginalTran
				DlgValue "ApplyCheckResultBox",.ApplyCheckResult
				DlgValue "SpaceForEnAndAsiaBox",.SpaceForEnAndAsia
			End With
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = ProjectList(j).Name Then
					DlgEnable "ChangButton",False
					DlgEnable "DelButton",False
					Exit For
				End If
			Next i
			If DlgEnable("DelButton") = True Then
				If UBound(CheckList) = 0 Then DlgEnable "DelButton",False
			End If
		Else
			DlgEnable "ChangButton",False
			DlgEnable "DelButton",False
		End If
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		ProjectsFunc = True 'ֹ°ťرնԻ򴰿
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		Select Case DlgItem$
		Case "HelpButton"
			Call Help("ProjectHelp")
			Exit Function
		Case "OKButton"
			Temp = IIf(DlgValue("cWriteType") = 0,CheckFilePath,CheckRegKey)
			If WriteCheckSet(Temp,"Project") = False Then
				MsgBox Replace$(MsgList(20),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
			Else
				ProjectListBak = ProjectList
				ProjectsFunc = False
			End If
			Exit Function
		Case "CancelButton"
			ProjectList = ProjectListBak
			ProjectsFunc = False
			Exit Function
		Case "NextSetType"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			If j < UBound(ProjectList) Then j = j + 1 Else j = 0
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "AddButton"
			TempList = getSetNameList(ProjectList)
			Temp = AddSet(TempList)
			If Temp = "" Then Exit Function
			j = 0
			If CheckArray(TempList) = True Then
				j = UBound(ProjectList) + 1
			End If
			ReDim Preserve TempList(j) As String,ProjectList(j) As CHECK_PROJECT_SET
			TempList(j) = Temp
			ProjectList(j).Name = Temp
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "ChangButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			TempList = getSetNameList(ProjectList)
			Temp = EditSet(TempList,j)
			If Temp = "" Then Exit Function
			TempList(j) = Temp
			ProjectList(j).Name = Temp
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			Exit Function
    	Case "DelButton"
    		j = DlgValue("ProjectList")
    		If j < 0 Then Exit Function
			If MsgBox(Replace(MsgList(12),"%s",DlgText("ProjectList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then
				Exit Function
			End If
			Call DelProjectArray(ProjectList,j)
			If j > 0 Then j = j - 1
			TempList = getSetNameList(ProjectList)
			DlgListBoxArray "ProjectList",TempList()
			DlgValue "ProjectList",j
			DlgItem$ = "ProjectList"
		Case "ResetButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			ReDim TempList(1)
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = ProjectList(j).Name Then
					TempList(0) = MsgList(1)
					Exit For
				End If
			Next i
			TempList(1) = MsgList(2)
			For i = 0 To UBound(ProjectList)
				If i <> j Then
					ReDim Preserve TempList(i + 2) As String
					TempList(i + 2) = MsgList(3) & " - " & ProjectList(i).Name
				End If
			Next i
			i = ShowPopupMenu(TempList,vbPopupUseRightButton)
			Select Case i
			Case Is < 0
				Exit Function
			Case 0
				ProjectList(j) = DefaultCheckSet(DlgText("ProjectList"),True)
				ProjectList(j).Name = DlgText("ProjectList")
			Case 1
				For n = 0 To UBound(ProjectListBak)
					If ProjectListBak(n).Name = ProjectList(j).Name Then
						ProjectList(j) = ProjectListBak(n)
						Exit For
					End If
				Next n
			Case Else
				Temp = Mid(TempList(i),InStr(TempList(i),MsgList(3) & " - ") + Len(MsgList(3) & " - "))
				For n = 0 To UBound(ProjectList)
					If ProjectList(n).Name = Temp Then
						ProjectList(j) = ProjectList(n)
						ProjectList(j).Name = DlgText("ProjectList")
						Exit For
					End If
				Next n
			End Select
			DlgItem$ = "ProjectList"
	    Case "CleanButton"
	    	j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			With ProjectList(i)
		    	.PreSpaceInSource = 0
				.PreSpaceInTarget = 0
				.PreSpaceInBoth = 0
				.EndSpaceInSource = 0
				.EndSpaceInTarget = 0
				.EndSpaceInBoth = 0
				.AcckeyInSource = 0
				.AcckeyInTarget = 0
				.AcckeyInBoth = 0
				.EndStrInSource = 0
				.EndStrInTarget = 0
				.EndStrInBoth = 0
				.ShortcutInSource = 0
				.ShortcutInTarget = 0
				.ShortcutInBoth = 0
				.DelSpace = 0
				.EnableStrSplit = 0
				.TranEndStr = 0
				.UseAcckeyInShortcut = 0
				.ShowOriginalTran = 0
				.ApplyCheckResult = 0
				.SpaceForEnAndAsia = 0
			End With
			DlgItem$ = "ProjectList"
		Case "ImportButton"
			If PSL.SelectFile(Temp,True,Replace$(MsgList(25),"%s",MsgList(15)),MsgList(23)) = False Then Exit Function
			Select Case GetCheckSet("Project",Temp)
			Case -1
				Exit Function
			Case 3
				TempList = getSetNameList(ProjectList)
				DlgListBoxArray "ProjectList",TempList()
				DlgValue "ProjectList",0
				MsgBox MsgList(19),vbOkOnly+vbInformation,MsgList(17)
				DlgItem$ = "ProjectList"
			Case Else
				MsgBox Replace$(MsgList(21),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End Select
		Case "ExportButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			For i = 0 To UBound(CheckList)
				If CheckCheckSet(CheckList,i) = False Then
					If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
						Exit Function
					End If
				End If
			Next i
			If PSL.SelectFile(Temp,False,Replace$(MsgList(25),"%s",MsgList(15)),MsgList(24)) = True Then
				If InStr(Temp,".dat") = 0 Then Temp = Temp & ".dat"
				If WriteCheckSet(Temp,"Sets",3) = False Then
					MsgBox Replace$(MsgList(22),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Else
					MsgBox MsgList(18),vbOkOnly+vbInformation,MsgList(17)
				End If
			End If
			Exit Function
		Case "TestButton"
			j = DlgValue("ProjectList")
			If j < 0 Then Exit Function
			For i = 0 To UBound(CheckList)
				If CheckCheckSet(CheckList,i) = False Then
					If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
						Exit Function
					End If
				End If
			Next i
			n = -1
			For i = 0 To UBound(CheckList)
				If CheckList(i).Name = cSelected(2) Then
					If n = -1 Then n = i
				End If
			Next i
			If n < 0 Then n = 0
			Call CheckTest(n,j)
			Exit Function
		End Select

		j = DlgValue("ProjectList")
		If j < 0 Then Exit Function
		With ProjectList(j)
			If DlgItem$ = "ProjectList" Then
				DlgValue "PreSpaceinSourceBox",.PreSpaceInSource
				DlgValue "PreSpaceinTargetBox",.PreSpaceInTarget
				DlgValue "PreSpaceinBothBox",.PreSpaceInBoth
				DlgValue "EndSpaceinSourceBox",.EndSpaceInSource
				DlgValue "EndSpaceinTargetBox",.EndSpaceInTarget
				DlgValue "EndSpaceinBothBox",.EndSpaceInBoth
				DlgValue "AcckeyinSourceBox",.AcckeyInSource
				DlgValue "AcckeyinTargetBox",.AcckeyInTarget
				DlgValue "AcckeyinBothBox",.AcckeyInBoth
				DlgValue "EndStringinSourceBox",.EndStrInSource
				DlgValue "EndStringinTargetBox",.EndStrInTarget
				DlgValue "EndStringinBothBox",.EndStrInBoth
				DlgValue "ShortcutinSourceBox",.ShortcutInSource
				DlgValue "ShortcutinTargetBox",.ShortcutInTarget
				DlgValue "ShortcutinBothBox",.ShortcutInBoth
				DlgValue "DelSpaceBox",.DelSpace
				DlgValue "EnableStringSplitBox",.EnableStrSplit
				DlgValue "TranEndStringBox",.TranEndStr
				DlgValue "AcckeyInShortcutBox",.UseAcckeyInShortcut
				DlgValue "ShowOriginalTranBox",.ShowOriginalTran
				DlgValue "ApplyCheckResultBox",.ApplyCheckResult
				DlgValue "SpaceForEnAndAsiaBox",.SpaceForEnAndAsia
			Else
				.PreSpaceInSource = DlgValue("PreSpaceinSourceBox")
				.PreSpaceInTarget = DlgValue("PreSpaceinTargetBox")
				.PreSpaceInBoth = DlgValue("PreSpaceinBothBox")
				.EndSpaceInSource = DlgValue("EndSpaceinSourceBox")
				.EndSpaceInTarget = DlgValue("EndSpaceinTargetBox")
				.EndSpaceInBoth = DlgValue("EndSpaceinBothBox")
				.AcckeyInSource = DlgValue("AcckeyinSourceBox")
				.AcckeyInTarget = DlgValue("AcckeyinTargetBox")
				.AcckeyInBoth = DlgValue("AcckeyinBothBox")
				.EndStrInSource = DlgValue("EndStringinSourceBox")
				.EndStrInTarget = DlgValue("EndStringinTargetBox")
				.EndStrInBoth = DlgValue("EndStringinBothBox")
				.ShortcutInSource = DlgValue("ShortcutinSourceBox")
				.ShortcutInTarget = DlgValue("ShortcutinTargetBox")
				.ShortcutInBoth = DlgValue("ShortcutinBothBox")
				.DelSpace = DlgValue("DelSpaceBox")
				.EnableStrSplit = DlgValue("EnableStringSplitBox")
				.TranEndStr = DlgValue("TranEndStringBox")
				.UseAcckeyInShortcut = DlgValue("AcckeyInShortcutBox")
				.ShowOriginalTran = DlgValue("ShowOriginalTranBox")
				.ApplyCheckResult = DlgValue("ApplyCheckResultBox")
				.SpaceForEnAndAsia = DlgValue("SpaceForEnAndAsiaBox")
			End If
			n = -1
			For i = 0 To UBound(DefaultProjectList)
				If DefaultProjectList(i) = .Name Then
					n = i
					Exit For
				End If
			Next i
			If n > -1 Then
				DlgEnable "ChangButton",False
				DlgEnable "DelButton",False
			Else
				DlgEnable "ChangButton",True
				DlgEnable "DelButton",IIf(UBound(ProjectList) = 0,False,True)
			End If
		End With
	End Select
End Function


'Զ
Private Function Settings(ByVal EngineID As Long,ByVal CheckID As Long,ByVal OptionID As Long) As Long
	Dim MsgList() As String,TempList() As String,TempArry() As String
	Settings = EngineID
	If getMsgList(UIDataList,MsgList,"Settings",1) = False Then Exit Function
	TempList = getSetNameList(EngineList)
	TempArry = getSetNameList(CheckList)
	Begin Dialog UserDialog 660,518,MsgList(0),.SettingsDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		Text 20,7,620,28,MsgList(1),.MainText
		OptionGroup .Options
			OptionButton 80,42,130,14,MsgList(75),.TrnEngine
			OptionButton 220,42,130,14,MsgList(2),.StrHandle
			OptionButton 360,42,130,14,MsgList(3),.AutoUpdate
			OptionButton 500,42,130,14,MsgList(4),.UILangListSet

		GroupBox 20,70,360,77,MsgList(5),.GroupBox1
		DropListBox 40,91,290,21,TempList(),.EngineList
		DropListBox 40,91,290,21,TempArry(),.CheckList
		PushButton 330,91,30,21,MsgList(6),.LevelButton
		PushButton 40,119,90,21,MsgList(7),.AddButton
		PushButton 155,119,90,21,MsgList(8),.ChangButton
		PushButton 270,119,90,21,MsgList(9),.DelButton

		GroupBox 390,70,250,77,MsgList(10),.GroupBox2
		OptionGroup .tWriteType
			OptionButton 410,94,110,14,MsgList(11),.tWriteToFile
			OptionButton 520,94,110,14,MsgList(12),.tWriteToRegistry
		OptionGroup .cWriteType
			OptionButton 410,94,100,14,MsgList(11),.cWriteToFile
			OptionButton 520,94,100,14,MsgList(12),.cWriteToRegistry
		PushButton 410,119,90,21,MsgList(13),.ImportButton
		PushButton 530,119,90,21,MsgList(14),.ExportButton

		GroupBox 20,189,620,287,MsgList(15),.GroupBox4
		OptionGroup .Engine
			OptionButton 110,161,160,14,MsgList(76),.EngineArgument
			OptionButton 280,161,160,14,MsgList(77),.LangCodePair
			OptionButton 450,161,160,14,MsgList(78),.EngineEnable

		Text 40,255,120,14,"",.ObjectNameText
		Text 40,213,120,14,MsgList(80),.AppIDText
		Text 40,234,120,14,MsgList(87),.SignText
		Text 40,255,120,14,MsgList(79),.MD5Text
		Text 40,276,120,14,MsgList(81),.UrlText
		Text 40,297,120,14,MsgList(82),.UrlTemplateText
		Text 40,318,120,14,MsgList(83),.bstrMethodText
		Text 340,318,120,14,MsgList(84),.varAsyncText
		Text 40,339,120,14,MsgList(85),.bstrUserText
		Text 340,339,120,14,MsgList(86),.bstrPasswordText
		Text 40,360,120,14,MsgList(88),.RequestHeaderText
		Text 40,378,120,14,MsgList(89),.RequestHeaderText2
		Text 40,401,120,14,MsgList(90),.responseTypeText
		Text 40,423,120,14,MsgList(91),.TranBeforeStrText
		Text 40,444,120,14,MsgList(92),.TranAfterStrText
		TextBox 170,203,450,21,.ObjectNameBox
		TextBox 170,210,450,21,.AppIDBox
		TextBox 170,231,450,21,.SignBox,-1
		TextBox 170,252,420,21,.MD5Box
		TextBox 170,273,450,21,.UrlBox
		TextBox 170,294,420,21,.UrlTemplateBox
		TextBox 170,315,130,21,.bstrMethodBox
		TextBox 460,315,130,21,.varAsyncBox
		TextBox 170,336,160,21,.bstrUserBox
		TextBox 460,336,160,21,.bstrPasswordBox,-1
		TextBox 170,357,420,42,.RequestHeaderBox,1
		TextBox 170,399,420,21,.responseTypeBox
		TextBox 170,420,420,21,.TranBeforeStrBox
		TextBox 170,441,420,21,.TranAfterStrBox
		PushButton 590,252,30,21,MsgList(69),.MD5Button
		PushButton 590,294,30,21,MsgList(69),.UrlTemplateButton
		PushButton 300,315,30,21,MsgList(69),.bstrMethodButton
		PushButton 590,315,30,21,MsgList(69),.varAsyncButton
		PushButton 590,357,30,21,MsgList(69),.RequestButton
		PushButton 590,399,30,21,MsgList(69),.responseTypeButton
		PushButton 590,420,30,21,MsgList(69),.TranBeforeStrButton
		PushButton 590,441,30,21,MsgList(69),.TranAfterStrButton

		Text 40,203,220,14,MsgList(93),.LngNameText
		Text 270,203,100,14,MsgList(94),.SrcLngText
		Text 380,203,100,14,MsgList(95),.TranLngText
		ListBox 40,217,220,245,TempList(),.LngNameList
		ListBox 270,217,100,245,TempList(),.SrcLngList
		ListBox 380,217,100,245,TempList(),.TranLngList
		PushButton 500,217,120,21,MsgList(07),.AddLngButton
		PushButton 500,238,120,21,MsgList(09),.DelLngButton
		PushButton 500,259,120,21,MsgList(96),.DelAllButton
		PushButton 500,294,120,21,MsgList(97),.EditLngButton
		PushButton 500,315,120,21,MsgList(98),.ExtEditButton
		PushButton 500,336,120,21,MsgList(99),.NullLngButton
		PushButton 500,357,120,21,MsgList(100),.ResetLngButton
		PushButton 500,399,120,21,MsgList(101),.ShowNoNullLngButton
		PushButton 500,420,120,21,MsgList(102),.ShowNullLngButton
		PushButton 500,441,120,21,MsgList(103),.ShowAllLngButton

		Text 40,210,580,70,MsgList(104),.EnableText1
		Text 40,287,580,70,MsgList(105),.EnableText2
		CheckBox 220,378,330,14,MsgList(106),.EnableBox

		GroupBox 20,189,620,287,MsgList(15),.GroupBox3
		Text 30,164,190,14,MsgList(16),.SetItemText,1
		DropListBox 240,161,250,21,TempList(),.SetType
		PushButton 490,161,30,21,MsgList(17),.NextSetType

		Text 40,210,580,14,MsgList(18),.AccKeyBoxTxt
		Text 40,259,580,14,MsgList(19),.ExCrBoxTxt
		Text 40,308,580,14,MsgList(20),.ChkBktBoxTxt
		Text 40,357,580,14,MsgList(21),.KpPairBoxTxt
		TextBox 40,231,580,21,.AccKeyBox
		TextBox 40,280,580,21,.ExCrBox,1
		TextBox 40,329,580,21,.ChkBktBox
		TextBox 40,378,580,42,.KpPairBox,1
		CheckBox 40,427,580,14,MsgList(22),.AsiaKeyBox
		CheckBox 40,448,580,14,MsgList(23),.AddAcckeyBox

		Text 40,210,580,14,MsgList(24),.ChkEndBoxTxt
		Text 40,294,580,14,MsgList(25),.NoTrnEndBoxTxt
		Text 40,378,580,14,MsgList(26),.AutoTrnEndBoxTxt
		TextBox 40,231,580,56,.ChkEndBox,1
		TextBox 40,315,580,56,.NoTrnEndBox,1
		TextBox 40,399,580,63,.AutoTrnEndBox,1

		Text 40,210,580,14,MsgList(27),.ShortBoxTxt
		Text 40,259,580,14,MsgList(28),.ShortKeyBoxTxt
		Text 40,371,580,14,MsgList(29),.KpShortKeyBoxTxt
		TextBox 40,231,580,21,.ShortBox
		TextBox 40,280,580,84,.ShortKeyBox,1
		TextBox 40,392,580,70,.KpShortKeyBox,1

		Text 40,210,580,14,MsgList(30),.PreRepStrBoxTxt
		Text 40,336,580,14,MsgList(31),.AutoWebFlagBoxTxt
		TextBox 40,231,580,98,.PreRepStrBox,1
		TextBox 40,357,580,105,.AutoWebFlagBox,1

		Text 40,210,580,77,MsgList(32),.LineSplitBoxTxt
		Text 40,294,580,14,MsgList(33),.PreInsertSplitBoxTxt
		Text 40,343,580,14,MsgList(34),.AppInsertSplitBoxTxt
		Text 40,392,580,14,MsgList(35),.ReplaceSplitBoxTxt
		TextBox 40,315,580,21,.PreInsertSplitBox
		TextBox 40,364,580,21,.AppInsertSplitBox
		TextBox 40,413,580,21,.ReplaceSplitBox
		CheckBox 40,448,580,14,MsgList(36),.LineSplitModeBox

		Text 40,203,200,14,MsgList(37),.AppLngText
		Text 420,203,200,14,MsgList(38),.UseLngText
		ListBox 40,217,200,245,TempList(),.AppLngList
		ListBox 420,217,200,245,TempList(),.UseLngList
		PushButton 260,217,140,21,MsgList(39),.AddLangButton
		PushButton 260,238,140,21,MsgList(40),.AddAllLangButton
		PushButton 260,266,140,21,MsgList(41),.DelLangButton
		PushButton 260,287,140,21,MsgList(42),.DelAllLangButton
		PushButton 260,322,140,21,MsgList(43),.SetAppLangButton
		PushButton 260,343,140,21,MsgList(44),.EditAppLangButton
		PushButton 260,364,140,21,MsgList(45),.DelAppLangButton
		PushButton 260,399,140,21,MsgList(46),.SetUseLangButton
		PushButton 260,420,140,21,MsgList(47),.EditUseLangButton
		PushButton 260,441,140,21,MsgList(48),.DelUseLangButton

		GroupBox 20,70,620,91,MsgList(49),.UpdateSetGroup
		OptionGroup .UpdateSet
			OptionButton 40,91,580,14,MsgList(50),.AutoButton
			OptionButton 40,112,580,14,MsgList(51),.ManualButton
			OptionButton 40,133,580,14,MsgList(52),.OffButton
		GroupBox 20,175,620,49,MsgList(53),.CheckGroup
		Text 40,196,100,14,MsgList(54),.UpdateCycleText
		TextBox 150,192,40,21,.UpdateCycleBox
		Text 200,196,60,14,MsgList(55),.UpdateDatesText
		Text 280,196,130,14,MsgList(56),.UpdateDateText
		TextBox 420,192,100,21,.UpdateDateBox
		PushButton 540,192,80,21,MsgList(57),.CheckButton
		GroupBox 20,238,620,98,MsgList(58),.WebSiteGroup
		TextBox 40,259,580,63,.WebSiteBox,1
		GroupBox 20,350,620,126,MsgList(59),.CmdGroup
		Text 40,371,550,14,MsgList(60),.CmdPathBoxText
		Text 40,420,550,14,MsgList(61),.ArgumentBoxText
		TextBox 40,392,550,21,.CmdPathBox
		TextBox 40,441,550,21,.ArgumentBox
		PushButton 590,392,30,21,MsgList(6),.ExeBrowseButton
		PushButton 590,441,30,21,MsgList(62),.ArgumentButton

		GroupBox 20,70,620,280,MsgList(63),.UILangSetGroup
		Text 40,91,580,147,MsgList(64),.UILangSetText1
		Text 40,255,130,14,MsgList(65),.UILangSetText2
		DropListBox 180,252,360,21,TempList(),.UILangList
		Text 40,294,580,42,MsgList(66),.UILangSetText3

		GroupBox 20,364,620,112,MsgList(67),.UIFontSetGroup
		Text 40,388,130,14,MsgList(68),.MainFontText
		TextBox 180,385,360,21,.MainFontBox
		PushButton 540,385,30,21,MsgList(69),.MainFontButton

		PushButton 20,490,90,21,MsgList(70),.HelpButton
		PushButton 120,490,100,21,MsgList(71),.ResetButton
		PushButton 330,490,90,21,MsgList(72),.TestButton
		PushButton 230,490,90,21,MsgList(73),.CleanButton
		PushButton 120,490,160,21,MsgList(74),.EditUILangButton
		OKButton 460,490,90,21,.OKButton
		CancelButton 560,490,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.EngineList = EngineID
	dlg.CheckList = CheckID
	dlg.Options = OptionID
	If Dialog(dlg) = 0 Then Exit Function
	Settings = dlg.EngineList
End Function


'ز鿴Ի˽Ϣ
Private Function SettingsDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long,HeaderID As Long,LangPair As LANG_SET
	Dim Temp As String,TempList() As String,MsgList() As String,Dic As Object
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		DlgEnable "MainFontBox",False

		TempList = ReSplit(MsgList(53),";")
		DlgListBoxArray "SetType",TempList()
		DlgValue "SetType",0

		ReDim TempList(UBound(UIFileList) + 2) As String
		n = 1
		For i = 0 To UBound(UIFileList) + 2
			If i = 0 Then
				TempList(i) = MsgList(54)
			ElseIf i = 1 Then
				TempList(i) = MsgList(55)
			ElseIf UIFileList(i - 2).FilePath <> "" Then
				TempList(i) = UIFileList(i - 2).LangName
				n = n + 1
				If tSelected(0) = UIFileList(i - 2).LangID Then j = i
			End If
		Next i
		ReDim Preserve TempList(n) As String
		DlgListBoxArray "UILangList",TempList()
		DlgValue "UILangList",IIf(j < 2,StrToLong(tSelected(0),0),j)
		DlgText "MainFontBox",GetFontText(SuppValue,LFList(0))

		Select Case tWriteLoc
		Case EngineFilePath
			DlgValue "tWriteType",0
		Case EngineRegKey
			DlgValue "tWriteType",1
		Case Else
			DlgValue "tWriteType",0
		End Select

		j = DlgValue("EngineList")
		If j < 0 Then
			DlgValue "EngineList",0
			j = 0
		End If
		If CheckEngineSet(EngineList,j) = True Then
			With EngineList(j)
				DlgText "ObjectNameBox",.HttpName
				DlgText "AppIDBox",.AppId
				DlgText "UrlBox",.url
				DlgText "UrlTemplateBox",.UrlTemplate
				DlgText "bstrMethodBox",.method
				DlgText "varAsyncBox",.Async
				DlgText "bstrUserBox",.User
				DlgText "bstrPasswordBox",.Password
				DlgText "SignBox",.Sign
				DlgText "MD5Box",.MD5
				DlgText "RequestHeaderBox",.RequestHeader
				DlgText "responseTypeBox",.ResponseType
				Select Case DlgText("responseTypeBox")
				Case "responseText"
					DlgText "TranBeforeStrBox",.TranBeforeStrByText
					DlgText "TranAfterStrBox",.TranAfterStrByText
				Case "responseBody"
					DlgText "TranBeforeStrBox",.TranBeforeStrByBody
					DlgText "TranAfterStrBox",.TranAfterStrByBody
				Case "responseStream"
					DlgText "TranBeforeStrBox",.TranBeforeStrByStream
					DlgText "TranAfterStrBox",.TranAfterStrByStream
				Case "responseXML"
					DlgText "TranBeforeStrBox",.TranXMLIDName
					DlgText "TranAfterStrBox",.TranXMLTagName
				End Select
				If DlgText("ObjectNameBox") = "" Then DlgText "ObjectNameBox",DefaultObject
				LngNameList = GetLangSet(.LangPairList,0)
				DlgListBoxArray "LngNameList",LngNameList()
				SrcLngList = GetLangSet(.LangPairList,1)
				DlgListBoxArray "SrcLngList",SrcLngList()
				TranLngList = GetLangSet(.LangPairList,2)
				DlgListBoxArray "TranLngList",TranLngList()
				DlgValue "LngNameList",0
				DlgValue "SrcLngList",0
				DlgValue "TranLngList",0
				DlgValue "EnableBox",.Enable
			End With
		End If
		DlgText "LngNameText",Replace$(MsgList(50),"%s",CStr$(DlgListBoxArray("LngNameList")))

		Select Case cWriteLoc
		Case CheckFilePath
			DlgValue "cWriteType",0
		Case CheckRegKey
			DlgValue "cWriteType",1
		Case Else
			DlgValue "cWriteType",0
		End Select

		j = DlgValue("CheckList")
		If j < 0 Then
			DlgValue "CheckList",0
			j = 0
		End If
		If CheckCheckSet(CheckList,j) = True Then
			With CheckList(j)
				DlgText "ExCrBox",.AccKeyExcludeChar
				DlgText "PreInsertSplitBox",.PreInsertSplitChar
				DlgText "ChkBktBox",.CheckBracket
				DlgText "KpPairBox",.KeepCharPair
				DlgValue "AsiaKeyBox",.ShowAsiaKey
				DlgText "ChkEndBox",.CheckEndChar
				DlgText "NoTrnEndBox",.NotTrnEndChar
				DlgText "AutoTrnEndBox",.AutoTrnEndChar
				DlgText "ShortBox",.CheckShortChar
				DlgText "ShortKeyBox",.CheckShortKey
				DlgText "KpShortKeyBox",.KeepShortKey
				DlgText "PreRepStrBox",.PreRepStr
				DlgText "AutoWebFlagBox",.AppRepStr
				DlgText "AccKeyBox",.AccKeyChar
				DlgValue "AddAcckeyBox",.AccKeyWithFirstChar
				DlgValue "LineSplitModeBox",.LineSplitMode
				DlgText "AppInsertSplitBox",.AppInsertSplitChar
				DlgText "ReplaceSplitBox",.ReplaceSplitChar
				TempList = GetLangSet(.LangPairList,9)
				DlgListBoxArray "AppLngList",TempList()
				TempList = GetLangSet(.LangPairList,10)
				DlgListBoxArray "UseLngList",TempList()
				DlgValue "AppLngList",0
				DlgValue "UseLngList",0
			End With
		End If
		DlgText "AppLngText",Replace$(MsgList(31),"%s",CStr$(DlgListBoxArray("AppLngList")))
		DlgText "UseLngText",Replace$(MsgList(32),"%s",CStr$(DlgListBoxArray("UseLngList")))

		If CheckArray(UpdateSet) = True Then
			DlgValue "UpdateSet",StrToLong(UpdateSet(0))
			DlgText "WebSiteBox",UpdateSet(1)
			DlgText "CmdPathBox",UpdateSet(2)
			DlgText "ArgumentBox",UpdateSet(3)
			DlgText "UpdateCycleBox",UpdateSet(4)
			DlgText "UpdateDateBox",UpdateSet(5)
		End If
		If DlgText("UpdateDateBox") = "" Then DlgText "UpdateDateBox",MsgList(4)
		DlgEnable "UpdateDateBox",False

		Select Case DlgValue("Options")
		Case 0
			j = -1
			n = DlgValue("EngineList")
			If n > -1 Then
				For i = 0 To UBound(DefaultEngineList)
					If DefaultEngineList(i) = EngineList(n).Name Then
						j = i
						Exit For
					End If
				Next i
			End If
			If j > -1 Then
				DlgEnable "ChangButton",False
				DlgEnable "DelButton",False
			Else
				If UBound(EngineList) = 0 Then DlgEnable "DelButton",False
			End If
			If DlgText("responseTypeBox") = "responseXML" Then
				DlgText "TranBeforeStrText",MsgList(29)
				DlgText "TranAfterStrText",MsgList(30)
			Else
				DlgText "TranBeforeStrText",MsgList(27)
				DlgText "TranAfterStrText",MsgList(28)
			End If
			DlgEnable "ShowAllLngButton",False
			DlgEnable "ResetLngButton",False
		Case 1
			j = -1
			n = DlgValue("CheckList")
			If n > -1 Then
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = CheckList(n).Name Then
						j = i
						Exit For
					End If
				Next i
			End If
			If j > -1 Then
				DlgEnable "ChangButton",False
				DlgEnable "DelButton",False
			Else
				If UBound(CheckList) = 0 Then DlgEnable "DelButton",False
			End If
			If DlgListBoxArray("AppLngList") = 0 Then
				DlgEnable "AddLangButton",False
				DlgEnable "AddAllLangButton",False
				DlgEnable "EditAppLangButton",False
				DlgEnable "DelAppLangButton",False
			End If
			If DlgListBoxArray("UseLngList") = 0 Then
				DlgEnable "DelLangButton",False
				DlgEnable "DelAllLangButton",False
				DlgEnable "EditUseLangButton",False
				DlgEnable "DelUseLangButton",False
			End If
			If DlgValue("AsiaKeyBox") = 1 Then
				DlgEnable "AddAcckeyBox",False
				DlgValue "AddAcckeyBox",0
			End If
		End Select

		DlgVisible "ObjectNameText",False
		DlgVisible "ObjectNameBox",False
		If DlgValue("Options") > 1 Then
			DlgVisible "GroupBox1",False
			DlgVisible "LevelButton",False
			DlgVisible "AddButton",False
			DlgVisible "ChangButton",False
			DlgVisible "DelButton",False

			DlgVisible "GroupBox2",False
			DlgVisible "ImportButton",False
			DlgVisible "ExportButton",False
		End If
		If DlgValue("Options") > 2 Then
			DlgVisible "ResetButton",False
			DlgVisible "TestButton",False
			DlgVisible "CleanButton",False
		Else
			DlgVisible "EditUILangButton",False
		End If
		If DlgValue("Options") <> 0 Then
			DlgVisible "EngineList",False

			DlgVisible "tWriteType",False
			DlgVisible "GroupBox4",False
			DlgVisible "Engine",False

			DlgVisible "AppIDText",False
			DlgVisible "UrlText",False
			DlgVisible "UrlTemplateText",False
			DlgVisible "bstrMethodText",False
			DlgVisible "varAsyncText",False
			DlgVisible "bstrUserText",False
			DlgVisible "bstrPasswordText",False
			DlgVisible "SignText",False
			DlgVisible "RequestHeaderText",False
			DlgVisible "MD5Text",False
			DlgVisible "RequestHeaderText2",False
			DlgVisible "responseTypeText",False
			DlgVisible "TranBeforeStrText",False
			DlgVisible "TranAfterStrText",False
			DlgVisible "AppIDBox",False
			DlgVisible "UrlBox",False
			DlgVisible "UrlTemplateBox",False
			DlgVisible "bstrMethodBox",False
			DlgVisible "varAsyncBox",False
			DlgVisible "bstrUserBox",False
			DlgVisible "bstrPasswordBox",False
			DlgVisible "MD5Box",False
			DlgVisible "SignBox",False
			DlgVisible "RequestHeaderBox",False
			DlgVisible "responseTypeBox",False
			DlgVisible "TranBeforeStrBox",False
			DlgVisible "TranAfterStrBox",False
			DlgVisible "MD5Button",False
			DlgVisible "UrlTemplateButton",False
			DlgVisible "bstrMethodButton",False
			DlgVisible "varAsyncButton",False
			DlgVisible "RequestButton",False
			DlgVisible "responseTypeButton",False
			DlgVisible "TranBeforeStrButton",False
			DlgVisible "TranAfterStrButton",False

			DlgVisible "LngNameText",False
			DlgVisible "SrcLngText",False
			DlgVisible "TranLngText",False
			DlgVisible "LngNameList",False
			DlgVisible "SrcLngList",False
			DlgVisible "TranLngList",False
			DlgVisible "AddLngButton",False
			DlgVisible "DelLngButton",False
			DlgVisible "DelAllButton",False
			DlgVisible "EditLngButton",False
			DlgVisible "ExtEditButton",False
			DlgVisible "NullLngButton",False
			DlgVisible "ResetLngButton",False
			DlgVisible "ShowNoNullLngButton",False
			DlgVisible "ShowNullLngButton",False
			DlgVisible "ShowAllLngButton",False

			DlgVisible "EnableText1",False
			DlgVisible "EnableText2",False
			DlgVisible "EnableBox",False
		Else
			If DlgValue("Engine") <> 0 Then
				DlgVisible "AppIDText",False
				DlgVisible "UrlText",False
				DlgVisible "UrlTemplateText",False
				DlgVisible "bstrMethodText",False
				DlgVisible "varAsyncText",False
				DlgVisible "bstrUserText",False
				DlgVisible "bstrPasswordText",False
				DlgVisible "SignText",False
				DlgVisible "RequestHeaderText",False
				DlgVisible "MD5Text",False
				DlgVisible "RequestHeaderText2",False
				DlgVisible "responseTypeText",False
				DlgVisible "TranBeforeStrText",False
				DlgVisible "TranAfterStrText",False
				DlgVisible "AppIDBox",False
				DlgVisible "UrlBox",False
				DlgVisible "UrlTemplateBox",False
				DlgVisible "bstrMethodBox",False
				DlgVisible "varAsyncBox",False
				DlgVisible "bstrUserBox",False
				DlgVisible "bstrPasswordBox",False
				DlgVisible "MD5Box",False
				DlgVisible "SignBox",False
				DlgVisible "RequestHeaderBox",False
				DlgVisible "responseTypeBox",False
				DlgVisible "TranBeforeStrBox",False
				DlgVisible "TranAfterStrBox",False
				DlgVisible "MD5Button",False
				DlgVisible "UrlTemplateButton",False
				DlgVisible "bstrMethodButton",False
				DlgVisible "varAsyncButton",False
				DlgVisible "RequestButton",False
				DlgVisible "responseTypeButton",False
				DlgVisible "TranBeforeStrButton",False
				DlgVisible "TranAfterStrButton",False
			End If
			If DlgValue("Engine") <> 1 Then
				DlgVisible "LngNameText",False
				DlgVisible "SrcLngText",False
				DlgVisible "TranLngText",False
				DlgVisible "LngNameList",False
				DlgVisible "SrcLngList",False
				DlgVisible "TranLngList",False
				DlgVisible "AddLngButton",False
				DlgVisible "DelLngButton",False
				DlgVisible "DelAllButton",False
				DlgVisible "EditLngButton",False
				DlgVisible "ExtEditButton",False
				DlgVisible "NullLngButton",False
				DlgVisible "ResetLngButton",False
				DlgVisible "ShowNoNullLngButton",False
				DlgVisible "ShowNullLngButton",False
				DlgVisible "ShowAllLngButton",False
			End If
			If DlgValue("Engine") <> 2 Then
				DlgVisible "EnableText1",False
				DlgVisible "EnableText2",False
				DlgVisible "EnableBox",False
			End If
		End If
		If DlgValue("Options") <> 1 Then
			DlgVisible "CheckList",False
			DlgVisible "cWriteType",False

			DlgVisible "GroupBox3",False
			DlgVisible "SetType",False
			DlgVisible "NextSetType",False
			DlgVisible "SetItemText",False

			DlgVisible "AccKeyBoxTxt",False
			DlgVisible "ExCrBoxTxt",False
			DlgVisible "ChkBktBoxTxt",False
			DlgVisible "KpPairBoxTxt",False
			DlgVisible "AccKeyBox",False
			DlgVisible "ExCrBox",False
			DlgVisible "ChkBktBox",False
			DlgVisible "KpPairBox",False
			DlgVisible "AsiaKeyBox",False
			DlgVisible "AddAcckeyBox",False

			DlgVisible "ChkEndBoxTxt",False
			DlgVisible "NoTrnEndBoxTxt",False
			DlgVisible "AutoTrnEndBoxTxt",False
			DlgVisible "ChkEndBox",False
			DlgVisible "NoTrnEndBox",False
			DlgVisible "AutoTrnEndBox",False

			DlgVisible "ShortBoxTxt",False
			DlgVisible "ShortKeyBoxTxt",False
			DlgVisible "KpShortKeyBoxTxt",False
			DlgVisible "ShortBox",False
			DlgVisible "ShortKeyBox",False
			DlgVisible "KpShortKeyBox",False

			DlgVisible "PreRepStrBoxTxt",False
			DlgVisible "AutoWebFlagBoxTxt",False
			DlgVisible "PreRepStrBox",False
			DlgVisible "AutoWebFlagBox",False

			DlgVisible "LineSplitBoxTxt",False
			DlgVisible "PreInsertSplitBoxTxt",False
			DlgVisible "AppInsertSplitBoxTxt",False
			DlgVisible "ReplaceSplitBoxTxt",False
			DlgVisible "PreInsertSplitBox",False
			DlgVisible "AppInsertSplitBox",False
			DlgVisible "ReplaceSplitBox",False
			DlgVisible "LineSplitModeBox",False

			DlgVisible "AppLngText",False
			DlgVisible "UseLngText",False
			DlgVisible "AppLngList",False
			DlgVisible "UseLngList",False
			DlgVisible "AddLangButton",False
			DlgVisible "AddAllLangButton",False
			DlgVisible "DelLangButton",False
			DlgVisible "DelAllLangButton",False
			DlgVisible "SetAppLangButton",False
			DlgVisible "EditAppLangButton",False
			DlgVisible "DelAppLangButton",False
			DlgVisible "SetUseLangButton",False
			DlgVisible "EditUseLangButton",False
			DlgVisible "DelUseLangButton",False
		Else
			If DlgValue("SetType") <> 0 Then
				DlgVisible "AccKeyBoxTxt",False
				DlgVisible "ExCrBoxTxt",False
				DlgVisible "ChkBktBoxTxt",False
				DlgVisible "KpPairBoxTxt",False
				DlgVisible "AccKeyBox",False
				DlgVisible "ExCrBox",False
				DlgVisible "ChkBktBox",False
				DlgVisible "KpPairBox",False
				DlgVisible "AsiaKeyBox",False
				DlgVisible "AddAcckeyBox",False
			End If
			If DlgValue("SetType") <> 1 Then
				DlgVisible "ChkEndBoxTxt",False
				DlgVisible "NoTrnEndBoxTxt",False
				DlgVisible "AutoTrnEndBoxTxt",False
				DlgVisible "ChkEndBox",False
				DlgVisible "NoTrnEndBox",False
				DlgVisible "AutoTrnEndBox",False
			End If
			If DlgValue("SetType") <> 2 Then
				DlgVisible "ShortBoxTxt",False
				DlgVisible "ShortKeyBoxTxt",False
				DlgVisible "KpShortKeyBoxTxt",False
				DlgVisible "ShortBox",False
				DlgVisible "ShortKeyBox",False
				DlgVisible "KpShortKeyBox",False
			End If
			If DlgValue("SetType") <> 3 Then
				DlgVisible "PreRepStrBoxTxt",False
				DlgVisible "AutoWebFlagBoxTxt",False
				DlgVisible "PreRepStrBox",False
				DlgVisible "AutoWebFlagBox",False
			End If
			If DlgValue("SetType") <> 4 Then
				DlgVisible "LineSplitBoxTxt",False
				DlgVisible "PreInsertSplitBoxTxt",False
				DlgVisible "AppInsertSplitBoxTxt",False
				DlgVisible "ReplaceSplitBoxTxt",False
				DlgVisible "PreInsertSplitBox",False
				DlgVisible "AppInsertSplitBox",False
				DlgVisible "ReplaceSplitBox",False
				DlgVisible "LineSplitModeBox",False
			End If
			If DlgValue("SetType") <> 5 Then
				DlgVisible "AppLngText",False
				DlgVisible "UseLngText",False
				DlgVisible "AppLngList",False
				DlgVisible "UseLngList",False
				DlgVisible "AddLangButton",False
				DlgVisible "AddAllLangButton",False
				DlgVisible "DelLangButton",False
				DlgVisible "DelAllLangButton",False
				DlgVisible "SetAppLangButton",False
				DlgVisible "EditAppLangButton",False
				DlgVisible "DelAppLangButton",False
				DlgVisible "SetUseLangButton",False
				DlgVisible "EditUseLangButton",False
				DlgVisible "DelUseLangButton",False
			End If
		End If
		If DlgValue("Options") <> 2 Then
			DlgVisible "UpdateSetGroup",False
			DlgVisible "UpdateSet",False
			DlgVisible "AutoButton",False
			DlgVisible "ManualButton",False
			DlgVisible "OffButton",False
			DlgVisible "CheckGroup",False
			DlgVisible "UpdateCycleText",False
			DlgVisible "UpdateCycleBox",False
			DlgVisible "UpdateDatesText",False
			DlgVisible "UpdateDateText",False
			DlgVisible "UpdateDateBox",False
			DlgVisible "CheckButton",False
			DlgVisible "WebSiteGroup",False
			DlgVisible "WebSiteBox",False
			DlgVisible "CmdGroup",False
			DlgVisible "CmdPathBoxText",False
			DlgVisible "ArgumentBoxText",False
			DlgVisible "CmdPathBox",False
			DlgVisible "ArgumentBox",False
			DlgVisible "ExeBrowseButton",False
			DlgVisible "ArgumentButton",False
		End If
		If DlgValue("Options") <> 3 Then
			DlgVisible "UILangSetGroup",False
			DlgVisible "UILangSetText1",False
			DlgVisible "UILangSetText2",False
			DlgVisible "UILangList",False
			DlgVisible "UILangSetText3",False

			DlgVisible "UIFontSetGroup",False
			DlgVisible "MainFontText",False
			DlgVisible "MainFontBox",False
			DlgVisible "MainFontButton",False
		End If

		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		SettingsDlgFunc = True 'ֹ°ťرնԻ򴰿
		If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
		If DlgItem$ = "NextSetType" Then
			i = DlgValue("SetType")
			If i < 5 Then i = i + 1 Else i = 0
			DlgValue "SetType",i
		End If
		Select Case DlgItem$
		Case "Options","SetType","NextSetType","Engine"
			If DlgValue("Options") < 2 Then
				DlgVisible "GroupBox1",True
				DlgVisible "LevelButton",True
				DlgVisible "AddButton",True
				DlgVisible "ChangButton",True
				DlgVisible "DelButton",True

				DlgVisible "GroupBox2",True
				DlgVisible "ImportButton",True
				DlgVisible "ExportButton",True
			Else
				DlgVisible "GroupBox1",False
				DlgVisible "LevelButton",False
				DlgVisible "AddButton",False
				DlgVisible "ChangButton",False
				DlgVisible "DelButton",False

				DlgVisible "GroupBox2",False
				DlgVisible "ImportButton",False
				DlgVisible "ExportButton",False
			End If
			If DlgValue("Options") < 3 Then
				DlgVisible "ResetButton",True
				DlgVisible "TestButton",True
				DlgVisible "CleanButton",True
				DlgVisible "EditUILangButton",False
			Else
				DlgVisible "ResetButton",False
				DlgVisible "TestButton",False
				DlgVisible "CleanButton",False
				DlgVisible "EditUILangButton",True
			End If
			If DlgValue("Options") = 0 Then
				DlgVisible "EngineList",True
				DlgVisible "tWriteType",True
				DlgVisible "GroupBox4",True
				DlgVisible "Engine",True
				If DlgValue("Engine") = 0 Then
					DlgVisible "AppIDText",True
					DlgVisible "UrlText",True
					DlgVisible "UrlTemplateText",True
					DlgVisible "bstrMethodText",True
					DlgVisible "varAsyncText",True
					DlgVisible "bstrUserText",True
					DlgVisible "bstrPasswordText",True
					DlgVisible "SignText",True
					DlgVisible "RequestHeaderText",True
					DlgVisible "MD5Text",True
					DlgVisible "RequestHeaderText2",True
					DlgVisible "responseTypeText",True
					DlgVisible "TranBeforeStrText",True
					DlgVisible "TranAfterStrText",True
					DlgVisible "AppIDBox",True
					DlgVisible "UrlBox",True
					DlgVisible "UrlTemplateBox",True
					DlgVisible "bstrMethodBox",True
					DlgVisible "varAsyncBox",True
					DlgVisible "bstrUserBox",True
					DlgVisible "bstrPasswordBox",True
					DlgVisible "MD5Box",True
					DlgVisible "SignBox",True
					DlgVisible "RequestHeaderBox",True
					DlgVisible "responseTypeBox",True
					DlgVisible "TranBeforeStrBox",True
					DlgVisible "TranAfterStrBox",True
					DlgVisible "MD5Button",True
					DlgVisible "UrlTemplateButton",True
					DlgVisible "bstrMethodButton",True
					DlgVisible "varAsyncButton",True
					DlgVisible "RequestButton",True
					DlgVisible "responseTypeButton",True
					DlgVisible "TranBeforeStrButton",True
					DlgVisible "TranAfterStrButton",True
				Else
					DlgVisible "AppIDText",False
					DlgVisible "UrlText",False
					DlgVisible "UrlTemplateText",False
					DlgVisible "bstrMethodText",False
					DlgVisible "varAsyncText",False
					DlgVisible "bstrUserText",False
					DlgVisible "bstrPasswordText",False
					DlgVisible "SignText",False
					DlgVisible "RequestHeaderText",False
					DlgVisible "MD5Text",False
					DlgVisible "RequestHeaderText2",False
					DlgVisible "responseTypeText",False
					DlgVisible "TranBeforeStrText",False
					DlgVisible "TranAfterStrText",False
					DlgVisible "AppIDBox",False
					DlgVisible "UrlBox",False
					DlgVisible "UrlTemplateBox",False
					DlgVisible "bstrMethodBox",False
					DlgVisible "varAsyncBox",False
					DlgVisible "bstrUserBox",False
					DlgVisible "bstrPasswordBox",False
					DlgVisible "MD5Box",False
					DlgVisible "SignBox",False
					DlgVisible "RequestHeaderBox",False
					DlgVisible "responseTypeBox",False
					DlgVisible "TranBeforeStrBox",False
					DlgVisible "TranAfterStrBox",False
					DlgVisible "MD5Button",False
					DlgVisible "UrlTemplateButton",False
					DlgVisible "bstrMethodButton",False
					DlgVisible "varAsyncButton",False
					DlgVisible "RequestButton",False
					DlgVisible "responseTypeButton",False
					DlgVisible "TranBeforeStrButton",False
					DlgVisible "TranAfterStrButton",False
				End If
				If DlgValue("Engine") = 1 Then
					DlgVisible "LngNameText",True
					DlgVisible "SrcLngText",True
					DlgVisible "TranLngText",True
					DlgVisible "LngNameList",True
					DlgVisible "SrcLngList",True
					DlgVisible "TranLngList",True
					DlgVisible "AddLngButton",True
					DlgVisible "DelLngButton",True
					DlgVisible "DelAllButton",True
					DlgVisible "EditLngButton",True
					DlgVisible "ExtEditButton",True
					DlgVisible "NullLngButton",True
					DlgVisible "ResetLngButton",True
					DlgVisible "ShowNoNullLngButton",True
					DlgVisible "ShowNullLngButton",True
					DlgVisible "ShowAllLngButton",True
				Else
					DlgVisible "LngNameText",False
					DlgVisible "SrcLngText",False
					DlgVisible "TranLngText",False
					DlgVisible "LngNameList",False
					DlgVisible "SrcLngList",False
					DlgVisible "TranLngList",False
					DlgVisible "AddLngButton",False
					DlgVisible "DelLngButton",False
					DlgVisible "DelAllButton",False
					DlgVisible "EditLngButton",False
					DlgVisible "ExtEditButton",False
					DlgVisible "NullLngButton",False
					DlgVisible "ResetLngButton",False
					DlgVisible "ShowNoNullLngButton",False
					DlgVisible "ShowNullLngButton",False
					DlgVisible "ShowAllLngButton",False
				End If
				If DlgValue("Engine") = 2 Then
					DlgVisible "EnableText1",True
					DlgVisible "EnableText2",True
					DlgVisible "EnableBox",True
				Else
					DlgVisible "EnableText1",False
					DlgVisible "EnableText2",False
					DlgVisible "EnableBox",False
				End If
			Else
				DlgVisible "EngineList",False

				DlgVisible "tWriteType",False
				DlgVisible "GroupBox4",False
				DlgVisible "Engine",False

				DlgVisible "AppIDText",False
				DlgVisible "UrlText",False
				DlgVisible "UrlTemplateText",False
				DlgVisible "bstrMethodText",False
				DlgVisible "varAsyncText",False
				DlgVisible "bstrUserText",False
				DlgVisible "bstrPasswordText",False
				DlgVisible "SignText",False
				DlgVisible "RequestHeaderText",False
				DlgVisible "MD5Text",False
				DlgVisible "RequestHeaderText2",False
				DlgVisible "responseTypeText",False
				DlgVisible "TranBeforeStrText",False
				DlgVisible "TranAfterStrText",False
				DlgVisible "AppIDBox",False
				DlgVisible "UrlBox",False
				DlgVisible "UrlTemplateBox",False
				DlgVisible "bstrMethodBox",False
				DlgVisible "varAsyncBox",False
				DlgVisible "bstrUserBox",False
				DlgVisible "bstrPasswordBox",False
				DlgVisible "MD5Box",False
				DlgVisible "SignBox",False
				DlgVisible "RequestHeaderBox",False
				DlgVisible "responseTypeBox",False
				DlgVisible "TranBeforeStrBox",False
				DlgVisible "TranAfterStrBox",False
				DlgVisible "MD5Button",False
				DlgVisible "UrlTemplateButton",False
				DlgVisible "bstrMethodButton",False
				DlgVisible "varAsyncButton",False
				DlgVisible "RequestButton",False
				DlgVisible "responseTypeButton",False
				DlgVisible "TranBeforeStrButton",False
				DlgVisible "TranAfterStrButton",False

				DlgVisible "LngNameText",False
				DlgVisible "SrcLngText",False
				DlgVisible "TranLngText",False
				DlgVisible "LngNameList",False
				DlgVisible "SrcLngList",False
				DlgVisible "TranLngList",False
				DlgVisible "AddLngButton",False
				DlgVisible "DelLngButton",False
				DlgVisible "DelAllButton",False
				DlgVisible "EditLngButton",False
				DlgVisible "ExtEditButton",False
				DlgVisible "NullLngButton",False
				DlgVisible "ResetLngButton",False
				DlgVisible "ShowNoNullLngButton",False
				DlgVisible "ShowNullLngButton",False
				DlgVisible "ShowAllLngButton",False

				DlgVisible "EnableText1",False
				DlgVisible "EnableText2",False
				DlgVisible "EnableBox",False
			End If
			If DlgValue("Options") = 1 Then
				DlgVisible "CheckList",True
				DlgVisible "cWriteType",True

				DlgVisible "GroupBox3",True
				DlgVisible "SetType",True
				DlgVisible "NextSetType",True
				DlgVisible "SetItemText",True
				If DlgValue("SetType") = 0 Then
					DlgVisible "AccKeyBoxTxt",True
					DlgVisible "ExCrBoxTxt",True
					DlgVisible "ChkBktBoxTxt",True
					DlgVisible "KpPairBoxTxt",True
					DlgVisible "AccKeyBox",True
					DlgVisible "ExCrBox",True
					DlgVisible "ChkBktBox",True
					DlgVisible "KpPairBox",True
					DlgVisible "AsiaKeyBox",True
					DlgVisible "AddAcckeyBox",True
				Else
					DlgVisible "AccKeyBoxTxt",False
					DlgVisible "ExCrBoxTxt",False
					DlgVisible "ChkBktBoxTxt",False
					DlgVisible "KpPairBoxTxt",False
					DlgVisible "AccKeyBox",False
					DlgVisible "ExCrBox",False
					DlgVisible "ChkBktBox",False
					DlgVisible "KpPairBox",False
					DlgVisible "AsiaKeyBox",False
					DlgVisible "AddAcckeyBox",False
				End If
				If DlgValue("SetType") = 1 Then
					DlgVisible "ChkEndBoxTxt",True
					DlgVisible "NoTrnEndBoxTxt",True
					DlgVisible "AutoTrnEndBoxTxt",True
					DlgVisible "ChkEndBox",True
					DlgVisible "NoTrnEndBox",True
					DlgVisible "AutoTrnEndBox",True
				Else
					DlgVisible "ChkEndBoxTxt",False
					DlgVisible "NoTrnEndBoxTxt",False
					DlgVisible "AutoTrnEndBoxTxt",False
					DlgVisible "ChkEndBox",False
					DlgVisible "NoTrnEndBox",False
					DlgVisible "AutoTrnEndBox",False
				End If
				If DlgValue("SetType") = 2 Then
					DlgVisible "ShortBoxTxt",True
					DlgVisible "ShortKeyBoxTxt",True
					DlgVisible "KpShortKeyBoxTxt",True
					DlgVisible "ShortBox",True
					DlgVisible "ShortKeyBox",True
					DlgVisible "KpShortKeyBox",True
				Else
					DlgVisible "ShortBoxTxt",False
					DlgVisible "ShortKeyBoxTxt",False
					DlgVisible "KpShortKeyBoxTxt",False
					DlgVisible "ShortBox",False
					DlgVisible "ShortKeyBox",False
					DlgVisible "KpShortKeyBox",False
				End If
				If DlgValue("SetType") = 3 Then
					DlgVisible "PreRepStrBoxTxt",True
					DlgVisible "AutoWebFlagBoxTxt",True
					DlgVisible "PreRepStrBox",True
					DlgVisible "AutoWebFlagBox",True
				Else
					DlgVisible "PreRepStrBoxTxt",False
					DlgVisible "AutoWebFlagBoxTxt",False
					DlgVisible "PreRepStrBox",False
					DlgVisible "AutoWebFlagBox",False
				End	If
				If DlgValue("SetType") = 4 Then
					DlgVisible "LineSplitBoxTxt",True
					DlgVisible "PreInsertSplitBoxTxt",True
					DlgVisible "AppInsertSplitBoxTxt",True
					DlgVisible "ReplaceSplitBoxTxt",True
					DlgVisible "PreInsertSplitBox",True
					DlgVisible "AppInsertSplitBox",True
					DlgVisible "ReplaceSplitBox",True
					DlgVisible "LineSplitModeBox",True
				Else
					DlgVisible "LineSplitBoxTxt",False
					DlgVisible "PreInsertSplitBoxTxt",False
					DlgVisible "AppInsertSplitBoxTxt",False
					DlgVisible "ReplaceSplitBoxTxt",False
					DlgVisible "PreInsertSplitBox",False
					DlgVisible "AppInsertSplitBox",False
					DlgVisible "ReplaceSplitBox",False
					DlgVisible "LineSplitModeBox",False
				End If
				If DlgValue("SetType") = 5 Then
					DlgVisible "AppLngText",True
					DlgVisible "UseLngText",True
					DlgVisible "AppLngList",True
					DlgVisible "UseLngList",True
					DlgVisible "AddLangButton",True
					DlgVisible "AddAllLangButton",True
					DlgVisible "DelLangButton",True
					DlgVisible "DelAllLangButton",True
					DlgVisible "SetAppLangButton",True
					DlgVisible "EditAppLangButton",True
					DlgVisible "DelAppLangButton",True
					DlgVisible "SetUseLangButton",True
					DlgVisible "EditUseLangButton",True
					DlgVisible "DelUseLangButton",True
				Else
					DlgVisible "AppLngText",False
					DlgVisible "UseLngText",False
					DlgVisible "AppLngList",False
					DlgVisible "UseLngList",False
					DlgVisible "AddLangButton",False
					DlgVisible "AddAllLangButton",False
					DlgVisible "DelLangButton",False
					DlgVisible "DelAllLangButton",False
					DlgVisible "SetAppLangButton",False
					DlgVisible "EditAppLangButton",False
					DlgVisible "DelAppLangButton",False
					DlgVisible "SetUseLangButton",False
					DlgVisible "EditUseLangButton",False
					DlgVisible "DelUseLangButton",False
				End If
			Else
				DlgVisible "CheckList",False
				DlgVisible "cWriteType",False

				DlgVisible "GroupBox3",False
				DlgVisible "SetType",False
				DlgVisible "NextSetType",False
				DlgVisible "SetItemText",False

				DlgVisible "AccKeyBoxTxt",False
				DlgVisible "ExCrBoxTxt",False
				DlgVisible "ChkBktBoxTxt",False
				DlgVisible "KpPairBoxTxt",False
				DlgVisible "AccKeyBox",False
				DlgVisible "ExCrBox",False
				DlgVisible "ChkBktBox",False
				DlgVisible "KpPairBox",False
				DlgVisible "AsiaKeyBox",False
				DlgVisible "AddAcckeyBox",False

				DlgVisible "ChkEndBoxTxt",False
				DlgVisible "NoTrnEndBoxTxt",False
				DlgVisible "AutoTrnEndBoxTxt",False
				DlgVisible "ChkEndBox",False
				DlgVisible "NoTrnEndBox",False
				DlgVisible "AutoTrnEndBox",False

				DlgVisible "ShortBoxTxt",False
				DlgVisible "ShortKeyBoxTxt",False
				DlgVisible "KpShortKeyBoxTxt",False
				DlgVisible "ShortBox",False
				DlgVisible "ShortKeyBox",False
				DlgVisible "KpShortKeyBox",False

				DlgVisible "PreRepStrBoxTxt",False
				DlgVisible "AutoWebFlagBoxTxt",False
				DlgVisible "PreRepStrBox",False
				DlgVisible "AutoWebFlagBox",False

				DlgVisible "LineSplitBoxTxt",False
				DlgVisible "PreInsertSplitBoxTxt",False
				DlgVisible "AppInsertSplitBoxTxt",False
				DlgVisible "ReplaceSplitBoxTxt",False
				DlgVisible "PreInsertSplitBox",False
				DlgVisible "AppInsertSplitBox",False
				DlgVisible "ReplaceSplitBox",False
				DlgVisible "LineSplitModeBox",False

				DlgVisible "AppLngText",False
				DlgVisible "UseLngText",False
				DlgVisible "AppLngList",False
				DlgVisible "UseLngList",False
				DlgVisible "AddLangButton",False
				DlgVisible "AddAllLangButton",False
				DlgVisible "DelLangButton",False
				DlgVisible "DelAllLangButton",False
				DlgVisible "SetAppLangButton",False
				DlgVisible "EditAppLangButton",False
				DlgVisible "DelAppLangButton",False
				DlgVisible "SetUseLangButton",False
				DlgVisible "EditUseLangButton",False
				DlgVisible "DelUseLangButton",False
			End If
			If DlgValue("Options") = 2 Then
				DlgVisible "UpdateSetGroup",True
				DlgVisible "UpdateSet",True
				DlgVisible "AutoButton",True
				DlgVisible "ManualButton",True
				DlgVisible "OffButton",True
				DlgVisible "CheckGroup",True
				DlgVisible "UpdateCycleText",True
				DlgVisible "UpdateCycleBox",True
				DlgVisible "UpdateDatesText",True
				DlgVisible "UpdateDateText",True
				DlgVisible "UpdateDateBox",True
				DlgVisible "CheckButton",True
				DlgVisible "WebSiteGroup",True
				DlgVisible "WebSiteBox",True
				DlgVisible "CmdGroup",True
				DlgVisible "CmdPathBoxText",True
				DlgVisible "ArgumentBoxText",True
				DlgVisible "CmdPathBox",True
				DlgVisible "ArgumentBox",True
				DlgVisible "ExeBrowseButton",True
				DlgVisible "ArgumentButton",True
			Else
				DlgVisible "UpdateSetGroup",False
				DlgVisible "UpdateSet",False
				DlgVisible "AutoButton",False
				DlgVisible "ManualButton",False
				DlgVisible "OffButton",False
				DlgVisible "CheckGroup",False
				DlgVisible "UpdateCycleText",False
				DlgVisible "UpdateCycleBox",False
				DlgVisible "UpdateDatesText",False
				DlgVisible "UpdateDateText",False
				DlgVisible "UpdateDateBox",False
				DlgVisible "CheckButton",False
				DlgVisible "WebSiteGroup",False
				DlgVisible "WebSiteBox",False
				DlgVisible "CmdGroup",False
				DlgVisible "CmdPathBoxText",False
				DlgVisible "ArgumentBoxText",False
				DlgVisible "CmdPathBox",False
				DlgVisible "ArgumentBox",False
				DlgVisible "ExeBrowseButton",False
				DlgVisible "ArgumentButton",False
			End If
			If DlgValue("Options") = 3 Then
				DlgVisible "UILangSetGroup",True
				DlgVisible "UILangSetText1",True
				DlgVisible "UILangSetText2",True
				DlgVisible "UILangList",True
				DlgVisible "UILangSetText3",True

				DlgVisible "UIFontSetGroup",True
				DlgVisible "MainFontText",True
				DlgVisible "MainFontBox",True
				DlgVisible "MainFontButton",True
			Else
				DlgVisible "UILangSetGroup",False
				DlgVisible "UILangSetText1",False
				DlgVisible "UILangSetText2",False
				DlgVisible "UILangList",False
				DlgVisible "UILangSetText3",False

				DlgVisible "UIFontSetGroup",False
				DlgVisible "MainFontText",False
				DlgVisible "MainFontBox",False
				DlgVisible "MainFontButton",False
			End If
		Case "HelpButton"
			Select Case DlgValue("Options")
			Case 0
				Call Help("EngineSetHelp")
			Case 1
				Call Help("CheckSetHelp")
			Case 2
				Call Help("UpdateSetHelp")
			Case 3
				Call Help("UILangSetHelp")
			End Select
			Exit Function
		Case "OKButton"
			'Զ
			If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    		MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			ElseIf Dir$(DlgText("CmdPathBox")) = "" Then
				MsgBox MsgList(16),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
	    	End If
	    	'鷭
	    	For i = 0 To UBound(EngineList)
	    		If CheckEngineSet(EngineList,i) = False Then
	    			If MsgBox(Replace$(MsgList(9),"%s",EngineList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
	    				Exit Function
					End If
				End If
			Next i
			'鷭
	    	For i = 0 To UBound(CheckList)
	    		If CheckCheckSet(CheckList,i) = False Then
	    			If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
	    				Exit Function
					End If
				End If
			Next i
			'ȡõıλ
			If DlgValue("tWriteType") = 0 Then Temp = EngineFilePath Else Temp = EngineRegKey
			If WriteEngineSet(Temp,"Sets") = False Then
				MsgBox MsgList(14) & Replace$(MsgList(20),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			If DlgValue("cWriteType") = 0 Then Temp = CheckFilePath Else Temp = CheckRegKey
			If WriteCheckSet(Temp,"Sets") = False Then
				MsgBox MsgList(15) & Replace$(MsgList(20),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
				Exit Function
			End If
			EngineListBak = EngineList
			CheckListBak = CheckList
			UpdateSetBak = UpdateSet
			LFListBak = LFList
			SettingsDlgFunc = False
			Exit Function
		Case "CancelButton"
			EngineList = EngineListBak
			CheckList = CheckListBak
			UpdateSet = UpdateSetBak
			SettingsDlgFunc = False
			Exit Function
		End Select

		Select Case DlgValue("Options")
		Case 0
			Select Case DlgItem$
			Case "LevelButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(EngineList)
				If SetLevel(TempList,j,MsgList(52)) = False Then Exit Function
				Temp = DlgText("EngineList")
				DlgListBoxArray "EngineList",TempList()
				DlgText "EngineList",Temp
				Set Dic = CreateObject("Scripting.Dictionary")
				For i = 0 To UBound(EngineList)
					If Not Dic.Exists(EngineList(i).Name) Then
						Dic.Add(EngineList(i).Name,i)
					End If
				Next i
				ReDim TempEngine(0) As ENGINE_SET
				TempEngine = EngineList
				For i = 0 To UBound(TempList)
					If Dic.Exists(TempList(i)) Then
						TempEngine(n) = EngineList(Dic.Item(TempList(i)))
						n = n + 1
					End If
				Next i
				EngineList = TempEngine
				Set Dic = Nothing
				Exit Function
			Case "AddButton"
				TempList = getSetNameList(EngineList)
				Temp = AddSet(TempList)
				If Temp = "" Then Exit Function
				j = 0
				If CheckArray(TempList) = True Then
					j = UBound(EngineList) + 1
				End If
				ReDim Preserve TempList(j) As String,EngineList(j) As ENGINE_SET
				EngineList(j).HttpName = DefaultObject
				EngineList(j).LangPairList = LangCodeList(Temp,0,-1)
				TempList(j) = Temp
				EngineList(j).Name = Temp
				DlgListBoxArray "EngineList",TempList()
				DlgValue "EngineList",j
				DlgItem$ = "EngineList"
			Case "ChangButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(EngineList)
				Temp = EditSet(TempList,j)
				If Temp = "" Then Exit Function
				TempList(j) = Temp
				EngineList(j).Name = Temp
				DlgListBoxArray "EngineList",TempList()
				DlgValue "EngineList",j
				Exit Function
			Case "DelButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				If MsgBox(Replace(MsgList(12),"%s",DlgText("EngineList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then
					Exit Function
				End If
				Call DelEngintArray(EngineList,j)
				TempList = getSetNameList(EngineList)
				If j = UBound(TempList) + 1 Then j = j - 1
				DlgListBoxArray "EngineList",TempList()
				DlgValue "EngineList",j
				DlgItem$ = "EngineList"
			Case "ResetButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(1)
				For i = 0 To UBound(DefaultEngineList)
					If DefaultEngineList(i) = DlgText("EngineList") Then
						TempList(0) = MsgList(1)
						Exit For
					End If
				Next i
				TempList(1) = MsgList(2)
				For i = 0 To UBound(EngineList)
					If i <> j Then
						ReDim Preserve TempList(i + 2) As String
						TempList(i + 2) = MsgList(3) & " - " & EngineList(i).Name
					End If
				Next i
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				Select Case i
				Case Is < 0
					Exit Function
				Case 0
					EngineList(j) = DefaultEngineSet(DlgText("EngineList"))
					EngineList(j).Name = DlgText("EngineList")
					EngineList(j).LangPairList = LangCodeList(DlgText("EngineList"),0,-1)
				Case 1
					For n = 0 To UBound(EngineListBak)
						If EngineListBak(n).Name = DlgText("EngineList") Then
							EngineList(j) = EngineListBak(n)
							Exit For
						End If
					Next n
				Case Else
					Temp = Mid(TempList(i),InStr(TempList(i),MsgList(3) & " - ") + Len(MsgList(3) & " - "))
					For n = 0 To UBound(EngineList)
						If EngineList(n).Name = Temp Then
							EngineList(j) = EngineList(n)
							EngineList(j).Name = DlgText("EngineList")
							Exit For
						End If
					Next n
				End Select
				DlgItem$ = "EngineList"
			Case "CleanButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				With EngineList(j)
					Select Case DlgValue("Engine")
					Case 0
						.HttpName = ""
						.AppId = ""
						.url = ""
						.UrlTemplate = ""
						.method = ""
						.Async = ""
						.User = ""
						.Password = ""
						.Sign = ""
						.MD5 = ""
						.RequestHeader = ""
						.ResponseType = ""
						.TranBeforeStrByText = ""
						.TranAfterStrByText = ""
						.TranBeforeStrByBody = ""
						.TranAfterStrByBody = ""
						.TranBeforeStrByStream = ""
						.TranAfterStrByStream = ""
						.TranXMLIDName = ""
						.TranXMLTagName = ""
					Case 1
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = ""
						Next i
					Case Else
						.Enable = 0
					End Select
				End With
				DlgItem$ = "EngineList"
			Case "LngNameList"
				DlgValue "SrcLngList",DlgValue("LngNameList")
				DlgValue "TranLngList",DlgValue("LngNameList")
			Case "SrcLngList"
				DlgValue "LngNameList",DlgValue("SrcLngList")
				DlgValue "TranLngList",DlgValue("SrcLngList")
			Case "TranLngList"
				DlgValue "LngNameList",DlgValue("TranLngList")
				DlgValue "SrcLngList",DlgValue("TranLngList")
			Case "AddLngButton","DelLngButton","DelAllButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				With EngineList(j)
					Select Case DlgItem$
					Case "AddLngButton"
						LangPair = EditLang(.LangPairList,-1)
						If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
						If CheckArrEmpty(.LangPairList) = True Then
							n = UBound(.LangPairList) + 1
						End If
						ReDim Preserve EngineList(j).LangPairList(n) 'As LANG_SET
						.LangPairList(n) = LangPair
					Case "DelLngButton"
						Temp = DlgText("LngNameList")
						If Temp = "" Then Exit Function
						If MsgBox(Replace(MsgList(13),"%s",DlgText("LngNameList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then Exit Function
						n = -1
						For i = 0 To UBound(.LangPairList)
							If .LangPairList(i).Name = Temp Then
								n = i
							End If
						Next i
						If n = -1 Then Exit Function
						Call DelLangPair(.LangPairList,n)
						If n > 0 Then n = n - 1
					Case Else
						If MsgBox(MsgList(26),vbYesNo+vbInformation,MsgList(11)) = vbNo Then Exit Function
						ReDim EngineList(j).LangPairList(0) 'As LANG_SET
					End Select
					LngNameList = GetLangSet(.LangPairList,0)
					DlgListBoxArray "LngNameList",LngNameList()
					DlgValue "LngNameList",n
					SrcLngList = GetLangSet(.LangPairList,1)
					DlgListBoxArray "SrcLngList",SrcLngList()
					DlgValue "SrcLngList",n
					TranLngList = GetLangSet(.LangPairList,2)
					DlgListBoxArray "TranLngList",TranLngList()
					DlgValue "TranLngList",n
				End With
				DlgEnable "ShowNoNullLngButton",True
				DlgEnable "ShowNullLngButton",True
				DlgEnable "ShowAllLngButton",False
			Case "EditLngButton","NullLngButton","ResetLngButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				HeaderID = DlgValue("LngNameList")
				If HeaderID < 0 Then Exit Function
				Temp = DlgText("LngNameList")
				With EngineList(j)
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
							Exit For
						End If
					Next i
					If n = -1 Then Exit Function
					Select Case DlgItem$
					Case "EditLngButton"
						If .LangPairList(n).UseCode = "" Then .LangPairList(n).UseCode = NullValue
						LangPair = EditLang(.LangPairList,n)
						If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
						.LangPairList(n) = LangPair
						LngNameList(HeaderID) = LangPair.Name
						DlgListBoxArray "LngNameList",LngNameList()
						SrcLngList(HeaderID) = LangPair.PslCode
						DlgListBoxArray "SrcLngList",SrcLngList()
						TranLngList(HeaderID) = LangPair.UseCode
						If LangPair.UseCode = "" Then TranLngList(HeaderID) = NullValue
						DlgListBoxArray "TranLngList",TranLngList()
					Case "NullLngButton"
						.LangPairList(n).UseCode = ""
						TranLngList(HeaderID) = NullValue
						DlgListBoxArray "TranLngList",TranLngList()
					Case Else
						For i = 0 To UBound(EngineListBak)
							If EngineListBak(i).Name = .Name Then
								For j = 0 To UBound(EngineListBak(i).LangPairList)
									If EngineListBak(i).LangPairList(j).Name = Temp Then
										.LangPairList(n) = EngineListBak(i).LangPairList(j)
										TranLngList(HeaderID) = .LangPairList(n).UseCode
										If .LangPairList(n).UseCode = "" Then TranLngList(HeaderID) = NullValue
										DlgListBoxArray "TranLngList",TranLngList()
										j = -1
										Exit For
									End If
								Next j
							End If
							If j = -1 Then Exit For
						Next i
					End Select
					DlgValue "LngNameList",HeaderID
					DlgValue "SrcLngList",HeaderID
					DlgValue "TranLngList",HeaderID
				End With
			Case "ShowAllLngButton","ShowNoNullLngButton","ShowNullLngButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				Temp = DlgText("LngNameList")
				With EngineList(j)
					Select Case DlgItem$
					Case "ShowAllLngButton"
						LngNameList = GetLangSet(.LangPairList,0)
						DlgListBoxArray "LngNameList",LngNameList()
						SrcLngList = GetLangSet(.LangPairList,1)
						DlgListBoxArray "SrcLngList",SrcLngList()
						TranLngList = GetLangSet(.LangPairList,2)
						DlgListBoxArray "TranLngList",TranLngList()
						DlgEnable "ShowNoNullLngButton",True
						DlgEnable "ShowNullLngButton",True
						DlgEnable "ShowAllLngButton",False
					Case "ShowNoNullLngButton"
						LngNameList = GetLangSet(.LangPairList,3)
						DlgListBoxArray "LngNameList",LngNameList()
						SrcLngList = GetLangSet(.LangPairList,4)
						DlgListBoxArray "SrcLngList",SrcLngList()
						TranLngList = GetLangSet(.LangPairList,5)
						DlgListBoxArray "TranLngList",TranLngList()
						DlgEnable "ShowNoNullLngButton",False
						DlgEnable "ShowNullLngButton",True
						DlgEnable "ShowAllLngButton",True
					Case Else
						LngNameList = GetLangSet(.LangPairList,6)
						DlgListBoxArray "LngNameList",LngNameList()
						SrcLngList = GetLangSet(.LangPairList,7)
						DlgListBoxArray "SrcLngList",SrcLngList()
						TranLngList = GetLangSet(.LangPairList,8)
						DlgListBoxArray "TranLngList",TranLngList()
						DlgEnable "ShowNoNullLngButton",True
						DlgEnable "ShowNullLngButton",False
						DlgEnable "ShowAllLngButton",True
					End Select
					DlgText "LngNameList",Temp
					n = DlgValue("LngNameList")
					If n > -1 Then
						DlgValue "LngNameList",n
						DlgValue "SrcLngList",n
						DlgValue "TranLngList",n
					Else
						DlgValue "LngNameList",0
						DlgValue "SrcLngList",0
						DlgValue "TranLngList",0
					End If
				End With
				'Exit Function
			Case "ExtEditButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(UBound(Tools)) As String
				For i = 0 To UBound(Tools)
					TempList(i) = Tools(i).sName
				Next i
				n = ShowPopupMenu(TempList,vbPopupUseRightButton)
				If n < 0 Then Exit Function
				On Error Resume Next
				With EngineList(j)
					ReDim TempList(UBound(.LangPairList)) As String
					For i = 0 To UBound(.LangPairList)
						TempList(i) = .LangPairList(i).Name & vbTab & .LangPairList(i).PslCode & vbTab
						If .LangPairList(i).UseCode <> "" Then
							TempList(i) = TempList(i) & .LangPairList(i).UseCode
						Else
							TempList(i) = TempList(i) & NullValue
						End If
					Next i
					Dim textStr As String
					textStr = Join(TempList,vbCrLf)
					Temp = trn.Project.Location & "\~temp.xls"
					If WriteToFile(Temp,Join(TempList,vbCrLf),"utf-8EFBB") = True Then
						If Dir(Temp) <> "" Then
							ReDim FileDataList(0)
							FileDataList(0) = Temp & JoinStr & "utf-8EFBB"
							If OpenFile(Temp,FileDataList,n,True) = True Then
								TempList = ReSplit(ReadTextFile(Temp,"utf-8EFBB"),vbCrLf)
							End If
							Kill Temp
						End If
					Else
						Exit Function
					End If
					If textStr = "" Then Exit Function
					If StrListJoin(TempList,vbCrLf) = textStr Then Exit Function
					If CheckArray(TempList) = False Then Exit Function
					n = UBound(TempList)
					ReDim TempArray(0) As String,EngineList(j).LangPairList(n) 'As LANG_SET
					For i = 0 To n
						TempArray = ReSplit(TempList(i),vbTab)
						.LangPairList(i).Name = TempArray(0)
						.LangPairList(i).PslCode = TempArray(1)
						.LangPairList(i).UseCode = IIf(TempArray(2) = NullValue,"",TempArray(2))
					Next i
				End With
				On Error GoTo 0
				DlgEnable "ShowNoNullLngButton",True
				DlgEnable "ShowNullLngButton",True
				DlgEnable "ShowAllLngButton",False
				DlgItem$ = "EngineList"
			Case "MD5Button","UrlTemplateButton","RequestButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(10) As String
				TempList(0) = MsgList(39)
				TempList(1) = MsgList(40)
				TempList(2) = MsgList(41)
				TempList(3) = MsgList(42)
				TempList(4) = MsgList(43)
				TempList(5) = MsgList(57)
				TempList(6) = MsgList(58)
				TempList(7) = MsgList(59)
				TempList(8) = MsgList(60)
				TempList(9) = MsgList(61)
				TempList(10) = MsgList(62)
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				If i < 0 Then Exit Function
				Select Case DlgItem$
				Case "MD5Button"
					Temp = "MD5Box"
				Case "UrlTemplateButton"
					Temp = "UrlTemplateBox"
				Case "RequestButton"
					Temp = "RequestHeaderBox"
				End Select
				DlgFocus(Temp)  'ý㵽ı
				DlgText Temp,InsertStr(GetFocus(),DlgText(Temp),Mid(TempList(i),InStr(TempList(i),"{")))
				Select Case DlgItem$
				Case "MD5Button"
					EngineList(j).MD5 = DlgText("MD5Box")
				Case "UrlTemplateButton"
					EngineList(j).UrlTemplate = DlgText("UrlTemplateBox")
				Case "RequestButton"
					EngineList(j).RequestHeader = DlgText("RequestHeaderBox")
				End Select
				DlgItem$ = "EngineList"
			Case "bstrMethodButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(1) As String
				TempList(0) = "GET"
				TempList(1) = "POST"
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				If i < 0 Then Exit Function
				EngineList(j).Method = TempList(i)
				DlgItem$ = "EngineList"
			Case "varAsyncButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(1) As String
				TempList(0) = MsgList(44)
				TempList(1) = MsgList(45)
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				If i < 0 Then Exit Function
				TempList(i) = Mid(TempList(i),InStr(TempList(i),"{") + 1,InStr(TempList(i),"}") - InStr(TempList(i),"{") - 1)
				EngineList(j).Async = TempList(i)
				DlgItem$ = "EngineList"
			Case "responseTypeButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				ReDim TempList(3) As String
				TempList(0) = MsgList(46)
				TempList(1) = MsgList(47)
				TempList(2) = MsgList(48)
				TempList(3) = MsgList(49)
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				If i < 0 Then Exit Function
				TempList(i) = Mid(TempList(i),InStr(TempList(i),"{") + 1,InStr(TempList(i),"}") - InStr(TempList(i),"{") - 1)
				EngineList(j).responseType = TempList(i)
				DlgItem$ = "EngineList"
			Case "TranBeforeStrButton","TranAfterStrButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				Call TranTest(DlgValue("EngineList"),1)
				Exit Function
			Case "ImportButton"
				If PSL.SelectFile(Temp,True,Replace(MsgList(25),"%s",MsgList(14)),MsgList(23)) = False Then Exit Function
				Select Case GetEngineSet("Sets",Temp)
				Case -1
					Exit Function
				Case 4
					TempList = getSetNameList(EngineList)
					DlgListBoxArray "EngineList",TempList()
					DlgValue "EngineList",UBound(EngineList)
					MsgBox MsgList(19),vbOkOnly+vbInformation,MsgList(17)
					DlgItem$ = "EngineList"
				Case Else
					MsgBox Replace$(MsgList(21),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End Select
			Case "ExportButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(EngineList)
					If CheckEngineSet(EngineList,i) = False Then
						If MsgBox(Replace$(MsgList(9),"%s",EngineList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				If PSL.SelectFile(Temp,False,Replace(MsgList(25),"%s",MsgList(14)),MsgList(24)) = True Then
					If InStr(Temp,".dat") = 0 Then Temp = Temp & ".dat"
					If WriteEngineSet(Temp,"Sets",1) = False Then
						MsgBox Replace$(MsgList(22),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Else
						MsgBox MsgList(18),vbOkOnly+vbInformation,MsgList(17)
					End If
				End If
				Exit Function
			Case "TestButton"
				j = DlgValue("EngineList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(EngineList)
					If CheckEngineSet(EngineList,i) = False Then
						If MsgBox(Replace$(MsgList(9),"%s",EngineList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				Call TranTest(j,0)
				Exit Function
			End Select

			j = DlgValue("EngineList")
			If j < 0 Then Exit Function
			With EngineList(j)
				If DlgItem$ = "EngineList" Then
					DlgText "ObjectNameBox",IIf(.HttpName <> "",.HttpName,DefaultObject)
					DlgText "AppIDBox",.AppId
					DlgText "UrlBox",.url
					DlgText "UrlTemplateBox",.UrlTemplate
					DlgText "bstrMethodBox",.method
					DlgText "varAsyncBox",.Async
					DlgText "bstrUserBox",.User
					DlgText "bstrPasswordBox",.Password
					DlgText "MD5Box",.MD5
					DlgText "SignBox",.Sign
					DlgText "RequestHeaderBox",.RequestHeader
					DlgText "responseTypeBox",.ResponseType
					Select Case DlgText("responseTypeBox")
					Case "responseText"
						DlgText "TranBeforeStrBox",.TranBeforeStrByText
						DlgText "TranAfterStrBox",.TranAfterStrByText
					Case "responseBody"
						DlgText "TranBeforeStrBox",.TranBeforeStrByBody
						DlgText "TranAfterStrBox",.TranAfterStrByBody
					Case "responseStream"
						DlgText "TranBeforeStrBox",.TranBeforeStrByStream
						DlgText "TranAfterStrBox",.TranAfterStrByStream
					Case "responseXML"
						DlgText "TranBeforeStrBox",.TranXMLIDName
						DlgText "TranAfterStrBox",.TranXMLTagName
					Case Else
						DlgText "TranBeforeStrBox",""
						DlgText "TranAfterStrBox",""
					End Select
					If DlgText("responseTypeBox") = "responseXML" Then
						DlgText "TranBeforeStrText",MsgList(29)
						DlgText "TranAfterStrText",MsgList(30)
					Else
						DlgText "TranBeforeStrText",MsgList(27)
						DlgText "TranAfterStrText",MsgList(28)
					End If
					n = DlgValue("LngNameList")
					If n > -1 Then
						Temp = DlgText("LngNameList")
					End If
					LngNameList = GetLangSet(.LangPairList,0)
					DlgListBoxArray "LngNameList",LngNameList()
					SrcLngList = GetLangSet(.LangPairList,1)
					DlgListBoxArray "SrcLngList",SrcLngList()
					TranLngList = GetLangSet(.LangPairList,2)
					DlgListBoxArray "TranLngList",TranLngList()
					If n > -1 Then
						DlgText "LngNameList",Temp
						n = DlgValue("LngNameList")
					End If
					If n < 0 Then n = 0
					DlgValue "LngNameList",n
					DlgValue "SrcLngList",n
					DlgValue "TranLngList",n
					DlgValue "EnableBox",.Enable
					DlgEnable "ShowAllLngButton",False
				ElseIf DlgValue("Engine") = 2 Then
					.Enable = DlgValue("EnableBox")
				End If
				If DlgValue("Engine") = 1 Then
					If DlgText("LngNameList") = "" Then
						DlgEnable "DelLngButton",False
						DlgEnable "DelAllButton",False

						DlgEnable "EditLngButton",False
						DlgEnable "ExtEditButton",False
						DlgEnable "ResetLngButton",False
						DlgEnable "NullLngButton",False

						DlgEnable "ShowNoNullLngButton",False
						DlgEnable "ShowNullLngButton",False
						DlgEnable "ShowAllLngButton",False
						DlgText "LngNameText",Replace$(MsgList(50),"%s","0")
					Else
						DlgEnable "DelLngButton",True
						DlgEnable "DelAllButton",True

						DlgEnable "EditLngButton",True
						DlgEnable "ExtEditButton",True
						DlgEnable "NullLngButton",IIf(DlgText("TranLngList") = NullValue,False,True)
						DlgEnable "ResetLngButton",False
						Temp = DlgText("LngNameList")
						For i = 0 To UBound(EngineListBak)
							If EngineListBak(i).Name = .Name Then
								For n = 0 To UBound(EngineListBak(i).LangPairList)
									If EngineListBak(i).LangPairList(n).Name = Temp Then
										If EngineListBak(i).LangPairList(n).UseCode <> .LangPairList(n).UseCode Then
											DlgEnable "ResetLngButton",True
										End If
										Exit For
									End If
								Next n
								Exit For
							End If
						Next i
						If DlgEnable("ShowAllLngButton") = False Then
							DlgEnable "ShowNoNullLngButton",True
						ElseIf DlgEnable("ShowNullLngButton") = False Then
							DlgEnable "ShowNoNullLngButton",True
						Else
							DlgEnable "ShowNoNullLngButton",False
						End If
						If DlgEnable("ShowAllLngButton") = False Then
							DlgEnable "ShowNullLngButton",True
						ElseIf DlgEnable("ShowNoNullLngButton") = False Then
							DlgEnable "ShowNullLngButton",True
						Else
							DlgEnable "ShowNullLngButton",False
						End If
						If DlgEnable("ShowNoNullLngButton") = False Or DlgEnable("ShowNullLngButton") = False Then
							DlgEnable "ShowAllLngButton",True
						Else
							DlgEnable "ShowAllLngButton",False
						End If
						DlgText "LngNameText",Replace$(MsgList(50),"%s",CStr$(DlgListBoxArray("LngNameList")))
					End If
				End If
				n = -1
				For i = 0 To UBound(DefaultEngineList)
					If DefaultEngineList(i) = .Name Then
						n = i
						Exit For
					End If
				Next i
				If n > -1 Then
					DlgEnable "ChangButton",False
					DlgEnable "DelButton",False
				Else
					DlgEnable "ChangButton",True
					DlgEnable "DelButton",True
				End If
			End With
		Case 1
			Select Case DlgItem$
			Case "LevelButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(CheckList)
				If SetLevel(TempList,j,MsgList(51)) = False Then Exit Function
				Temp = DlgText("CheckList")
				DlgListBoxArray "CheckList",TempList()
				DlgText "CheckList",Temp
				Set Dic = CreateObject("Scripting.Dictionary")
				For i = 0 To UBound(CheckList)
					If Not Dic.Exists(CheckList(i).Name) Then
						Dic.Add(CheckList(i).Name,i)
					End If
				Next i
				ReDim TempCheck(0) As CHECK_SET
				TempCheck = CheckList
				For i = 0 To UBound(TempList)
					If Dic.Exists(TempList(i)) Then
						TempCheck(n) = CheckList(Dic.Item(TempList(i)))
						n = n + 1
					End If
				Next i
				CheckList = TempCheck
				Set Dic = Nothing
				Exit Function
			Case "AddButton"
				TempList = getSetNameList(CheckList)
				Temp = AddSet(TempList)
				If Temp = "" Then Exit Function
				j = 0
				If CheckArray(TempList) = True Then
					j = UBound(CheckList) + 1
				End If
				ReDim Preserve TempList(j) As String,CheckList(j) As CHECK_SET
				CheckList(j).LangPairList = LangCodeList(Temp,1,-1)
				TempList(j) = Temp
				CheckList(j).Name = Temp
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				DlgItem$ = "CheckList"
			Case "ChangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				TempList = getSetNameList(CheckList)
				Temp = EditSet(TempList,j)
				If Temp = "" Then Exit Function
				TempList(j) = Temp
				CheckList(j).Name = Temp
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				Exit Function
			Case "DelButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				If MsgBox(Replace(MsgList(12),"%s",DlgText("CheckList")),vbYesNo+vbInformation,MsgList(11)) = vbNo Then
					Exit Function
				End If
				Call DelCheckArray(CheckList,j)
				TempList = getSetNameList(CheckList)
				If j = UBound(TempList) + 1 Then j = j - 1
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",j
				DlgItem$ = "CheckList"
			Case "ResetButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				ReDim TempList(1)
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = DlgText("CheckList") Then
						TempList(0) = MsgList(1)
						Exit For
					End If
				Next i
				TempList(1) = MsgList(2)
				For i = 0 To UBound(CheckList)
					If i <> j Then
						ReDim Preserve TempList(i + 2) As String
						TempList(i + 2) = MsgList(3) & " - " & CheckList(i).Name
					End If
				Next i
				i = ShowPopupMenu(TempList,vbPopupUseRightButton)
				Select Case i
				Case Is < 0
					Exit Function
				Case 0
					CheckList(j) = DefaultCheckSet(DlgText("CheckList"),False)
					CheckList(j).Name = DlgText("CheckList")
					CheckList(j).LangPairList = LangCodeList(DlgText("CheckList"),1,-1)
				Case 1
					For n = 0 To UBound(CheckListBak)
						If CheckListBak(n).Name = DlgText("CheckList") Then
							CheckList(j) = CheckListBak(n)
							Exit For
						End If
					Next n
				Case Else
					Temp = Mid(TempList(i),InStr(TempList(i),MsgList(3) & " - ") + Len(MsgList(3) & " - "))
					For n = 0 To UBound(CheckList)
						If CheckList(n).Name = Temp Then
							CheckList(j) = CheckList(n)
							CheckList(j).Name = DlgText("CheckList")
							Exit For
						End If
					Next n
				End Select
				DlgItem$ = "CheckList"
			Case "CleanButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					Select Case DlgValue("SetType")
	    			Case 0
	    				.AccKeyChar = ""
						.AccKeyExcludeChar = ""
						.CheckBracket = ""
						.KeepCharPair = ""
						.ShowAsiaKey = 0
						.AccKeyWithFirstChar = 0
					Case 1
						.CheckEndChar = ""
						.NotTrnEndChar = ""
						.AutoTrnEndChar = ""
					Case 2
						.CheckShortChar = ""
						.CheckShortKey = ""
						.KeepShortKey = ""
					Case 3
						.PreRepStr = ""
						.AppRepStr = ""
					Case 4
						.LineSplitMode = 0
						.PreInsertSplitChar = ""
						.AppInsertSplitChar = ""
						.ReplaceSplitChar = ""
					Case 5
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = ""
						Next i
					End Select
				End With
				DlgItem$ = "CheckList"
			Case "AddLangButton","DelLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "AddLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
							Exit For
						End If
					Next i
					If n < 0 Then Exit Function
					Temp = .LangPairList(n).Name
					If DlgItem$ = "AddLangButton" Then
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgValue("AppLngList")
					Else
						.LangPairList(n).UseCode = ""
						n = DlgValue("UseLngList")
					End If
					If n > 0 Then n = n - 1
					TempList = GetLangSet(.LangPairList,9)
					DlgListBoxArray "AppLngList",TempList()
					TempList = GetLangSet(.LangPairList,10)
					DlgListBoxArray "UseLngList",TempList()
					If DlgItem$ = "AddLangButton" Then
						DlgValue "AppLngList",n
						DlgText "UseLngList",Temp
					Else
						DlgText "AppLngList",Temp
						DlgValue "UseLngList",n
					End If
				End With
			Case "AddAllLangButton","DelAllLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "AddAllLangButton" Then
						ReDim TempList(0) As String
						DlgListBoxArray "AppLngList",TempList()
						TempList = ChangeList(GetLangSet(.LangPairList,0),TempList)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",0
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = .LangPairList(i).PslCode
						Next i
					Else
						ReDim TempList(0) As String
						DlgListBoxArray "UseLngList",TempList()
						TempList = ChangeList(GetLangSet(.LangPairList,0),TempList)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",0
						For i = 0 To UBound(.LangPairList)
							.LangPairList(i).UseCode = ""
						Next i
					End If
				End With
			Case "SetAppLangButton","SetUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					LangPair = SetLang(.LangPairList,-1,IIf(DlgItem$ = "SetAppLangButton",False,True))
					If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
					If CheckArrEmpty(.LangPairList) = True Then
						n = UBound(.LangPairList) + 1
					End If
					ReDim Preserve CheckList(j).LangPairList(n) 'As LANG_SET
					.LangPairList(n) = LangPair
					If DlgItem$ = "SetAppLangButton" Then
						.LangPairList(n).UseCode = ""
						n = DlgListBoxArray("AppLngList")
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgListBoxArray("UseLngList")
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
				Exit Function
			Case "EditAppLangButton","EditUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "EditAppLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
							Exit For
						End If
					Next i
					If n < 0 Then Exit Function
					LangPair = SetLang(.LangPairList,n,IIf(DlgItem$ = "EditAppLangButton",False,True))
					If LangPair.Name = "" Or LangPair.PslCode = "" Then Exit Function
					.LangPairList(n) = LangPair
					If DlgItem$ = "EditAppLangButton" Then
						.LangPairList(n).UseCode = ""
						n = DlgValue("AppLngList")
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						.LangPairList(n).UseCode = .LangPairList(n).PslCode
						n = DlgValue("UseLngList")
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
				Exit Function
			Case "DelAppLangButton","DelUseLangButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				With CheckList(j)
					If DlgItem$ = "DelAppLangButton" Then
						Temp = DlgText("AppLngList")
					Else
						Temp = DlgText("UseLngList")
					End If
					If Temp = "" Then Exit Function
					If MsgBox(Replace(MsgList(13),"%s",Temp),vbYesNo+vbInformation,MsgList(11)) = vbNo Then Exit Function
					n = -1
					For i = 0 To UBound(.LangPairList)
						If .LangPairList(i).Name = Temp Then
							n = i
						End If
					Next i
					If n = -1 Then Exit Function
					Call DelLangPair(.LangPairList,n)
					If DlgItem$ = "DelAppLangButton" Then
						n = DlgValue("AppLngList")
						i = DlgListBoxArray("AppLngList")
						If n = i Then n = n - 1
						TempList = GetLangSet(.LangPairList,9)
						DlgListBoxArray "AppLngList",TempList()
						DlgValue "AppLngList",n
					Else
						n = DlgValue("UseLngList")
						i = DlgListBoxArray("UseLngList")
						If n = i Then n = n - 1
						TempList = GetLangSet(.LangPairList,10)
						DlgListBoxArray "UseLngList",TempList()
						DlgValue "UseLngList",n
					End If
				End With
			Case "ImportButton"
				If PSL.SelectFile(Temp,True,Replace(MsgList(25),"%s",MsgList(15)),MsgList(23)) = False Then Exit Function
				Select Case GetCheckSet("Sets",Temp)
				Case -1
					Exit Function
				Case 4
					TempList = getSetNameList(CheckList)
					DlgListBoxArray "CheckList",TempList()
					DlgValue "CheckList",UBound(CheckList)
					MsgBox MsgList(19),vbOkOnly+vbInformation,MsgList(17)
					DlgItem$ = "CheckList"
				Case Else
					MsgBox Replace$(MsgList(21),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
				End Select
			Case "ExportButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(CheckList)
					If CheckCheckSet(CheckList,i) = False Then
						If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				If PSL.SelectFile(Temp,False,Replace(MsgList(25),"%s",MsgList(15)),MsgList(24)) = True Then
					If InStr(Temp,".dat") = 0 Then Temp = Temp & ".dat"
					If WriteCheckSet(Temp,"Sets",3) = False Then
						MsgBox Replace$(MsgList(22),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
					Else
						MsgBox MsgList(18),vbOkOnly+vbInformation,MsgList(17)
					End If
				End If
				Exit Function
			Case "TestButton"
				j = DlgValue("CheckList")
				If j < 0 Then Exit Function
				For i = 0 To UBound(CheckList)
					If CheckCheckSet(CheckList,i) = False Then
						If MsgBox(Replace$(MsgList(10),"%s",CheckList(i).Name) & MsgList(6),vbYesNo+vbInformation,MsgList(5)) = vbNo Then
							Exit Function
						End If
					End If
				Next i
				Call CheckTest(j,0)
				Exit Function
			End Select

			j = DlgValue("CheckList")
			If j < 0 Then Exit Function
			With CheckList(j)
				If DlgItem$ = "CheckList" Then
					DlgText "ExCrBox",.AccKeyExcludeChar
					DlgText "PreInsertSplitBox",.PreInsertSplitChar
					DlgText "ChkBktBox",.CheckBracket
					DlgText "KpPairBox",.KeepCharPair
					DlgValue "AsiaKeyBox",.ShowAsiaKey
					DlgText "ChkEndBox",.CheckEndChar
					DlgText "NoTrnEndBox",.NotTrnEndChar
					DlgText "AutoTrnEndBox",.AutoTrnEndChar
					DlgText "ShortBox",.CheckShortChar
					DlgText "ShortKeyBox",.CheckShortKey
					DlgText "KpShortKeyBox",.KeepShortKey
					DlgText "PreRepStrBox",.PreRepStr
					DlgText "AutoWebFlagBox",.AppRepStr
					DlgText "AccKeyBox",.AccKeyChar
					DlgValue "AddAcckeyBox",.AccKeyWithFirstChar
					DlgValue "LineSplitModeBox",.LineSplitMode
					DlgText "AppInsertSplitBox",.AppInsertSplitChar
					DlgText "ReplaceSplitBox",.ReplaceSplitChar
					TempList = GetLangSet(.LangPairList,9)
					DlgListBoxArray "AppLngList",TempList()
					TempList = GetLangSet(.LangPairList,10)
					DlgListBoxArray "UseLngList",TempList()
					DlgValue "AppLngList",0
					DlgValue "UseLngList",0
				Else
					.ShowAsiaKey = DlgValue("AsiaKeyBox")
					.AccKeyWithFirstChar = DlgValue("AddAcckeyBox")
					.LineSplitMode = DlgValue("LineSplitModeBox")
				End If
				If DlgText("AppLngList") = "" Then
					DlgEnable "AddLangButton",False
					DlgEnable "AddAllLangButton",False
					DlgEnable "EditAppLangButton",False
					DlgEnable "DelAppLangButton",False
					DlgText "AppLngText",Replace$(MsgList(31),"%s","0")
				Else
					DlgEnable "AddLangButton",True
					DlgEnable "AddAllLangButton",True
					DlgEnable "EditAppLangButton",True
					DlgEnable "DelAppLangButton",True
					DlgText "AppLngText",Replace$(MsgList(31),"%s",CStr$(DlgListBoxArray("AppLngList")))
				End If
				If DlgText("UseLngList") = "" Then
					DlgEnable "DelLangButton",False
					DlgEnable "DelAllLangButton",False
					DlgEnable "EditUseLangButton",False
					DlgEnable "DelUseLangButton",False
					DlgText "UseLngText",Replace$(MsgList(32),"%s","0")
				Else
					DlgEnable "DelLangButton",True
					DlgEnable "DelAllLangButton",True
					DlgEnable "EditUseLangButton",True
					DlgEnable "DelUseLangButton",True
					DlgText "UseLngText",Replace$(MsgList(32),"%s",CStr$(DlgListBoxArray("UseLngList")))
				End If
				If DlgValue("AsiaKeyBox") = 1 Then
					DlgEnable "AddAcckeyBox",False
					DlgValue "AddAcckeyBox",0
				Else
					DlgEnable "AddAcckeyBox",True
				End If
				n = -1
				For i = 0 To UBound(DefaultCheckList)
					If DefaultCheckList(i) = .Name Then
						n = i
						Exit For
					End If
				Next i
				If n > -1 Then
					DlgEnable "ChangButton",False
					DlgEnable "DelButton",False
				Else
					DlgEnable "ChangButton",True
					DlgEnable "DelButton",IIf(UBound(CheckList) = 0,False,True)
				End If
			End With
		Case 2
			Select Case DlgItem$
			Case "ExeBrowseButton"
				If PSL.SelectFile(Temp,True,MsgList(34),MsgList(33)) = False Then Exit Function
				DlgText "CmdPathBox",Temp
				If InStr(LCase$(Temp),"winrar.exe") Then
					DlgText "ArgumentBox","e -ibck ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"winzip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"WinZip.exe","WzunZip.exe")
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"wzunzip.exe") Then
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"7z.exe") Then
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"7zfm.exe") Then
					DlgText "ArgumentBox",strReplace(Temp,"7zFM.exe","7z.exe")
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"HaoZip.exe","HaoZipC.exe")
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozipc.exe") Then
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				End If
			Case "ArgumentButton"
				ReDim TempList(2) As String
				TempList(0) = MsgList(36)
				TempList(1) = MsgList(37)
				TempList(2) = MsgList(38)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%1"""
				Case 1
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%2"""
				Case Else
					DlgText "ArgumentBox",DlgText("ArgumentBox")  & " " & """%3"""
				End Select
			Case "ResetButton"
				ReDim TempList(1) As String
				TempList(0) = MsgList(1)
				TempList(1) = MsgList(2)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0
					DlgValue "UpdateSet",1
					DlgText "WebSiteBox",updateMainUrl & vbCrLf & updateMinorUrl
					TempList = ReSplit(getCMDPath(".rar","",""),JoinStr)
					DlgText "CmdPathBox",TempList(0)
					DlgText "ArgumentBox",TempList(1)
					DlgText "UpdateCycleBox","7"
				Case 1
					DlgValue "UpdateSet",StrToLong(UpdateSetBak(0))
					DlgText "WebSiteBox",UpdateSetBak(1)
					DlgText "CmdPathBox",UpdateSetBak(2)
					DlgText "ArgumentBox",UpdateSetBak(3)
					DlgText "UpdateCycleBox",UpdateSetBak(4)
				End Select
	    	Case "CleanButton"
	    		DlgText "WebSiteBox",""
	    		DlgText "CmdPathBox",""
				DlgText "ArgumentBox",""
	    	Case "CheckButton"
	    		If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    			MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
					Exit Function
	    		End If
				i = Download(UpdateSet,DlgText("WebSiteBox"),3,-2)
	    		If i < 1 Then Exit Function
	    		j = 0
	    		If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
	    			j = 1
	    		ElseIf i = 3 And ArrayComp(UpdateSet,UpdateSetBak) = False Then
	    			j = 1
	    		End If
	    		If j = 1 Then
					DlgText "UpdateDateBox",Format(Date,"yyyy-MM-dd")
					UpdateSet(5) = DlgText("UpdateDateBox")
					Temp = IIf(DlgValue("tWriteType") = 0,EngineFilePath,EngineRegKey)
					If WriteEngineSet(Temp,"Update") = False Then
						MsgBox Replace$(MsgList(20),"%s",Temp),vbOkOnly+vbInformation,MsgList(0)
						Exit Function
					Else
						UpdateSetBak(5) = UpdateSet(5)
					End If
				End If
				If i = 3 Then Call ExitMacro(1)
				Exit Function
			Case "TestButton"
				If DlgText("CmdPathBox") = "" Or DlgText("ArgumentBox") = "" Then
	    			MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
	    			Exit Function
	    		End If
	    		Download(UpdateSet,DlgText("WebSiteBox"),4,-2)
	    		Exit Function
	    	End Select
			UpdateSet(0) = DlgValue("UpdateSet")
			UpdateSet(1) = DlgText("WebSiteBox")
			UpdateSet(2) = DlgText("CmdPathBox")
			UpdateSet(3) = DlgText("ArgumentBox")
			UpdateSet(4) = DlgText("UpdateCycleBox")
			UpdateSet(5) = DlgText("UpdateDateBox")
			If UpdateSet(5) = MsgList(4) Then UpdateSet(5) = ""
		Case 3
			Select Case DlgItem$
			Case "UILangList"
				HeaderID = DlgValue("UILangList")
				If HeaderID < 0 Then Exit Function
				If HeaderID > 1 Then
					If LCase$(tSelected(0)) = LCase$(UIFileList(HeaderID - 2).LangID) Then Exit Function
				Else
					If tSelected(0) = CStr$(HeaderID) Then Exit Function
				End If
			Case "EditUILangButton"
				ReDim FileDataList(UBound(UIFileList)) As String
				For i = 0 To UBound(UIFileList)
					FileDataList(i) = UIFileList(i).FilePath & JoinStr & "unicodeFFFE"
				Next i
				If EditFile(LangFile,FileDataList,True) = False Then Exit Function
				If GetUIList(MacroLoc & "\Data\",UIFileList) = False Then Exit Function
				HeaderID = DlgValue("UILangList")
			Case "MainFontButton","SrcStrFontButton","TrnStrFontButton"
				HeaderID = CLng(DlgText("SuppValueBox"))
				Select Case DlgItem$
				Case "MainFontButton"
					i = 0
				Case "SrcStrFontButton"
					i = 1
				Case "TrnStrFontButton"
					i = 2
				End Select
				ReDim TempList(2) As String
				TempList(0) = MsgList(1)
				TempList(1) = MsgList(2)
				TempList(2) = MsgList(56)
				Select Case ShowPopupMenu(TempList,vbPopupUseRightButton)
				Case Is < 0
					Exit Function
				Case 0	'Ĭ
					If CheckFont(LFList(i)) = False Then Exit Function
					ReDim tmpLFList(0) As LOG_FONT
					LFList(i) = tmpLFList(0)
				Case 1	'ԭֵ
					If FontComp(LFList(i),LFListBak(i)) = False Then Exit Function
					LFList(i) = LFListBak(i)
				Case 2	'Զ
					If SelectFont(HeaderID,LFList(i)) = 0 Then Exit Function
				End Select
				DlgText Replace$(DlgItem$,"Button","Box"),GetFontText(HeaderID,LFList(i))
				If DlgItem$ <> "MainFontButton" Then Exit Function
				'岢ӦõԻ
				j = CreateFont(HeaderID,LFList(0))
				If j = 0 Then Exit Function
				For i = 0 To DlgCount() - 1
					n = GetDlgItem(HeaderID,DlgControlId(DlgName(i)))
					SendMessageLNG(n,WM_SETFONT,j,0)
				Next i
				DrawWindow(HeaderID,j)
				Exit Function
			Case Else
				Exit Function
			End Select

			If HeaderID > 1 Then
				Temp = UIFileList(HeaderID - 2).FilePath
			Else
				If HeaderID = 0 Then
					n = Val("&H" & OSLanguage)
				Else
					n = PSL.Option(pslOptionSystemLanguage)
				End If
				For i = 0 To UBound(UIFileList)
					TempList = ReSplit(LCase$(UIFileList(i).LangID),";")
					For j = 0 To UBound(TempList)
						If Val("&H" & TempList(j)) = n Then
							Temp = UIFileList(i).FilePath
							Exit For
						End If
					Next j
					If Temp <> "" Then Exit For
				Next i
			End If
			If Temp = "" Then Exit Function
			If Dir$(Temp) = "" Then Exit Function
			If getINIFile(UIDataList,Temp,"unicodeFFFE",0) = False Then Exit Function
			If DlgItem$ = "UILangList" Then
				If HeaderID < 2 Then
					tSelected(0) = CStr(HeaderID)
				Else
					tSelected(0) = UIFileList(HeaderID - 2).LangID
				End If
			End If
			LangFile = Temp

			'»ȡַб
			CodeList = getCodePageList(0,49)
			'öԻִ
			If getMsgList(UIDataList,MsgList,"Settings",1) = True Then
				DlgText -1,MsgList(0)
				DlgText "MainText",MsgList(1)
				DlgText "StrHandle",MsgList(2)
				DlgText "AutoUpdate",MsgList(3)
				DlgText "UILangListSet",MsgList(4)

				DlgText "GroupBox1",MsgList(5)
				DlgText "LevelButton",MsgList(6)
				DlgText "AddButton",MsgList(7)
				DlgText "ChangButton",MsgList(8)
				DlgText "DelButton",MsgList(9)

				DlgText "GroupBox2",MsgList(10)
				DlgText "cWriteToFile",MsgList(11)
				DlgText "cWriteToRegistry",MsgList(12)
				DlgText "ImportButton",MsgList(13)
				DlgText "ExportButton",MsgList(14)

				DlgText "GroupBox3",MsgList(15)
				DlgText "SetItemText",MsgList(16)
				DlgText "NextSetType",MsgList(17)

				DlgText "AccKeyBoxTxt",MsgList(18)
				DlgText "ExCrBoxTxt",MsgList(19)
				DlgText "ChkBktBoxTxt",MsgList(20)
				DlgText "KpPairBoxTxt",MsgList(21)
				DlgText "AsiaKeyBox",MsgList(22)
				DlgText "AddAcckeyBox",MsgList(23)

				DlgText "ChkEndBoxTxt",MsgList(24)
				DlgText "NoTrnEndBoxTxt",MsgList(25)
				DlgText "AutoTrnEndBoxTxt",MsgList(26)

				DlgText "ShortBoxTxt",MsgList(27)
				DlgText "ShortKeyBoxTxt",MsgList(28)
				DlgText "KpShortKeyBoxTxt",MsgList(29)

				DlgText "PreRepStrBoxTxt",MsgList(30)
				DlgText "AutoWebFlagBoxTxt",MsgList(31)

				DlgText "LineSplitBoxTxt",MsgList(32)
				DlgText "PreInsertSplitBoxTxt",MsgList(33)
				DlgText "AppInsertSplitBoxTxt",MsgList(34)
				DlgText "ReplaceSplitBoxTxt",MsgList(35)
				DlgText "LineSplitModeBox",MsgList(36)

				DlgText "AppLngText",MsgList(37)
				DlgText "UseLngText",MsgList(38)
				DlgText "AddLangButton",MsgList(39)
				DlgText "AddAllLangButton",MsgList(40)
				DlgText "DelLangButton",MsgList(41)
				DlgText "DelAllLangButton",MsgList(42)
				DlgText "SetAppLangButton",MsgList(43)
				DlgText "EditAppLangButton",MsgList(44)
				DlgText "DelAppLangButton",MsgList(45)
				DlgText "SetUseLangButton",MsgList(46)
				DlgText "EditUseLangButton",MsgList(47)
				DlgText "DelUseLangButton",MsgList(48)

				DlgText "UpdateSetGroup",MsgList(49)
				DlgText "AutoButton",MsgList(50)
				DlgText "ManualButton",MsgList(51)
				DlgText "OffButton",MsgList(52)
				DlgText "CheckGroup",MsgList(53)
				DlgText "UpdateCycleText",MsgList(54)
				DlgText "UpdateDatesText",MsgList(55)
				DlgText "UpdateDateText",MsgList(56)
				DlgText "CheckButton",MsgList(57)
				DlgText "WebSiteGroup",MsgList(58)
				DlgText "CmdGroup",MsgList(59)
				DlgText "CmdPathBoxText",MsgList(60)
				DlgText "ArgumentBoxText",MsgList(61)
				DlgText "ExeBrowseButton",MsgList(6)
				DlgText "ArgumentButton",MsgList(62)

				DlgText "UILangSetGroup",MsgList(63)
				DlgText "UILangSetText1",MsgList(64)
				DlgText "UILangSetText2",MsgList(65)
				DlgText "UILangSetText3",MsgList(66)

				DlgText "UIFontSetGroup",MsgList(67)
				DlgText "MainFontText",MsgList(68)
				DlgText "MainFontButton",MsgList(69)

				DlgText "HelpButton",MsgList(70)
				DlgText "ResetButton",MsgList(71)
				DlgText "TestButton",MsgList(72)
				DlgText "CleanButton",MsgList(73)
				DlgText "EditUILangButton",MsgList(74)

				DlgText "TrnEngine",MsgList(75)
				DlgText "tWriteToFile",MsgList(11)
				DlgText "tWriteToRegistry",MsgList(12)

				DlgText "GroupBox4",MsgList(15)
				DlgText "EngineArgument",MsgList(76)
				DlgText "LangCodePair",MsgList(77)
				DlgText "EngineEnable",MsgList(78)

				'DlgText "ObjectNameText",MsgList(79)
				DlgText "AppIDText",MsgList(80)
				DlgText "UrlText",MsgList(81)
				DlgText "UrlTemplateText",MsgList(82)
				DlgText "bstrMethodText",MsgList(83)
				DlgText "varAsyncText",MsgList(84)
				DlgText "bstrUserText",MsgList(85)
				DlgText "bstrPasswordText",MsgList(86)
				DlgText "MD5Text",MsgList(79)
				DlgText "SignText",MsgList(87)
				DlgText "RequestHeaderText",MsgList(88)
				DlgText "RequestHeaderText2",MsgList(89)
				DlgText "responseTypeText",MsgList(90)
				DlgText "TranBeforeStrText",MsgList(91)
				DlgText "TranAfterStrText",MsgList(92)
				DlgText "MD5Button",MsgList(69)
				DlgText "UrlTemplateButton",MsgList(69)
				DlgText "bstrMethodButton",MsgList(69)
				DlgText "varAsyncButton",MsgList(69)
				DlgText "RequestButton",MsgList(69)
				DlgText "responseTypeButton",MsgList(69)
				DlgText "TranBeforeStrButton",MsgList(69)
				DlgText "TranAfterStrButton",MsgList(69)

				DlgText "LngNameText",MsgList(93)
				DlgText "SrcLngText",MsgList(94)
				DlgText "TranLngText",MsgList(95)
				DlgText "AddLngButton",MsgList(7)
				DlgText "DelLngButton",MsgList(9)
				DlgText "DelAllButton",MsgList(96)
				DlgText "EditLngButton",MsgList(97)
				DlgText "ExtEditButton",MsgList(98)
				DlgText "NullLngButton",MsgList(99)
				DlgText "ResetLngButton",MsgList(100)
				DlgText "ShowNoNullLngButton",MsgList(101)
				DlgText "ShowNullLngButton",MsgList(102)
				DlgText "ShowAllLngButton",MsgList(103)

				DlgText "EnableText1",MsgList(104)
				DlgText "EnableText2",MsgList(105)
				DlgText "EnableBox",MsgList(106)
			End If
			'öԻִ
			If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = True Then
				TempList = ReSplit(MsgList(53),";")
				i = DlgValue("SetType")
				DlgListBoxArray "SetType",TempList()
				DlgValue "SetType",i
				ReDim TempList(UBound(UIFileList) + 2) As String
				For i = 0 To UBound(UIFileList) + 2
					Select Case i
					Case 0
						TempList(i) = MsgList(54)
					Case 1
						TempList(i) = MsgList(55)
					Case Else
						TempList(i) = UIFileList(i - 2).LangName
					End Select
				Next i
				DlgListBoxArray "UILangList",TempList()
				DlgValue "UILangList",HeaderID
			End If
			'Իִ
			If getMsgList(UIDataList,MsgList,"Main",1) = True Then
				'滻༭߲˵
				TempList = ReSplit(MsgList(3),";")
				Tools(0).sName = TempList(0)
				Tools(1).sName = TempList(1)
				Tools(2).sName = TempList(2)
				Tools(3).sName = TempList(3)
				'滻
				TempList = ReSplit(MsgList(4),";")
				For i = 0 To UBound(EngineList)
					Select Case EngineList(i).Name
					Case DefaultEngineList(0)
						EngineList(i).Name = TempList(0)
					Case DefaultEngineList(1)
						EngineList(i).Name = TempList(1)
					Case DefaultEngineList(2)
						EngineList(i).Name = TempList(2)
					End Select
				Next i
				'滻ݷ
				For i = 0 To UBound(EngineListBak)
					Select Case EngineListBak(i).Name
					Case DefaultEngineList(0)
						EngineListBak(i).Name = TempList(0)
					Case DefaultEngineList(1)
						EngineListBak(i).Name = TempList(1)
					Case DefaultEngineList(2)
						EngineListBak(i).Name = TempList(2)
					End Select
				Next i
				'滻ĬϷ
				Select Case tSelected(1)
				Case DefaultEngineList(0)
					tSelected(1) = TempList(0)
				Case DefaultEngineList(1)
					tSelected(1) = TempList(1)
				Case DefaultEngineList(2)
					tSelected(1) = TempList(2)
				End Select
				'ĬϷб
				DefaultEngineList(0) = TempList(0)
				DefaultEngineList(1) = TempList(1)
				DefaultEngineList(2) = TempList(2)
				n = DlgValue("EngineList")
				TempList = getSetNameList(EngineList)
				DlgListBoxArray "EngineList",TempList()
				DlgValue "EngineList",n
				'滻
				TempList = ReSplit(MsgList(5),";")
				For i = 0 To UBound(CheckList)
					Select Case CheckList(i).Name
					Case DefaultCheckList(0)
						CheckList(i).Name = TempList(0)
					Case DefaultCheckList(1)
						CheckList(i).Name = TempList(1)
					End Select
				Next i
				'滻ݷ
				For i = 0 To UBound(CheckListBak)
					Select Case CheckListBak(i).Name
					Case DefaultCheckList(0)
						CheckListBak(i).Name = TempList(0)
					Case DefaultCheckList(1)
						CheckListBak(i).Name = TempList(1)
					End Select
				Next i
				'滻ĬϷ
				Select Case tSelected(2)
				Case DefaultCheckList(0)
					tSelected(2) = TempList(0)
				Case DefaultCheckList(1)
					tSelected(2) = TempList(1)
				End Select
				'ĬϷб
				DefaultCheckList(0) = TempList(0)
				DefaultCheckList(1) = TempList(1)
				n = DlgValue("CheckList")
				TempList = getSetNameList(CheckList)
				DlgListBoxArray "CheckList",TempList()
				DlgValue "CheckList",n
				'滻鷽
				TempList = ReSplit(MsgList(6),";")
				For i = 0 To UBound(ProjectList)
					Select Case ProjectList(i).Name
					Case DefaultProjectList(0)
						ProjectList(i).Name = TempList(0)
					Case DefaultProjectList(1)
						ProjectList(i).Name = TempList(1)
					Case DefaultProjectList(2)
						ProjectList(i).Name = TempList(2)
					Case DefaultProjectList(3)
						ProjectList(i).Name = TempList(3)
					Case DefaultProjectList(4)
						ProjectList(i).Name = TempList(4)
					End Select
				Next i
				'滻ݷ鷽
				For i = 0 To UBound(ProjectListBak)
					Select Case ProjectListBak(i).Name
					Case DefaultProjectList(0)
						ProjectListBak(i).Name = TempList(0)
					Case DefaultProjectList(1)
						ProjectListBak(i).Name = TempList(1)
					Case DefaultProjectList(2)
						ProjectListBak(i).Name = TempList(2)
					Case DefaultProjectList(3)
						ProjectListBak(i).Name = TempList(3)
					Case DefaultProjectList(4)
						ProjectListBak(i).Name = TempList(4)
					End Select
				Next i
				'ĬϷб
				DefaultProjectList(0) = TempList(0)
				DefaultProjectList(1) = TempList(1)
				DefaultProjectList(2) = TempList(2)
				DefaultProjectList(3) = TempList(3)
				DefaultProjectList(4) = TempList(4)
				'ֹͣťʱʾԻϵϢ
				StopTitle = MsgList(40)
				StopMsg = MsgList(41)
			End If
		End Select
	Case 3 ' ıϿı
		Select Case DlgValue("Options")
		Case 0
			If DlgValue("Engine") <> 0 Then Exit Function
			j = DlgValue("EngineList")
			If j < 0 Then Exit Function
			With EngineList(j)
				.HttpName = Trim(DlgText("ObjectNameBox"))
				.AppId = Trim(DlgText("AppIDBox"))
				.url = Trim(DlgText("UrlBox"))
				.UrlTemplate = Trim(DlgText("UrlTemplateBox"))
				.method = Trim(DlgText("bstrMethodBox"))
				.Async = Trim(DlgText("varAsyncBox"))
				.User = Trim(DlgText("bstrUserBox"))
				.Password = Trim(DlgText("bstrPasswordBox"))
				.Sign = Trim(DlgText("SignBox"))
				.MD5 = Trim(DlgText("MD5Box"))
				.RequestHeader = Trim(DlgText("RequestHeaderBox"))
				.ResponseType = Trim(DlgText("responseTypeBox"))
				Select Case .ResponseType
				Case "responseText"
					.TranBeforeStrByText = Trim(DlgText("TranBeforeStrBox"))
					.TranAfterStrByText = Trim(DlgText("TranAfterStrBox"))
				Case "responseBody"
					.TranBeforeStrByBody = Trim(DlgText("TranBeforeStrBox"))
					.TranAfterStrByBody = Trim(DlgText("TranAfterStrBox"))
				Case "responseStream"
					.TranBeforeStrByStream = Trim(DlgText("TranBeforeStrBox"))
					.TranAfterStrByStream = Trim(DlgText("TranAfterStrBox"))
				Case "responseXML"
					.TranXMLIDName = Trim(DlgText("TranBeforeStrBox"))
					.TranXMLTagName = Trim(DlgText("TranAfterStrBox"))
				End Select
				If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
				If .ResponseType = "responseXML" Then
					DlgText "TranBeforeStrText",MsgList(29)
					DlgText "TranAfterStrText",MsgList(30)
				Else
					DlgText "TranBeforeStrText",MsgList(27)
					DlgText "TranAfterStrText",MsgList(28)
				End If
			End With
		Case 1
			If DlgValue("SetType") = 5 Then Exit Function
			j = DlgValue("CheckList")
			If j < 0 Then Exit Function
			With CheckList(j)
				Select Case DlgValue("SetType")
				Case 0
					.AccKeyChar = RemoveSpaces(DlgText("AccKeyBox"),",")
					.AccKeyExcludeChar = DlgText("ExCrBox")
					.CheckBracket = RemoveSpaces(DlgText("ChkBktBox"),",")
					.KeepCharPair = RemoveSpaces(DlgText("KpPairBox"),",")
					.ShowAsiaKey = DlgValue("AsiaKeyBox")
					.AccKeyWithFirstChar = DlgValue("AddAcckeyBox")
				Case 1
					.CheckEndChar = RemoveSpaces(DlgText("ChkEndBox")," ")
					.NotTrnEndChar = RemoveSpaces(DlgText("NoTrnEndBox"),",")
					.AutoTrnEndChar = RemoveSpaces(DlgText("AutoTrnEndBox")," ")
				Case 2
					.CheckShortChar = RemoveSpaces(DlgText("ShortBox"),",")
					.CheckShortKey = RemoveSpaces(DlgText("ShortKeyBox"),",")
					.KeepShortKey = RemoveSpaces(DlgText("KpShortKeyBox"),",")
				Case 3
					.PreRepStr = DlgText("PreRepStrBox")
					.AppRepStr = DlgText("AutoWebFlagBox")
				Case 4
					.LineSplitMode = DlgValue("LineSplitModeBox")
					.PreInsertSplitChar = RemoveSpaces(DlgText("PreInsertSplitBox"),",")
					.AppInsertSplitChar = RemoveSpaces(DlgText("AppInsertSplitBox"),",")
					.ReplaceSplitChar = RemoveSpaces(DlgText("ReplaceSplitBox"),",")
				End Select
			End With
		Case 2
			If getMsgList(UIDataList,MsgList,"SettingsDlgFunc",1) = False Then Exit Function
			Select Case DlgItem$
			Case "CmdPathBox"
				'Զ
				If DlgText("CmdPathBox") = "" Then
	    			MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
					Exit Function
				ElseIf Dir$(DlgText("CmdPathBox")) = "" Then
					MsgBox MsgList(16),vbOkOnly+vbInformation,MsgList(0)
					Exit Function
	    		End If
				Temp = Trim(DlgText("CmdPathBox"))
				If InStr(LCase$(Temp),"winrar.exe") Then
					DlgText "ArgumentBox","e -ibck ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"winzip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"WinZip.exe","WzunZip.exe")
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"wzunzip.exe") Then
					DlgText "ArgumentBox"," ""%1"" %2 ""%3"""
				ElseIf InStr(LCase$(Temp),"7z.exe") Then
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"7zfm.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"7zFM.exe","7z.exe")
					DlgText "ArgumentBox","e -r ""%1"" -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozip.exe") Then
					DlgText "CmdPathBox",strReplace(Temp,"HaoZip.exe","HaoZipC.exe")
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				ElseIf InStr(LCase$(Temp),"haozipc.exe") Then
					DlgText "ArgumentBox","e ""%1"" -r -o""%3"" %2"
				End If
				UpdateSet(2) = Temp
			Case "ArgumentBox"
				If DlgText("ArgumentBox") = "" Then
					MsgBox MsgList(35),vbInformation+vbOkOnly,MsgList(0)
					Exit Function
				End If
				UpdateSet(3) = DlgText("ArgumentBox")
			Case Else
				UpdateSet(0) = DlgValue("UpdateSet")
				UpdateSet(1) = DlgText("WebSiteBox")
				UpdateSet(4) = DlgText("UpdateCycleBox")
				UpdateSet(5) = DlgText("UpdateDateBox")
				If UpdateSet(5) = MsgList(4) Then UpdateSet(5) = ""
			End Select
		End Select
	End Select
End Function


'ӻ༭Զ
'LangID = -1 (ƿɱ༭)༭(Ʋɱ༭)
Private Function EditLang(LangSetList() As LANG_SET,ByVal LangID As Long) As LANG_SET
	Dim i As Long,Temp As String,MsgList() As String
	If getMsgList(UIDataList,MsgList,"EditLang",1) = False Then Exit Function
	If LangID > -1 Then Temp = LangSetList(LangID).Name
	Begin Dialog UserDialog 390,189,IIf(Temp = "",MsgList(0),MsgList(1)),.LangDlgFunc ' %GRID:10,7,1,1
		Text 10,7,370,14,MsgList(2),.LangText
		TextBox 10,28,370,21,.LangName
		Text 10,56,370,14,MsgList(3),.SrcCodeText
		TextBox 10,77,370,21,.SrcCode
		Text 10,105,370,14,MsgList(4),.TranCodeText
		TextBox 10,126,370,21,.TarnCode
		OKButton 90,161,80,21,.OKButton
		CancelButton 220,161,80,21,.CancelButton
	End Dialog
    Dim dlg As UserDialog
    If LangID > -1 Then
    	dlg.LangName = LangSetList(LangID).Name
    	dlg.SrcCode = LangSetList(LangID).PslCode
    	dlg.TarnCode = LangSetList(LangID).UseCode
    End If
    StartDlg:
    If Dialog(dlg) = 0 Then Exit Function
    If LangID > -1 Then
		If dlg.SrcCode = "" Then
			MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(5)
			GoTo StartDlg
		End If
		If LCase$(dlg.SrcCode) <> LCase$(LangSetList(LangID).PslCode) Then
			For i = 0 To UBound(LangSetList)
				If LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
					MsgBox MsgList(9),vbOkOnly+vbInformation,MsgList(5)
					GoTo StartDlg
				End If
			Next i
		End If
	Else
		If dlg.LangName = "" Or dlg.SrcCode = "" Then
			MsgBox MsgList(7),vbOkOnly+vbInformation,MsgList(5)
			GoTo StartDlg
		End If
		For i = 0 To UBound(LangSetList)
			If LCase$(dlg.LangName) = LCase$(LangSetList(i).Name) Then
				MsgBox MsgList(8),vbOkOnly+vbInformation,MsgList(5)
				GoTo StartDlg
			ElseIf LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
				MsgBox MsgList(9),vbOkOnly+vbInformation,MsgList(5)
				GoTo StartDlg
			End If
		Next i
	End If
	Select Case LCase$(dlg.TarnCode)
	Case ""
		If MsgBox(MsgList(10),vbYesNo+vbInformation,MsgList(5)) = vbYes Then GoTo StartDlg
	Case "null"
		dlg.TarnCode = ""
	End Select
	EditLang.Name = dlg.LangName
	EditLang.PslCode = dlg.SrcCode
	EditLang.UseCode = dlg.TarnCode
End Function


'ӻ༭Զ
'LangID = -1 (ƿɱ༭)༭(Ʋɱ༭)
Private Function SetLang(LangSetList() As LANG_SET,ByVal LangID As Long,ByVal Mode As Boolean) As LANG_SET
	Dim i As Long,Temp As String,MsgList() As String
	If getMsgList(UIDataList,MsgList,"SetLang",1) = False Then Exit Function
	If LangID > -1 Then Temp = LangSetList(LangID).Name
	Begin Dialog UserDialog 390,168,IIf(Temp = "",MsgList(0),MsgList(1)),.LangDlgFunc ' %GRID:10,7,1,1
		Text 10,14,370,14,MsgList(2),.LangText
		TextBox 10,35,370,21,.LangName
		Text 10,77,370,14,MsgList(3),.CodeText
		TextBox 10,98,370,21,.SrcCode
		OKButton 90,140,80,21,.OKButton
		CancelButton 220,140,80,21,.CancelButton
	End Dialog
    Dim dlg As UserDialog
    If LangID > -1 Then
    	dlg.LangName = LangSetList(LangID).Name
    	dlg.SrcCode = LangSetList(LangID).PslCode
    End If
    StartDlg:
    If Dialog(dlg) = 0 Then Exit Function
	If LangID > -1 Then
		If dlg.SrcCode = "" Then
			MsgBox MsgList(5),vbOkOnly+vbInformation,MsgList(4)
			GoTo StartDlg
		End If
		If LCase$(dlg.SrcCode) <> LCase$(LangSetList(LangID).PslCode) Then
			For i = 0 To UBound(LangSetList)
				If LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
					MsgBox MsgList(8),vbOkOnly+vbInformation,MsgList(4)
					GoTo StartDlg
				End If
			Next i
		End If
	Else
		If dlg.LangName = "" Or dlg.SrcCode = "" Then
			MsgBox MsgList(6),vbOkOnly+vbInformation,MsgList(4)
			GoTo StartDlg
		End If
		For i = 0 To UBound(LangSetList)
			If LCase$(dlg.LangName) = LCase$(LangSetList(i).Name) Then
				MsgBox MsgList(7),vbOkOnly+vbInformation,MsgList(4)
				GoTo StartDlg
			ElseIf LCase$(dlg.SrcCode) = LCase$(LangSetList(i).PslCode) Then
				MsgBox MsgList(8),vbOkOnly+vbInformation,MsgList(4)
				GoTo StartDlg
			End If
		Next i
	End If
	SetLang.Name = dlg.LangName
	SetLang.PslCode = dlg.SrcCode
	SetLang.UseCode = IIf(Mode = False,"",dlg.SrcCode)
End Function


'Ա༭Ի
Private Function LangDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,LangName As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		LangName = LCase$(DlgText("LangName"))
		If LangName <> "" Then
			For i = 0 To UBound(PslLangList)
				If LCase$(PslLangList(i).Name) = LangName Then
					DlgEnable "LangName",False
					Exit For
				End If
			Next i
		End If
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 3 ' ıϿı
		Select Case DlgItem$
		Case "LangName"
			DlgText "LangName",Trim$(DlgText("LangName"))
		Case "SrcCode"
			DlgText "SrcCode",Trim$(DlgText("SrcCode"))
			If DlgText("SrcCode") = "" Then Exit Function
			If DlgText("LangName") <> "" Then Exit Function
			LangName = PSL.GetLangCode(PSL.GetLangID(DlgText("SrcCode"),pslCode639_1),pslCodeText)
			If LangName = "3FF3F" Then
				LangName = PSL.GetLangCode(PSL.GetLangID(DlgText("SrcCode"),pslCodeLangRgn),pslCodeText)
			End If
			If LangName <> "3FF3F" Then DlgText "LangName",LangName
		Case "TarnCode"
			DlgText "TarnCode",Trim$(DlgText("TarnCode"))
		End Select
	End Select
End Function


'ȼ
Private Function SetLevel(LevelList() As String,ByVal ID As Long,ByVal Msg As String) As Boolean
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"SetLevel",1) = False Then Exit Function
	UseStrList = LevelList
	AllStrList = LevelList
	Begin Dialog UserDialog 480,322,MsgList(0),.SetLevelDlgFunc ' %GRID:10,7,1,1
		Text 10,7,460,105,Msg
		ListBox 10,119,360,161,LevelList(),.LevelList
		PushButton 380,119,90,21,MsgList(1),.UpButton
		PushButton 380,147,90,21,MsgList(2),.DownButton
		PushButton 380,175,90,21,MsgList(3),.ResetButton
		OKButton 130,294,80,21,.OKButton
		CancelButton 280,294,80,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.LevelList = ID
	If Dialog(dlg) = 0 Then Exit Function
	If ArrayComp(UseStrList,AllStrList) = True Then
		SetLevel = True
		LevelList = UseStrList
	End If
	Erase UseStrList,AllStrList
End Function


'ȼԻ
Private Function SetLevelDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,Temp As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If UBound(UseStrList) = 0 Then
			DlgEnable "UpButton",False
			DlgEnable "DownButton",False
		Else
			Select Case DlgValue("LevelList")
			Case Is < 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",False
			Case 0
				DlgEnable "UpButton",False
			Case DlgListBoxArray("LevelList") - 1
				DlgEnable "DownButton",False
			Case Else
				DlgEnable "DownButton",True
			End Select
		End If
		DlgEnable "ResetButton",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		SetLevelDlgFunc = True 'ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton","OKButton"
			SetLevelDlgFunc = False
			Exit Function
		Case "UpButton"
			i = DlgValue("LevelList")
			If i = 0 Then Exit Function
			Temp = UseStrList(i)
			UseStrList(i) = UseStrList(i - 1)
			UseStrList(i - 1) = Temp
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",i - 1
		Case "DownButton"
			i = DlgValue("LevelList")
			If i = UBound(UseStrList) Then Exit Function
			Temp = UseStrList(i)
			UseStrList(i) = UseStrList(i + 1)
			UseStrList(i + 1) = Temp
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",i + 1
		Case "ResetButton"
			UseStrList = AllStrList
			DlgListBoxArray "LevelList",UseStrList()
			DlgValue "LevelList",0
		End Select
		If UBound(UseStrList) = 0 Then
			DlgEnable "UpButton",False
			DlgEnable "DownButton",False
		Else
			Select Case DlgValue("LevelList")
			Case Is < 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",False
			Case 0
				DlgEnable "UpButton",False
				DlgEnable "DownButton",True
			Case DlgListBoxArray("LevelList") - 1
				DlgEnable "UpButton",True
				DlgEnable "DownButton",False
			Case Else
				DlgEnable "UpButton",True
				DlgEnable "DownButton",True
			End Select
		End If
		DlgEnable "ResetButton",ArrayComp(UseStrList,AllStrList)
	End Select
End Function


'ȡʷ¼
'Separator Ϊʱ÷ʽȡ
'Separator Ϊʱ׷ӷʽȡ Separator Чֵظ
'߷
Private Sub TranTest(ByVal EngineID As Long,ByVal Mode As Long)
	Dim MsgList() As String,TempList() As String
	If getMsgList(UIDataList,MsgList,"TranTest",1) = False Then Exit Sub
	TempList = getSetNameList(EngineList)
	Begin Dialog UserDialog 660,518,MsgList(0),.TranTestFunc ' %GRID:10,7,1,1
		GroupBox 10,42,640,70,"",.GroupBox
		Text 10,7,640,28,MsgList(1),.MainText
		Text 30,59,90,14,MsgList(2),.SetNameText
		DropListBox 130,56,200,21,TempList(),.EngineListBox
		Text 340,59,90,14,MsgList(3),.LngNameText
		DropListBox 430,56,200,21,TempList(),.LngNameListBox
		Text 30,87,90,14,MsgList(4),.TrnListText
		DropListBox 130,84,300,21,TempList(),.TrnListBox
		Text 450,87,120,14,MsgList(5),.LineNumText
		TextBox 580,84,50,21,.LineNumBox
		Text 10,126,360,14,MsgList(6),.InText
		TextBox 10,147,640,147,.InTextBox,1
		OptionGroup .StrType
			OptionButton 380,126,130,14,MsgList(8),.SrcString
			OptionButton 520,126,130,14,MsgList(9),.TranString
		Text 10,301,360,14,MsgList(7),.OutText
		TextBox 10,322,640,154,.OutTextBox,1
		OptionGroup .TranType
			OptionButton 380,301,130,14,MsgList(10),.TranOnly
			OptionButton 520,301,130,14,MsgList(11),.AllTran
		PushButton 10,490,100,21,MsgList(12),.HelpButton
		PushButton 120,490,100,21,MsgList(13),.TestButton
		PushButton 230,490,100,21,MsgList(14),.HeaderButton
		PushButton 340,490,100,21,MsgList(15),.ClearButton
		CancelButton 550,490,100,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.EngineListBox = EngineID
	dlg.TranType = Mode
	If Dialog(dlg) = 0 Then Exit Sub
End Sub


'ԶԻ
Private Function TranTestFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,n As Long,m As Long,LangPair As LANG_SET
	Dim TempList() As String,MsgList() As String
	Dim TrnList As PslTransList,xmlHttp As Object,Temp As String
	Select Case Action%
	Case 1
		If getMsgList(UIDataList,MsgList,"TranTestFunc",1) = False Then Exit Function
		If trn.SourceList.LastChange > trn.LastUpdate Then trn.Update
		m = 10
		If trn.StringCount < m Then m = trn.StringCount
		DlgText "LineNumBox",CStr$(m)
		If m < 1 Then m = 1
		ReDim TempList(m - 1) As String
		For i = 1 To trn.StringCount
			If trn.String(i).Text <> "" Then
				If DlgValue("StrType") = 0 Then
					TempList(n) = trn.String(i).SourceText
				Else
					TempList(n) = trn.String(i).Text
				End If
				n = n + 1
				If n = m Then Exit For
			End If
		Next i
		ReDim Preserve TempList(IIf(n = 0,0,n - 1)) As String
		DlgText "InTextBox",Join$(TempList,vbCrLf)
		If DlgText("InTextBox") <> "" Then
			DlgText "ClearButton",MsgList(0)
		Else
			DlgText "ClearButton",MsgList(1)
			DlgEnable "TestButton",False
			DlgEnable "ClearButton",False
			DlgEnable "HeaderButton",False
		End If
		n = 0: m = 0
		j = DlgValue("EngineListBox")
		If j > -1 Then
			With LangPair
				.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
				If .UseCode = "" Or .UseCode = "zh" Then
					.UseCode = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
					Select Case .UseCode
					Case "zh-CHS" ,"zh-SG"
						.UseCode = "zh-CN"
					Case "zh-CHT", "zh-HK", "zh-MO"
						.UseCode = "zh-TW"
					End Select
				Else
					.UseCode = .UseCode & LngJoinStr & PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
				End If
				Temp = LngJoinStr & LCase$(.UseCode) & LngJoinStr
			End With
			With EngineList(j)
				ReDim TempList(UBound(.LangPairList)) As String
				For i = 0 To UBound(.LangPairList)
					If .LangPairList(i).UseCode <> "" Then
						TempList(n) = .LangPairList(i).Name
						If InStr(Temp,LngJoinStr & LCase$(.LangPairList(i).PslCode) & LngJoinStr) Then m = n
						n = n + 1
					End If
				Next i
			End With
		End If
		ReDim Preserve TempList(IIf(n = 0,0,n - 1)) As String
		DlgListBoxArray "LngNameListBox",TempList()
		DlgValue "LngNameListBox",m
		If trn.Project.TransLists.Count > 0 Then
			ReDim TempList(trn.Project.TransLists.Count - 1) As String
			For i = 1 To trn.Project.TransLists.Count
				Set TrnList = trn.Project.TransLists(i)
				TempList(i - 1) = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText)
			Next i
			DlgListBoxArray "TrnListBox",TempList()
		End If
		DlgText "TrnListBox",trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		TranTestFunc = True 'ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			TranTestFunc = False '°ťرնԻ򴰿
			Exit Function
		Case "HelpButton"
			Call Help("EngineTestHelp")
			Exit Function
		Case "EngineListBox"
			j = DlgValue("EngineListBox")
			If j < 0 Then Exit Function
			With EngineList(j)
				ReDim TempList(UBound(.LangPairList)) As String
				For i = 0 To UBound(.LangPairList)
					If .LangPairList(i).UseCode <> "" Then
						TempList(n) = .LangPairList(i).Name
						n = n + 1
					End If
				Next i
			End With
			ReDim Preserve TempList(IIf(n = 0,0,n - 1)) As String
			Temp = DlgText("LngNameListBox")
			DlgListBoxArray "LngNameListBox",TempList()
			DlgText "LngNameListBox",Temp
			If DlgText("LngNameListBox") = "" Then DlgValue "LngNameListBox",0
		Case "TrnListBox", "StrType", "ClearButton"
			If getMsgList(UIDataList,MsgList,"TranTestFunc",1) = False Then Exit Function
			If DlgItem$ <> "ClearButton" Or DlgText("ClearButton") = MsgList(1) Then
				Temp = DlgText("TrnListBox")
				Set TrnList = trn
				For i = 1 To trn.Project.TransLists.Count
					Set TrnList = trn.Project.TransLists(i)
					If Temp = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText) Then Exit For
				Next i
				If TrnList.SourceList.LastChange > TrnList.LastUpdate Then TrnList.Update
				m = StrToLong(DlgText("LineNumBox"))
				If TrnList.StringCount < m Then m = TrnList.StringCount
				If m < 1 Then m = 1
				n = 0
				ReDim TempList(m - 1) As String
				For i = 1 To TrnList.StringCount
					If TrnList.String(i).Text <> "" Then
						If DlgValue("StrType") = 0 Then
							TempList(n) = TrnList.String(i).SourceText
						Else
							TempList(n) = TrnList.String(i).Text
						End If
						n = n + 1
						If n = m Then Exit For
					End If
				Next i
				ReDim Preserve TempList(IIf(n = 0,0,n - 1)) As String
				DlgText "InTextBox",Join$(TempList,vbCrLf)
				If DlgText("InTextBox") <> "" Then
					DlgText "ClearButton",MsgList(0)
					DlgEnable "TestButton",True
					DlgEnable "HeaderButton",True
				Else
					DlgText "ClearButton",MsgList(1)
   					DlgEnable "TestButton",False
					DlgEnable "HeaderButton",False
    			End If
			ElseIf DlgText("ClearButton") = MsgList(0) Then
				DlgText "InTextBox",""
				DlgText "OutTextBox",""
   				DlgText "ClearButton",MsgList(1)
   				DlgEnable "TestButton",False
				DlgEnable "HeaderButton",False
			End If
		Case "TestButton", "TranType", "HeaderButton"
			j = DlgValue("EngineListBox")
			If j < 0 Then Exit Function
			If getMsgList(UIDataList,MsgList,"TranTestFunc",1) = False Then Exit Function
			DlgText "OutTextBox",""
			DlgText "OutTextBox",MsgList(2)
			' Microsoft.XMLHTTP Ƿ
			TempList = ReSplit(EngineList(j).HttpName,IIf(InStr(EngineList(j).HttpName,";"),";",","))
			On Error Resume Next
			For i = 0 To UBound(TempList)
				TempList(i) = Trim(TempList(i))
				If TempList(i) <> "" Then
					Set xmlHttp = CreateObject(TempList(i))
					If Not xmlHttp Is Nothing Then Exit For
				End If
			Next i
			If xmlHttp Is Nothing Then
				Err.Source = Join(TempList,"; ")
				Call sysErrorMassage(Err,2)
				TranTestFunc = True 'ֹ°ťرնԻ򴰿
				Exit Function
			End If
			On Error GoTo 0
			'ȡбԴĿ
			Temp = DlgText("TrnListBox")
			Set TrnList = trn
			For i = 1 To trn.Project.TransLists.Count
				Set TrnList = trn.Project.TransLists(i)
				If Temp = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText) Then Exit For
			Next i
			'תΪֵ
			ReDim TempList(1) As String,SetList(UBound(tSelected)) As Integer
			SetList(1) = j
			For i = 3 To UBound(tSelected)
				SetList(i) = StrToLong(tSelected(i))
			Next i
			With LangPair
				'ȡԴ
				If DlgValue("StrType") = 0 Then
					.PslCode = PSL.GetLangCode(TrnList.SourceList.LangID,pslCode639_1)
				Else
					.PslCode = PSL.GetLangCode(TrnList.Language.LangID,pslCode639_1)
				End If
				If .PslCode = "zh" Or .PslCode = "ja" Or .PslCode = "ko" Then .Name = "Asia"
				If .PslCode = "" Or .PslCode = "zh" Then
					If DlgValue("StrType") = 0 Then
						.PslCode = PSL.GetLangCode(TrnList.SourceList.LangID,pslCodeLangRgn)
					Else
						.PslCode = PSL.GetLangCode(TrnList.Language.LangID,pslCodeLangRgn)
					End If
					Select Case .PslCode
					Case "zh-CHS","zh-SG"
						.PslCode = "zh-CN"
					Case "zh-CHT","zh-HK","zh-MO"
						.PslCode = "zh-TW"
					End Select
				Else
					.PslCode = .PslCode & LngJoinStr & PSL.GetLangCode(TrnList.SourceList.LangID,pslCodeLangRgn)
				End If
				'ȡĿ
				Temp = LCase$(DlgText("LngNameListBox"))
				For i = 0 To UBound(EngineList(j).LangPairList)
					If Temp = LCase$(EngineList(j).LangPairList(i).Name) Then
						.UseCode = EngineList(j).LangPairList(i).PslCode
						Exit For
					End If
				Next i
			End With
			'ȡõķ
			SetList(2) = -1
			If SetList(17) = 1 Then
				SetList(2) = getCheckID(CheckList,LangPair.UseCode,LangPair.Name)
			End If
			If SetList(2) = -1 Then
				For i = 0 To UBound(CheckList)
					If CheckList(i).Name = tSelected(2) Then
						SetList(2) = i
						Exit For
					End If
				Next i
			End If
			If SetList(2) = -1 Then SetList(2) = 0
			'ҷжӦԴ
			If getEngineLngPair(EngineList(j).LangPairList,LangPair) = False Then
				MsgBox MsgList(10),vbOkOnly+vbInformation,MsgList(9)
				Exit Function
			End If
			'ȡ鷽
			If SetList(19) = 1 Then
				TempList(0) = ProjectList(SetList(18)).Name
			Else
				TempList(0) = MsgList(5)
			End If
			If SetList(23) = 1 Then
				TempList(1) = ProjectList(SetList(22)).Name
			Else
				TempList(1) = MsgList(5)
			End If
			'ȡ TK űļ
			TKJScript = ReadTextFile(MacroLoc & "\Module\modGoogleJScript.js","windows-1252")
			'ʼϢ
			If DlgValue("TranType") = 1 Or DlgItem$ = "HeaderButton" Then
				DlgText "OutTextBox",Replace(Replace(MsgList(2) & vbCrLf & MsgList(3),"%s",LangPair.PslCode & " > " & LangPair.UseCode),"%d",CheckList(SetList(2)).Name)
			Else
				DlgText "OutTextBox",Replace(Replace(MsgList(2) & vbCrLf & MsgList(3),"%s",LangPair.PslCode & " > " & LangPair.UseCode),"%d",CheckList(SetList(2)).Name)
				DlgText "OutTextBox",DlgText("OutTextBox") & vbCrLf & Replace(Replace(MsgList(4),"%p",TempList(0)),"%n",TempList(1))
			End If
			'ȡִ
			Temp = DlgText("InTextBox")
			If DlgItem$ = "HeaderButton" Then
				Temp = getTranslate(xmlHttp,j,Temp,LangPair,2)
			Else
				'ݷͼ
				Dim EngineTest As ENGINE_SET,CheckTest As CHECK_SET
				EngineTest = EngineList(j)
				CheckTest = CheckList(SetList(2))
				'תеת
				EngineList(j) = ConvertResponseTypeSet(EngineList(j))
				'תеת
				CheckList(SetList(2)) = ConvertAndSortCheckSet(CheckList(SetList(2)))
				'üΪȫ
				ReDim TempList(0) As String
				TempList(0) = cSelected(14)
				cSelected(14) = "1"
				If SetList(20) = 1 Then Temp = ReplaceStr(SetList(2),Temp,0,0)
				If SetList(21) = 0 Then
					If SetList(19) = 1 Then Temp = CheckHanding(SetList(2),SetList(18),DlgText("InTextBox"),Temp)
					If InStr(Temp,"&") Then Temp = Replace(Temp,"&","")
					Temp = getTranslate(xmlHttp,j,Temp,LangPair,DlgValue("TranType"))
				Else
					Temp = SplitTran(xmlHttp,j,Temp,LangPair,SetList,DlgValue("TranType"))
				End If
				If Trim(Temp) <> "" And Temp <> DlgText("InTextBox") And DlgValue("TranType") = 0 Then
					If SetList(23) = 1 Then
						If ProjectList(SetList(22)).ApplyCheckResult = 1 Then
							Temp = CheckHanding(SetList(2),SetList(22),DlgText("InTextBox"),Temp)
						End If
					End If
					If SetList(24) = 1 Then Temp = ReplaceStr(SetList(2),Temp,2,0)
				End If
				'ԭͼ
				EngineList(j) = EngineTest
				CheckList(SetList(2)) = CheckTest
				'ԭ
				cSelected(14) = TempList(0)
			End If
			Set xmlHttp = Nothing
			'Ϣͷ
			If Trim(Temp) = "" Then
				DlgText "OutTextBox",DlgText("OutTextBox") & vbCrLf & MsgList(8) & vbCrLf & MsgList(6)
			ElseIf Trim(Replace(Temp,vbCrLf,"")) = "" Then
				DlgText "OutTextBox",DlgText("OutTextBox") & vbCrLf & MsgList(8) & vbCrLf & MsgList(7)
			ElseIf Temp <> DlgText("InTextBox") Then
				DlgText "OutTextBox",DlgText("OutTextBox") & vbCrLf & MsgList(8) & vbCrLf & Temp
			Else
				DlgText "OutTextBox",DlgText("OutTextBox") & vbCrLf & MsgList(8) & vbCrLf & MsgList(6)
			End If
		End Select
	Case 3 ' ıϿı
		If getMsgList(UIDataList,MsgList,"TranTestFunc",1) = False Then Exit Function
		Select Case DlgItem$
		Case "LineNumBox"
			Temp = DlgText("TrnListBox")
			Set TrnList = trn
			For i = 1 To trn.Project.TransLists.Count
				Set TrnList = trn.Project.TransLists(i)
				If Temp = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText) Then
					Exit For
				End If
			Next i
			m = StrToLong(DlgText("LineNumBox"))
			If TrnList.StringCount < m Then m = TrnList.StringCount
			If m < 1 Then m = 1
			n = 0
			ReDim TempList(m - 1) As String
			For i = 1 To TrnList.StringCount
				If TrnList.String(i).Text <> "" Then
					If DlgValue("StrType") = 0 Then
						TempList(n) = TrnList.String(i).SourceText
					Else
						TempList(n) = TrnList.String(i).Text
					End If
					n = n + 1
					If n = m Then Exit For
				End If
			Next i
			ReDim Preserve TempList(IIf(n = 0,0,n - 1)) As String
			DlgText "InTextBox",Join$(TempList,vbCrLf)
			If DlgText("InTextBox") <> "" Then
				DlgText "ClearButton",MsgList(0)
				DlgEnable "TestButton",True
				DlgEnable "HeaderButton",True
			Else
    			DlgText "ClearButton",MsgList(1)
    			DlgEnable "TestButton",False
    			DlgEnable "HeaderButton",False
    		End If
		Case "InTextBox"
			If DlgText("InTextBox") <> "" Then
				DlgText "ClearButton",MsgList(0)
				DlgEnable "TestButton",True
				DlgEnable "HeaderButton",True
			Else
    			DlgText "ClearButton",MsgList(1)
    			DlgEnable "TestButton",False
    			DlgEnable "HeaderButton",False
    		End If
    	End Select
	End Select
End Function


'Լ
Private Sub CheckTest(ByVal CheckID As Long,ByVal ProjectID As Long)
	Dim MsgList() As String,TempList() As String,TempArry() As String
	If getMsgList(UIDataList,MsgList,"CheckTest",1) = False Then Exit Sub
	TempList = getSetNameList(CheckList)
	TempArry = getSetNameList(ProjectList)
	Begin Dialog UserDialog 660,518,MsgList(0),.CheckTestFunc ' %GRID:10,7,1,1
		GroupBox 10,42,640,126,"",.GroupBox
		Text 10,7,640,28,MsgList(1),.MainText
		Text 30,59,90,14,MsgList(2),.SetNameText
		DropListBox 130,56,300,21,TempList(),.CheckListBox
		CheckBox 450,59,180,14,MsgList(16),.RepStrBox
		Text 30,80,90,14,MsgList(3),.ProjectText
		DropListBox 130,77,300,21,TempArry(),.ProjectListBox
		Text 30,101,90,14,MsgList(4),.TrnListText
		DropListBox 130,98,300,21,TempList(),.TrnListBox
		Text 450,87,120,14,MsgList(5),.LineNumText
		TextBox 580,84,50,18,.LineNumBox
		Text 30,122,90,14,MsgList(6),.SpecifyText
		TextBox 130,119,300,21,.SpecifyTextBox
		Text 450,117,180,24,MsgList(7),.TypeTipText
		Text 30,147,90,14,MsgList(8),.TypeText
		CheckBox 130,147,110,14,MsgList(9),.AllCheckBox
		CheckBox 250,147,120,14,MsgList(10),.AcckeyCheckBox
		CheckBox 380,147,120,14,MsgList(11),.EndSharCheckBox
		CheckBox 510,147,120,14,MsgList(12),.ShortCheckBox
		TextBox 10,182,640,294,.InTextBox,1
		PushButton 10,490,100,21,MsgList(15),.HelpButton
		PushButton 120,490,100,21,MsgList(13),.TestButton
		PushButton 230,490,100,21,MsgList(14),.ClearButton
		CancelButton 550,490,100,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	dlg.CheckListBox = CheckID
	dlg.ProjectListBox = ProjectID
	If Dialog(dlg) = 0 Then Exit Sub
End Sub


'ԶԻ
Private Function CheckTestFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,j As Long,MsgList() As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		If trn.Project.TransLists.Count > 0 Then
			ReDim MsgList(trn.Project.TransLists.Count - 1) As String
			For i = 1 To trn.Project.TransLists.Count
				MsgList(i - 1) = trn.Project.TransLists(i).Title & " - " & _
								PSL.GetLangCode(trn.Project.TransLists(i).Language.LangID,pslCodeText)
			Next i
			DlgListBoxArray "TrnListBox",MsgList()
		Else
			DlgEnable "TestButton",False
		End If
		DlgText "TrnListBox",trn.Title & " - " & PSL.GetLangCode(trn.Language.LangID,pslCodeText)
		DlgText "LineNumBox","10"
		DlgValue "AllCheckBox",1
    	DlgEnable "ClearButton",False
		'õǰԻ
		If CheckFont(LFList(0)) = True Then
			j = CreateFont(0,LFList(0))
			If j = 0 Then Exit Function
			For i = 0 To DlgCount() - 1
				SendMessageLNG(GetDlgItem(SuppValue,DlgControlId(DlgName(i))),WM_SETFONT,j,0)
			Next i
		End If
	Case 2 ' ֵĻ߰˰ť
		CheckTestFunc = True 'ֹ°ťرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			CheckTestFunc = False '°ťرնԻ򴰿
		Case "AllCheckBox"
			If DlgValue("AllCheckBox") = 1 Then
				DlgValue "AcckeyCheckBox",0
				DlgValue "EndSharCheckBox",0
				DlgValue "ShortCheckBox",0
			ElseIf DlgValue("AcckeyCheckBox") + DlgValue("EndSharCheckBox") + DlgValue("ShortCheckBox") = 0 Then
				DlgValue "AllCheckBox",1
			End If
		Case "AcckeyCheckBox", "EndSharCheckBox", "ShortCheckBox"
			If DlgValue("AcckeyCheckBox") = 1 Or DlgValue("EndSharCheckBox") = 1 Or DlgValue("ShortCheckBox") = 1 Then
				DlgValue "AllCheckBox",0
			Else
				DlgValue "AllCheckBox",1
			End If
		Case "TestButton"
			If getMsgList(UIDataList,MsgList,"CheckTest",1) = False Then Exit Function
			'ݷ
			i = DlgValue("CheckListBox")
			Dim CheckTest As CHECK_SET,ProjectTest As CHECK_PROJECT_SET
			CheckTest = CheckList(i)
			CheckList(i) = ConvertAndSortCheckSet(CheckList(i))
			'ִѡ
			j = DlgValue("ProjectListBox")
			ProjectTest = ProjectList(j)
			'üΪȫ
			ReDim TempList(0) As String
			TempList = cSelected
			cSelected(14) = DlgValue("AllCheckBox")
			cSelected(15) = DlgValue("AcckeyCheckBox")
			cSelected(16) = DlgValue("EndSharCheckBox")
			cSelected(17) = DlgValue("ShortCheckBox")
			DlgText "InTextBox",MsgList(17)
			DlgText "InTextBox",CheckTestStrings(i,j,DlgText("TrnListBox"), _
					StrToLong(DlgText("LineNumBox")),DlgValue("RepStrBox"),DlgText("SpecifyTextBox"))
			DlgEnable "ClearButton",IIf(DlgText("InTextBox") = "",False,True)
			'ԭ
			CheckList(i) = CheckTest
			ProjectList(j) = ProjectTest
			'üΪȫ
			cSelected = TempList
		Case "ClearButton"
			DlgText "InTextBox",""
			DlgEnable "ClearButton",False
		Case "HelpButton"
			Call Help("CheckTestHelp")
		End Select
	Case 3 ' ıϿı
		If DlgItem$ = "InTextBox" Then
			DlgEnable "ClearButton",IIf(DlgText("InTextBox") = "",False,True)
    	End If
	End Select
End Function


'ִбеִ
Private Function CheckTestStrings(ByVal CheckID As Long,ByVal ProjectID As Long,ByVal TrnListDec As String, _
					ByVal LineNum As Long,ByVal RepStr As Long,ByVal SpecifyText As String) As String
	Dim i As Long,j As Long,n As Long,srcString As String,trnString As String
	Dim MsgList() As String,TempList() As String,TempArray() As String
	Dim TrnList As PslTransList,Stemp As Boolean,Find As Boolean,Temp As String

	If getMsgList(UIDataList,MsgList,"CheckStrings",1) = False Then Exit Function

	'ȡѡķб
	Set TrnList = trn
	For i = 1 To trn.Project.TransLists.Count
		Set TrnList = trn.Project.TransLists(i)
		If TrnListDec = TrnList.Title & " - " & PSL.GetLangCode(TrnList.Language.LangID,pslCodeText) Then Exit For
	Next i

	If TrnList.SourceList.LastChange > TrnList.LastUpdate Then TrnList.Update
	If TrnList.StringCount < LineNum Then LineNum = TrnList.StringCount
	ReDim TempList(LineNum) As String
	For i = 1 To TrnList.StringCount
		'ȡԭĺͷִ
		If TrnList.String(i).Text <> "" Then
			srcString = TrnList.String(i).SourceText
			trnString = TrnList.String(i).Text

			'תת
			Stemp = False
			srcString = Convert(srcString)
			trnString = Convert(trnString)
			If trnString <> TrnList.String(i).Text Then Stemp = True
			Temp = trnString

			'ʼִ
			If SpecifyText <> "" Then
				TempArray = ReSplit(SpecifyText,";",-1)
				For j = 0 To UBound(TempArray)
					If Left(TempArray(j),1) <> "*" And Right(TempArray(j),1) <> "*" Then
						TempArray(j) = "*" & TempArray(j) & "*"
					End If
					If (trnString Like TempArray(j)) = True Then
						Find = True
						trnString = CheckHanding(CheckID,ProjectID,srcString,trnString)
						If trnString <> Temp Then Exit For
					End If
				Next j
			Else
				trnString = CheckHanding(CheckID,ProjectID,srcString,trnString)
			End If
			If RepStr = 1 Then trnString = ReplaceStr(CheckID,trnString,2,1)
			If Stemp = True Then trnString = ReConvert(trnString)

			'Ϣ
			If trnString <> "" And trnString <> TrnList.String(i).Text Then
				TempList(n) = MsgList(0) & TrnList.String(i).SourceText & vbCrLf & _
							MsgList(1) & TrnList.String(i).Text & vbCrLf & _
							MsgList(2) & trnString & vbCrLf & _
							MsgList(3) & CheckMassage(CheckID,ProjectID) & vbCrLf & _
							MsgList(4) & MsgList(4) & MsgList(4)
				n = n + 1
				If n = LineNum Then Exit For
			End If
		End If
	Next i
	If n > 0 Then
		CheckTestStrings = MsgList(5) & vbCrLf & MsgList(4) & MsgList(4) & MsgList(4) & vbCrLf & Join$(TempList,vbCrLf)
	Else
		If SpecifyText = "" Then
			CheckTestStrings = MsgList(6)
		ElseIf Find = True Then
			CheckTestStrings = MsgList(7)
		Else
			CheckTestStrings = MsgList(8)
		End If
	End If
End Function


'Ⲣ°汾
Private Function CheckUpdate(UpdateSet() As String,ByVal ShowMsg As Long) As Boolean
	Dim i As Long,j As Long,n As Long
	'ȡݲ°汾
	If CheckArray(UpdateSet) = True Then
		If UpdateSet(0) = "" Then UpdateSet(0) = "1"
		If UpdateSet(1) = "" Then UpdateSet(1) = updateMainUrl & vbCrLf & updateMinorUrl
		If UpdateSet(2) = "" Or (UpdateSet(2) <> "" And Dir$(UpdateSet(2)) = "") Then
			getCMDPath(".rar",UpdateSet(2),UpdateSet(3))
		End If
	Else
		UpdateSet = ReSplit("1" & JoinStr & updateMainUrl & vbCrLf & updateMinorUrl & JoinStr & _
					getCMDPath(".rar","","") & JoinStr & "7" & JoinStr,JoinStr)
	End If
	If UpdateSet(0) <> "" And UpdateSet(0) <> "2" Then
		If UpdateSet(5) <> "" Then
			i = CLng(DateDiff("d",CDate(UpdateSet(5)),Date))
			j = StrComp(Format(Date,"yyyy-MM-dd"),UpdateSet(5))
			If UpdateSet(4) <> "" Then n = i - CLng(UpdateSet(4))
		End If
		If UpdateSet(5) = "" Or (j = 1 And n >= 0) Then
			i = Download(UpdateSet,UpdateSet(1),StrToLong(UpdateSet(0)),ShowMsg)
			If i > 0 Then
				If UpdateSet(5) < Format(Date,"yyyy-MM-dd") Then
					UpdateSet(5) = Format(Date,"yyyy-MM-dd")
					WriteEngineSet(tWriteLoc,"Update")
				End If
				If i = 3 Then CheckUpdate = True
			End If
		End If
	End If
End Function


'Ⲣ°汾
'Mode: 0 = Զزװ, 1 = û, 2 = ر, 3 = ֶ 4 = , 5 = 
'ֵ = 0 ʧ, 1 = Ϣɹ, 2 = ļɹ, 3 = ³ɹ
Private Function Download(UpdateSet() As String,ByVal Url As String,ByVal Mode As Long,ByVal ShowMsg As Long) As Long
	Dim i As Long,j As Long,m As Long,n As Long
	Dim xmlHttp As Object,Body() As Byte,BodyBak() As Byte
	Dim UrlList() As String,TempList() As String,TempArray() As String,MsgList() As String
	Dim ExePath As String,Argument As String,Temp As String,UpdateData As INIFILE_DATA
	Dim WebVersion As String,WebBuild As String,IniBuild As String,TempPath As String

	If Mode = 2 Then Exit Function
	If getMsgList(UIDataList,MsgList,"Download",1) = False Then Exit Function

	'ȡѹͲ
	If CheckArray(UpdateSet) = True Then
		If Url = "" Then Url = UpdateSet(1)
		ExePath = Trim$(UpdateSet(2))
		Argument = UpdateSet(3)
	End If

	'ѹͲ
	If Mode < 5 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,IIf(Mode = 4,MsgList(22),MsgList(23))
		ElseIf ShowMsg < 0 Then
			PSL.OutputWnd.Clear
			PSL.Output IIf(Mode = 4,MsgList(22),MsgList(23))
		End If
	End If
	If ExePath = "" Then
		If Mode < 5 Then
			MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(3),vbOkOnly+vbInformation,MsgList(0))
		End If
		Exit Function
	End If
	If Url = "" Or Argument = "" Then
		i = 1
	ElseIf InStr(Argument,"%1") = 0 Then
		i = 1
	'ElseIf InStr(Argument,"%2") = 0 Then
	'	i = 1
	ElseIf InStr(Argument,"%3") = 0 Then
		i = 1
	End If
	If i = 1 Then
		If Mode < 5 Then
			MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(4),vbOkOnly+vbInformation,MsgList(0))
		End If
		Exit Function
	End If

	'طǷ
	On Error Resume Next
	TempList = ReSplit(DefaultObject,";")
	For i = 0 To UBound(TempList)
		Set xmlHttp = CreateObject(TempList(i))
		If Not xmlHttp Is Nothing Then Exit For
	Next i
	If xmlHttp Is Nothing Then
		If Mode < 5 Then
			Err.Source = StrListJoin(TempList,"; ")
			Call sysErrorMassage(Err,2)
		End If
		Exit Function
	End If
	On Error GoTo 0

	'ȡϢ
	j = 0
	If Mode <> 4 Then
		'ϲļĬϺԶַ
		UrlList = ReSplit(Url,vbCrLf)
		For i = 0 To UBound(UrlList)
			Temp = Trim$(UrlList(i))
			n = InStrRev(Temp,"/")
			If n > 0 Then
				UrlList(i) = Left$(Temp,n) & updateINIFile
			End If
		Next i
		UrlList = ReSplit(updateINIMainUrl & vbCrLf & updateINIMinorUrl & vbCrLf & StrListJoin(UrlList,vbCrLf),vbCrLf)

		'زļ
		For i = 0 To UBound(UrlList)
			'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
			Select Case DownloadFile(Body,xmlHttp,UrlList(i))
			Case 1
				Temp = BytesToBstr(Body,"utf-8")
				If Temp <> "" Then
					If InStr(LCase$(Temp),LCase$(AppName)) Then
						'ļ
						IniBuild = CheckUpdateINIFile(UpdateData,Temp)
						If IniBuild <> "" Then Exit For
					End If
				End If
			Case -2
				Set xmlHttp = Nothing
				If Mode < 5 Then MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
				Exit Function
			End Select
		Next i

		'ʾϢ
		If UpdateData.Title <> "" Then
			Download = 1
			Select Case StrComp(UpdateData.Title,Version) + StrComp(IniBuild,Build)
			Case Is > 0
				If Mode = 1 Or Mode = 3 Then
					Temp = Replace$(Replace$(MsgList(15),"%s",UpdateData.Title),"%d",IniBuild) & vbCrLf & vbCrLf & MsgList(20)
					If MsgBox(Temp & vbCrLf & StrListJoin(UpdateData.Value,vbCrLf),vbYesNo+vbInformation,MsgList(17)) = vbNo Then
						Set xmlHttp = Nothing
						Exit Function
					End If
				End If
			Case 0
				If Mode = 3 Then
					Temp = Replace$(Replace$(MsgList(14),"%s",UpdateData.Title),"%d",IniBuild) & vbCrLf & MsgList(21)
					If MsgBox(Temp,vbYesNo+vbInformation,MsgList(17)) = vbNo Then
						Set xmlHttp = Nothing
						Exit Function
					End If
				Else
					Set xmlHttp = Nothing
					Exit Function
				End If
			Case Is < 0
				If Mode = 3 Then
					MsgBox Replace$(Replace$(MsgList(14),"%s",UpdateData.Title),"%d",IniBuild),vbOkOnly+vbInformation,MsgList(16)
				End If
				Set xmlHttp = Nothing
				Exit Function
			End Select
		End If
	End If

	'سļ
	If Mode < 4 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(24),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(24)
		End If
	End If
	m = 0: n = 0: j = 0
	If UpdateData.Title <> "" Then
		UrlList = ClearTextArray(ReSplit(Url & vbCrLf & StrListJoin(UpdateData.Item,vbCrLf),vbCrLf),True)
	Else
		UrlList = ReSplit(Url,vbCrLf)
	End If
	For i = 0 To UBound(UrlList)
		If UrlList(i) <> "" Then
			'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
			Select Case DownloadFile(Body,xmlHttp,UrlList(i))
			Case 1
				If Mode <> 4 Then Exit For
				If LenB(BodyBak) = 0 Then BodyBak = Body
			Case 0
				If Mode = 4 Then
					ReDim Preserve TempList(m) As String
					TempList(m) = UrlList(i)
				End If
				m = m + 1
			Case -1
				If Mode = 4 Then
					ReDim Preserve TempArray(n) As String
					TempArray(n) = UrlList(i)
				End If
				n = n + 1
			Case -2
				If Mode < 5 Then MsgBox(MsgList(35),vbOkOnly+vbInformation,MsgList(0))
				Set xmlHttp = Nothing
				Exit Function
			End Select
			j = j + 1
		End If
	Next i
	If m + n <> 0 Then
		If Mode <> 4 Then
			If m = j Or n = j Then
				If Mode < 5 Then MsgBox(MsgList(1) & vbCrLf & IIf(n = j,MsgList(5),MsgList(6)),vbOkOnly+vbInformation,MsgList(0))
				Set xmlHttp = Nothing
				Exit Function
			End If
		Else
			If m <> 0 And n <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(33) & vbCrLf & StrListJoin(TempArray,vbCrLf) & _
						vbCrLf & vbCrLf & MsgList(34) & vbCrLf & StrListJoin(TempList,vbCrLf)
			ElseIf m <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(34) & vbCrLf & StrListJoin(TempList,vbCrLf)
			ElseIf n <> 0 Then
				Temp = MsgList(2) & vbCrLf & MsgList(33) & vbCrLf & StrListJoin(TempArray,vbCrLf)
			End If
			MsgBox(Temp,vbOkOnly+vbInformation,MsgList(12))
			Set xmlHttp = Nothing
			Exit Function
		End If
	End If
	Set xmlHttp = Nothing

	'صĳļ
	If Mode = 4 Then Body = BodyBak
	TempPath = MacroLoc & "\temp\"
	Temp = TempPath & "temp.rar"
	On Error Resume Next
	If Dir$(TempPath & "*.*") = "" Then MkDir TempPath
	If BytesToFile(Body,Temp) = False Then
		i = FreeFile
		Open Temp For Binary Access Write As #i
		Put #i,,Body
		Close #i
	End If
	On Error GoTo 0

	'ѹļ
	i = 0
	If Dir$(Temp) <> "" Then
		i = ExtractFile(Temp,TempPath,ExePath,Argument)
		If i = 1 Then
			Temp = TempPath & updateMainFile
		ElseIf Mode < 5 Then
			If i = -2 Then
				Temp = Mid$(Left$(ExePath,InStrRev(ExePath,".") - 1),InStrRev(ExePath,"\") + 1)
				Temp = Replace$(MsgList(8),"%s",Temp) & vbCrLf & _
						Replace$(MsgList(9),"%s",ExePath) & vbCrLf & _
						Replace$(MsgList(10),"%s",Argument) & vbCrLf & vbCrLf & MsgList(11)
				MsgBox(Temp,vbOkOnly+vbInformation,MsgList(0))
			ElseIf i = -3 Then
				MsgBox(IIf(Mode <> 4,MsgList(1),MsgList(2)) & vbCrLf & MsgList(7),vbOkOnly+vbInformation,MsgList(0))
			End If
		End If
	End If
	If i <> 1 Then
		DelDirs(TempPath)
		Exit Function
	End If

	'ȡصĳ汾
	If Mode < 4 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(26),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(26)
		End If
	End If
	WebVersion = GetWebVersion(Temp,"Const Version = ")
	WebBuild = GetWebVersion(Temp,"Const Build = ")
	If WebVersion = "" Or WebBuild = "" Then
		If Mode < 5 Then MsgBox(MsgList(19),vbOkOnly+vbInformation,MsgList(0))
		DelDirs(TempPath)
		Exit Function
	End If

	'Ƚϰ汾ʾϢ
	If Url <> StrListJoin(UrlList,vbCrLf) Then UpdateSet(1) = StrListJoin(UrlList,vbCrLf)
	If Mode = 4 Then
		MsgBox(MsgList(13) & vbCrLf & Replace$(Replace$(MsgList(14),"%s",WebVersion),"%d",WebBuild),vbOkOnly+vbInformation,MsgList(12))
		Download = 2
		DelDirs(TempPath)
		Exit Function
	End If
	n = StrComp(WebVersion,Version) + StrComp(WebBuild,Build)
	If Mode < 5 Then
		If n > 0 Or (n = 0 And Mode = 3) Then
			If UpdateData.Title = "" Then
				If Mode = 1 Then
					Temp = Replace$(Replace$(MsgList(15),"%s",WebVersion),"%d",WebBuild)
				ElseIf Mode = 3 Then
					If n = 0 Then
						Temp = Replace$(Replace$(MsgList(14),"%s",WebVersion),"%d",WebBuild) & vbCrLf & MsgList(21)
					Else
						Temp = Replace$(Replace$(MsgList(15),"%s",WebVersion),"%d",WebBuild)
					End If
				End If
				If MsgBox(Temp,vbYesNo+vbInformation,MsgList(17)) = vbNo Then
					DelDirs(TempPath)
					Exit Function
				End If
			ElseIf UpdateData.Title <> WebVersion Or IniBuild <> WebBuild Then
				Temp = MsgList(1) & vbCrLf & Replace$(Replace$(MsgList(29),"%s",WebVersion),"%d",WebBuild) & vbCrLf & MsgList(32)
				MsgBox(Temp,vbOkOnly+vbInformation,MsgList(0))
				DelDirs(TempPath)
				Exit Function
			End If
		Else
			If Mode < 2 Then
				If ShowMsg > 0 Then
					SetTextBoxString ShowMsg,Replace$(Replace$(MsgList(30),"%s",WebVersion),"%d",WebBuild),True
				ElseIf ShowMsg < 0 Then
					PSL.Output Replace$(Replace$(MsgList(30),"%s",WebVersion),"%d",WebBuild)
				End If
			Else
				MsgBox Replace$(Replace$(MsgList(31),"%s",WebVersion),"%d",WebBuild),vbOkOnly+vbInformation,MsgList(16)
			End If
			DelDirs(TempPath)
			Exit Function
		End If
	ElseIf n < 1 Then
		DelDirs(TempPath)
		Exit Function
	End If

	'װ°汾
	If Mode < 5 Then
		If ShowMsg > 0 Then
			SetTextBoxString ShowMsg,MsgList(27),True
		ElseIf ShowMsg < 0 Then
			PSL.Output MsgList(27)
		End If
		If SetupNewVersion(TempPath,MacroLoc) = True Then
			If ShowMsg > 0 Then
				SetTextBoxString ShowMsg,MsgList(28),True
			ElseIf ShowMsg < 0 Then
				PSL.Output MsgList(28)
			End If
			MsgBox(MsgList(18),vbOkOnly+vbInformation,MsgList(17))
			Download = 3
		End If
	ElseIf SetupNewVersion(TempPath,MacroLoc) = True Then
		Download = 3
	End If
	DelDirs(TempPath)
End Function


'עлȡ RAR չĬϳ
Private Function getCMDPath(ByVal ExtName As String,CmdPath As String,Argument As String) As String
	Dim i As Long,WshShell As Object,TempArray() As String
	On Error Resume Next
	Set WshShell = CreateObject("WScript.Shell")
	If WshShell Is Nothing Then
		getCMDPath = CmdPath & JoinStr & Argument
		Err.Source = "WScript.Shell"
		Call sysErrorMassage(Err,2)
		Exit Function
	End If
	ExtName = WshShell.RegRead("HKCR\" & ExtName & "\")
	If ExtName <> "" Then
		CmdPath = WshShell.RegRead("HKCR\" & ExtName & "\shell\open\command\")
	End If
	On Error GoTo 0
	Set WshShell = Nothing
	If CmdPath <> "" Then
		i = InStr(CmdPath,".")
		If i > 0 Then Argument = Trim$(Mid$(CmdPath,InStr(i,CmdPath," ")))
		CmdPath = Left$(CmdPath,Len(CmdPath) - Len(Argument))
		TempArray = ReSplit(CmdPath,"%")
		If UBound(TempArray) = 2 Then
			CmdPath = Replace$(CmdPath,"%" & TempArray(1) & "%",Environ(TempArray(1)),,1)
		End If
		CmdPath = RemoveBackslash(CmdPath,"""","""",1)

		If InStr(CmdPath,"\") = 0 Then
			If Dir$(Environ("SystemRoot") & "\system32\" & CmdPath) <> "" Then
				CmdPath = Environ("SystemRoot") & "\system32\" & CmdPath
			ElseIf Dir$(Environ("SystemRoot") & "\" & CmdPath) <> "" Then
				CmdPath = Environ("SystemRoot") & "\" & CmdPath
			End If
		End If

		If InStr(LCase$(CmdPath),"winrar.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -ibck " & Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -ibck " & Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = "e -ibck ""%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = "e -ibck ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"winzip.exe") Then
			CmdPath = strReplace(CmdPath,"WinZip.exe","WzunZip.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = """%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = " ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"wzunzip.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = Replace$(Argument,"""%1""","""%1"" %2 ""%3""")
				ElseIf InStr(Argument,"%1") Then
					Argument = Replace$(Argument,"%1","""%1"" %2 ""%3""")
				Else
					Argument = """%1"" %2 ""%3"" " & Argument
				End If
			Else
				Argument = " ""%1"" %2 ""%3"""
			End If
		ElseIf InStr(LCase$(CmdPath),"7z.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -r " & Replace$(Argument,"""%1""","""%1"" -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -r " & Replace$(Argument,"%1","""%1"" -o""%3"" %2")
				Else
					Argument = "e -r ""%1"" -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e -r ""%1"" -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"7zfm.exe") Then
			CmdPath = strReplace(CmdPath,"7zFM.exe","7z.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e -r " & Replace$(Argument,"""%1""","""%1"" -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e -r " & Replace$(Argument,"%1","""%1"" -o""%3"" %2")
				Else
					Argument = "e -r ""%1"" -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e -r ""%1"" -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"haozip.exe") Then
			CmdPath = strReplace(CmdPath,"HaoZip.exe","HaoZipC.exe")
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e " & Replace$(Argument,"""%1""","""%1"" -r -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e " & Replace$(Argument,"%1","""%1"" -r -o""%3"" %2")
				Else
					Argument = "e ""%1"" -r -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e ""%1"" -r -o""%3"" %2"
			End If
		ElseIf InStr(LCase$(CmdPath),"haozipc.exe") Then
			If Argument <> "" Then
				If InStr(Argument,"""%1""") Then
					Argument = "e " & Replace$(Argument,"""%1""","""%1"" -r -o""%3"" %2")
				ElseIf InStr(Argument,"%1") Then
					Argument = "e " & Replace$(Argument,"%1","""%1"" -r -o""%3"" %2")
				Else
					Argument = "e ""%1"" -r -o""%3"" %2 " & Argument
				End If
			Else
				Argument = "e ""%1"" -r -o""%3"" %2"
			End If
		End If
	End If
	getCMDPath = CmdPath & JoinStr & Argument
End Function


'ļ
'ֵ1 = ɹ0 = ʧܣ-1 = ļڣ-2 = 
Private Function DownloadFile(Body() As Byte,xmlHttp As Object,ByVal Url As String) As Long
	Dim FileSize As Long
	ReDim Body(0) As Byte
	If Trim$(Url) = "" Then Exit Function
	On Error GoTo ExitFunction
	xmlHttp.Open "HEAD",Url,False,"",""
	xmlHttp.send()
	If OnReadyStateChange(xmlHttp,4,DefaultWaitTimes) = 4 Then
		'FileSize = CLng(ReSplit(xmlHttp.getResponseHeader("Content-Range"),"/")(1))
		FileSize = CLng(xmlHttp.getResponseHeader("Content-Length"))
	End If
	xmlHttp.abort
	If FileSize > 0 Then
		xmlHttp.Open "GET",Url,False,"",""
		xmlHttp.setRequestHeader "Referer", Left$(Url, InStr(InStr(Url, "//") + 2, Url, "/") - 1)
		xmlHttp.setRequestHeader "Accept", "*/*"
		'xmlHttp.setRequestHeader "Range", "bytes = " & FileSize
		xmlHttp.setRequestHeader "Content-Type", "application/octet-stream"
		xmlHttp.setRequestHeader "If-Modified-Since", "0"
		xmlHttp.setRequestHeader "Pragma", "no-cache"
		xmlHttp.setRequestHeader "Cache-Control", "no-cache"
		xmlHttp.send()
		If OnReadyStateChange(xmlHttp,4,DefaultWaitTimes) = 4 Then
			If xmlHttp.status = 200 Then
				Body = xmlHttp.responseBody
				If LenB(Body) = FileSize Then DownloadFile = 1
			End If
		End If
	Else
		DownloadFile = -1
	End If
	On Error GoTo 0
	ExitFunction:
	xmlHttp.abort
	If Err.Number <> 0 Then DownloadFile = -2
End Function


'ļ
Private Function CheckUpdateINIFile(Data As INIFILE_DATA,ByVal UpdateINIText As String) As String
	Dim i As Long,j As Long,m As Long,n As Long
	Dim DefaultLng As String,LangName As String,DataList() As INIFILE_DATA

	If Trim$(UpdateINIText) = "" Then Exit Function
	If getINIFile(DataList,"",UpdateINIText,2) = False Then Exit Function
	For i = 0 To UBound(DataList)
		With DataList(i)
			Select Case .Title
			Case "Option"
				For j = 0 To UBound(.Item)
					If .Item(j) = "DefaultLanguage" Then
						DefaultLng = LCase$(Trim$(.Value(j)))
						Exit For
					End If
				Next j
			Case "Language"
				UpdateINIText = LCase$(OSLanguage)
				For j = 0 To UBound(.Item)
					If InStr(LCase$(.Value(j)),UpdateINIText) Then
						LangName = LCase$(.Item(j))
						Exit For
					End If
				Next j
				If LangName = "" Then LangName = DefaultLng
			Case AppName
				For j = 0 To UBound(.Item)
					UpdateINIText = LCase$(.Item(j))
					If UpdateINIText = "version" Then
						Data.Title = Trim$(.Value(j))
					ElseIf UpdateINIText = "build" Then
						CheckUpdateINIFile = Trim$(.Value(j))
					ElseIf InStr(UpdateINIText,"url_") Then
						ReDim Preserve Data.Item(m) 'As String
						Data.Item(m) = Trim$(.Value(j))
						m = m + 1
					ElseIf InStr(UpdateINIText,"des_" & LangName) Then
						ReDim Preserve Data.Value(n) 'As String
						Data.Value(n) = Trim$(.Value(j))
						n = n + 1
					End If
				Next j
				Exit For
			End Select
		End With
	Next i
	If m = 0 Or n = 0 Then
		CheckUpdateINIFile = ""
		Data.Title = ""
		ReDim Data.Item(0) 'As String,
		ReDim Data.Value(0) 'As String
	Else
		If CheckUpdateINIFile = "" Then CheckUpdateINIFile = Build
		ReDim Preserve Data.Item(m - 1) 'As String
		ReDim Preserve Data.Value(n - 1) 'As String
	End If
End Function


'ѹļ
'ֵ 1 = ɹ0 = ҪѹļڻСΪ㣬-1 = Ҳ-2 = ѹҲ-3 = ѹ
Private Function ExtractFile(ByVal File As String,ByVal Path As String,ByVal ExePath As String,ByVal Argument As String) As Long
	Dim WshShell As Object,TempList() As String

	On Error Resume Next
	Set WshShell = CreateObject("WScript.Shell")
	If WshShell Is Nothing Then
		Err.Source = "WScript.Shell"
		Call sysErrorMassage(Err,2)
		Exit Function
	End If
	On Error GoTo 0

	If Dir$(File) = "" Then Exit Function
	If FileLen(File) = 0 Then Exit Function
	If ExePath <> "" Then
		TempList = ReSplit(ExePath,"%",-1)
		If UBound(TempList) >= 2 Then
			ExePath = Replace$(ExePath,"%" & TempList(1) & "%",Environ(TempList(1)),,1)
		End If
		ExePath = RemoveBackslash(ExePath,"""","""",1)
	End If
	If Argument <> "" Then
		If InStr(Argument,"""%1""") Then Argument = Replace$(Argument,"%1",File)
		If InStr(Argument,"""%2""") Then Argument = Replace$(Argument,"%2","*")
		If InStr(Argument,"""%3""") Then Argument = Replace$(Argument,"%3",Path)
		If InStr(Argument,"%1") Then Argument = Replace$(Argument,"%1","""" & File & """")
		If InStr(Argument,"%2") Then Argument = Replace$(Argument,"%2","*")
		If InStr(Argument,"%3") Then Argument = Replace$(Argument,"%3","""" & Path & """")
	End If
	If ExePath <> "" Then
		If Dir$(ExePath) <> "" Then
			If WshShell.Run("""" & ExePath & """ " & Argument,0,True) = 0 Then
				ExtractFile = IIf(Dir$(Path & updateMainFile) <> "",1,-1)
			Else
				ExtractFile = -3
			End If
		Else
			ExtractFile = -2
		End If
	Else
		ExtractFile = -2
	End If
	Set WshShell = Nothing
End Function


'ȡصĳ汾
Private Function GetWebVersion(ByVal File As String,ByVal CheckStr As String) As String
	Dim n As Long,Temp As String,FN As Long
	On Error GoTo ExitFunction
	FN = FreeFile
	Open File For Input As #FN
	Do While Not EOF(FN)
		Line Input #FN,Temp
		n = InStr(Temp,CheckStr)
		If n > 0 Then
			GetWebVersion = Mid$(Temp,n + Len(CheckStr) + 1)
			GetWebVersion = Left$(GetWebVersion,Len(GetWebVersion) - 1)
			Exit Do
		End If
	Loop
	ExitFunction:
	On Error Resume Next
	Close #FN
End Function


'װ°汾
Private Function SetupNewVersion(ByVal FromPath As String,ByVal TargetDir As String) As Boolean
	Dim i As Long
	On Error GoTo ExitFunction
	If Right$(FromPath,1) <> "\" Then FromPath = FromPath & "\"

	'ǷӦĿ¼
	If Dir$(FromPath & "*.lng") <> "" Or Dir$(FromPath & "*.ini") <> "" Or Dir$(FromPath & "*.dat") <> "" Then
		If Dir$(TargetDir & "\Data\" & "*.*") = "" Then MkDir TargetDir & "\Data\"
	End If
	If Dir$(FromPath & "*.txt") <> "" Or Dir$(FromPath & "*.doc") <> "" Or Dir$(FromPath & "*.pdf") <> "" Then
		If Dir$(TargetDir & "\Doc\" & "*.*") = "" Then MkDir TargetDir & "\Doc\"
	End If
	If Dir$(FromPath & "mod*.bas") <> "" Or Dir$(FromPath & "*.cls") <> "" Then
		If Dir$(TargetDir & "\Module\" & "*.*") = "" Then MkDir TargetDir & "\Module\"
	End If
	If Dir$(FromPath & "*.chm") <> "" Or Dir$(FromPath & "*.hlp") <> "" Then
		If Dir$(TargetDir & "\Help\" & "*.*") = "" Then MkDir TargetDir & "\Help\"
	End If

	'ȡǰļУļУе°汾ļб
	ReDim FileList(0) As FILE_LIST
	If CheckArray(GetFiles(FileList,FromPath,"","*.*")) = False Then
		If CheckArray(getSubFiles(FileList,FromPath,"","*.*")) = False Then Exit Function
		SetupNewVersion = True
	End If
	Do
		'ƵǰļĿļ
		For i = 0 To UBound(FileList)
			Select Case LCase$(Mid$(FileList(i).sName,InStrRev(FileList(i).sName,".") + 1))
			Case "bas"
				If FileList(i).sName Like "mod*.bas" = False Then
					FileCopy FileList(i).FilePath,TargetDir & "\" & FileList(i).sName
				Else
					FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
				End If
			Case "lng", "dat"
				FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
			Case "obm", "cls"
				FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
			Case "txt","doc","pdf"
				FileCopy FileList(i).FilePath,TargetDir & "\Doc\" & FileList(i).sName
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					Kill TargetDir & "\Data\" & FileList(i).sName
				End If
			Case "ini"
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					If FileDateTime(FileList(i).FilePath) > FileDateTime(TargetDir & "\Data\" & FileList(i).sName) Then
						FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
					End If
				Else
					FileCopy FileList(i).FilePath,TargetDir & "\Data\" & FileList(i).sName
				End If
			Case "chm", "hlp"
				FileCopy FileList(i).FilePath,TargetDir & "\Help\" & FileList(i).sName
				If Dir$(TargetDir & "\Data\" & FileList(i).sName) <> "" Then
					Kill TargetDir & "\Data\" & FileList(i).sName
				End If
			Case Is <> "rar"
				FileCopy FileList(i).FilePath,TargetDir & "\Module\" & FileList(i).sName
			End Select
		Next i
		If SetupNewVersion = True Then Exit Do
		SetupNewVersion = True
		'ȡļе°汾ļб
		ReDim FileList(0) As FILE_LIST
		If CheckArray(getSubFiles(FileList,FromPath,"","*.*")) = False Then Exit Do
	Loop
	SetupNewVersion = True
	ExitFunction:
End Function


'ȡǰļеļб
'Mode = True Ƿ DefaultFile ΪΪ׸ļ
Private Function GetFiles(List() As FILE_LIST,ByVal DirPath As String,Optional ByVal DefaultFile As String, _
		Optional ByVal FindFile As String,Optional ByVal Mode As Boolean) As String()
	Dim n As Long,m As Long,FileList() As String,File As String,TempList() As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Or (DefaultFile = "" And FindFile = "") Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		GetFiles = FileList
		Exit Function
	End If
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	If DefaultFile <> "" Then
		DefaultFile = Mid$(DefaultFile,InStrRev(DefaultFile,"\") + 1)
	End If
	m = 20
	ReDim List(m) As FILE_LIST,FileList(m) As String
	If Mode = True Then
		List(0).sName = DefaultFile
		List(0).FilePath = DirPath & DefaultFile
		FileList(0) = DefaultFile
		n = 1
	End If
	DefaultFile = LCase$(DefaultFile): FindFile = LCase$(FindFile)
	File = Dir$(DirPath & "*.*")
	Do While File <> ""
		If n > m Then
			m = m * 2
			ReDim Preserve List(m) As FILE_LIST,FileList(m) As String
		End If
		If DefaultFile <> "" Then
			If LCase$(File) Like DefaultFile Then
				If Mode = True Then GoTo NextNum
				List(n).sName = File
				List(n).FilePath = DirPath & File
				FileList(n) = File
				n = n + 1
				GoTo NextNum
			End If
		End If
		If FindFile <> "" Then
			If LCase$(File) Like FindFile Then
				List(n).sName = File
				List(n).FilePath = DirPath & File
				FileList(n) = File
				n = n + 1
				GoTo NextNum
			End If
		End If
		NextNum:
		File = Dir$()
	Loop
	If n > 0 Then n = n - 1
	ReDim Preserve List(n) As FILE_LIST,FileList(n) As String
	GetFiles = FileList
End Function


'ȡǰļеļеļб
'FindFile = "" ʱ .sName = ļĿ¼ .sName = Ŀ¼еļ
Private Function getSubFiles(List() As FILE_LIST,ByVal DirPath As String,Optional ByVal DefaultFile As String,Optional ByVal FindFile As String) As String()
	Dim i As Long,j As Long,n As Long,m As Long
	Dim File As String,PathList() As String,FileList() As String,TempList() As String
	DirPath = Trim$(DirPath)
	If DirPath = "" Or (DefaultFile = "" And FindFile = "") Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		getSubFiles = FileList
		Exit Function
	End If
	If Right$(DirPath,1) <> "\" Then DirPath = DirPath & "\"
	If Dir$(DirPath & "*.*",vbDirectory) = "" Then
		ReDim List(0) As FILE_LIST,FileList(0) As String
		Exit Function
	End If
	If DefaultFile <> "" Then
		DefaultFile = LCase$(Mid$(DefaultFile,InStrRev(DefaultFile,"\") + 1))
	End If
	If FindFile <> "" Then FindFile = LCase$(FindFile)
	ReDim PathList(0) As String
	PathList(0) = DirPath
	m = 20
	ReDim List(m) As FILE_LIST,FileList(m) As String
	Do
		DirPath = PathList(i)
		File = Dir$(DirPath & "*.*",vbDirectory)
		While File <> ""
			If File <> "." And File <> ".." Then
				If GetAttr(DirPath & File) And vbDirectory Then
					j = j + 1
					ReDim Preserve PathList(j) As String
					PathList(j) = DirPath & File & "\"
				ElseIf DirPath <> PathList(0) Then
					If n > m Then
						m = m * 2
						ReDim Preserve List(m) As FILE_LIST,FileList(m) As String
					End If
					If DefaultFile <> "" Then
						If LCase$(File) Like DefaultFile Then
							If FindFile = "" Then
								TempList = ReSplit(DirPath,"\")
								List(n).sName = TempList(UBound(TempList) - 1)
							Else
								List(n).sName = File
							End If
							List(n).FilePath = DirPath & File
							FileList(n) = List(n).sName
							n = n + 1
							GoTo NextNum
						End If
					End If
					If FindFile <> "" Then
						If LCase$(File) Like FindFile Then
							List(n).sName = File
							List(n).FilePath = DirPath & File
							FileList(n) = List(n).sName
							n = n + 1
							GoTo NextNum
						End If
					End If
				End If
				NextNum:
			End If
			File = Dir$()
		Wend
		i = i + 1
	Loop Until i = j + 1
	If n > 0 Then n = n - 1
	ReDim Preserve List(n) As FILE_LIST,FileList(n) As String
	getSubFiles = FileList
End Function
